Mon Aug 17 21:26:38 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>

	* config/sparc/sparc.md (sltu, sgeu): Don't FAIL, call
	gen_compare_reg.
	(movsf_const_intreg, movsf_const_high, movsf_const_lo,
	movdf_const_intreg and helper splits): New patterns to move float
	constants into integer registers.
	(negtf2, negdf2, abstf2, absdf2): Rework using new patterns and
	splits.

Mon Aug 17 11:46:19 1998  Jeffrey A Law  (law@cygnus.com)

	* From Graham
	* tree.c (build_index_type): Copy TYPE_SIZE_UNIT from sizetype
	to itype.
	* c-decl.c (finish_enum): Copy TYPE_SIZ_UNIT from enumtype to tem.

	* rs6000.c (secondary_reload_class): For TARGET_ELF, indicate that
	a BASE_REGS register is needed as an intermediate when copying
	a symbolic value into any register class other than BASE_REGS.

	* expr.c (move_by_pieces): No longer static.  Remove prototype.
	* rtl.h (move_by_pieces): Add extern prototype.
	* mips.c (expand_block_move): Handle aligned straight line copy by
	calling move_by_pieces.

	* expr.c (expand_expr): Allow assignments from TImode PARM_DECLs
	and VAR_DECLs.

Mon Aug 17 10:28:52 1998  Mark Mitchell  <mark@markmitchell.com>

	* stmt.c (expand_end_loop): Tidy.  Allow unconditional
	jumps out of the loop to be treated as part of the exit test.

Mon Aug 17 10:06:11 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>
			  Jeff Law <law@cygnus.com>

	* Makefile.in (cplus-dep.o): Use cplus-dem.c from libiberty.
	* cplus-dem.c: Delete.

	* Makefile.in (fold-const.o): depend on $(RTL_H).

	* fold-const.c: Include rtl.h to get the prototype for
 	`set_identifier_local_value'.

	* loop.c (express_from_1): Remove unused variable `tmp'.
	(combine_givs): cast the first argument of bzero to char *.

	* toplev.c (display_help): Remove unused variable `looking_for_start'.

	* c-decl.c (init_decl_processing): Remove unneeded &.

	* alpha.h (alpha_initialize_trampoline): Provide prototype.
	
	* except.c (set_exception_lang_code, set_exception_version_code):
	Change parameter from `short' to `int' to avoid using a gcc
	extension.

	* except.h (set_exception_lang_code, set_exception_version_code):
	Likewise for prototypes.

	* flow.c (count_reg_references): Remove unused variables `regno'
	and `i'.

	* gcse.c (hash_scan_insn): Declare parameter `in_libcall_block'.

	* prefix.c (translate_name): Cast the result of `alloca'.

	* varray.h (VARRAY_FREE): Reimplement as a `do-while(0)' statement.

Mon Aug 17 09:23:42 1998  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* config/m68k/m68k.c: Include "system.h" instead of <stdio.h>.
	Include "toplev.h".
	(valid_dbcc_comparison_p): Mark mode argument as unused.
	(symbolic_operand): Likewise.
	(legitimize_pic_address): Likewise.
	(const_uint32_operand): Likewise.
	(const_sint32_operand): Likewise.
	* sched.c [!INSN_SCHEDULING]: Define only dummy function
	schedule_insns and comment out rest of file.

	* m68k.c (output_move_simode_const): Use subl to move a zero into an
	address register.
	(output_move_[hq]imode): Likewise.

Mon Aug 17 09:15:47 1998  Jeffrey A Law  (law@cygnus.com)

	* toplev.c (main): Enable -fstrict-aliasing for -O2 and above.
	* invoke.texi: Corresponding changes.

Mon Aug 17 02:03:55 1998  Richard Henderson  <rth@cygnus.com>

	* regclass.c (allocate_reg_info): Respect MIN when clearing data.

Sun Aug 16 17:37:06 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>

	* config/sparc/sparc.c (ultra_code_from_mask,
	ultra_cmove_results_ready_p, ultra_fpmode_conflict_exists,
	ultra_find_type, ultra_schedule_insn, ultra_flush_pipeline,
	ultrasparc_sched_init, ultrasparc_variable_issue,
	ultra_rescan_pipeline_state, ultrasparc_sched_reorder): New
	functions to describe UltraSPARC pipeline exactly to Haifa.
	(ultrasparc_adjust_cost): Indicate IMUL type insns have zero cost,
	as there is nothing the scheduler can do about it.  Indicate that
	REG_DEP_OUTPUT's collide.  Fixup formatting.
	* config/sparc/sparc.h (RTX_COSTS): Fixup integer multiply and
	divide costs on Ultra for DImode.
	(MD_SCHED_INIT, MD_SCHED_REORDER, MD_SCHED_VARIABLE_ISSUE):
	Define.
	* config/sparc/sparc.md (ieu_unnamed function unit): Rename to
	ieuN and add call_no_delay_slot to type list.
	(cti function unit): New unit for branches on UltraSPARC.
	(subx/addx insns): Set type to misc.
	(sidi zero/sign extension insns on arch64): Set type to shift.
	(sign_extendhidi2_insn): Set type to sload.

Sun Aug 16 13:52:00 1998  David Edelsohn  <edelsohn@mhpcc.edu>

	* rs6000.c (rs6000_stack_info): Use if == 0 for sizes.
	(output_epilog): Use if != 0 for offset.
	(rs6000_fatal_bad_address): Prepare for Intl.
	* rs6000.h (rs6000_fatal_bad_address): Declare.
	* rs6000.md (movsfcc, movdfcc): Use else if.
	(elf_high): Use {liu|lis}.
	(elf_low): Use {cal|la}.  Remove %a template from old mnemonics.
	(movsi): Use rs6000_fatal_bad_address.
	
Sun Aug 16 01:53:21 1998  Richard Henderson  <rth@cygnus.com>

	* reload.c (find_equiv_reg): Reject equivalences separated
	by a volatile instruction.

Sun Aug 16 00:21:44 1998 Franz Sirl <Franz.Sirl-kernel@lauterbach.com> 

        * rs6000/linux.h (CPP_OS_DEFAULT_SPEC): Define.

Sat Aug 15 20:51:35 1998  Richard Henderson  <rth@cygnus.com>

	* alpha.md (movsicc): Fix mode mismatch.

Sat Aug 15 20:22:33 1998  H.J. Lu  (hjl@gnu.org)

	* config/alpha/alpha.h (ASM_OUTPUT_MI_THUNK): Handle aggregated
	return type.
	* config/alpha/win-nt.h (ASM_OUTPUT_MI_THUNK): Likewise.

Sat Aug 15 08:39:49 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>

	* config/sparc/sparc.md (movsi_lo_sum_pic_label_reg): Remove
	write-only modifier from operand 1 constraint.

Sat Aug 15 06:28:19 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>

	* config/sparc/sparc.c (sparc_emit_set_const64_quick1): If
	emitting a XOR of -1 at the end, emit a NOT instead for combine's
	sake.
	(sparc_emit_set_const64): Likewise, also when computing trailing
	bits do not negate low_bits and make fast_int an int.

Fri Aug 14 21:07:03 1998  Jeffrey A Law  (law@cygnus.com)

	* loop.c (add_label_notes): Do not ignore references to labels
	before dispatch tables.  Mirrors Apr 8 change to mark_jump_label.
	* gcse.c (add_label_notes): Similarly.

	* pa.h (ASM_OUTPUT_MI_THUNK): Strip name encoding.

	* m68k.md (adddi_dilshr32): One of the operands must be a register.
	(adddi_dishl32): Similarly.

Fri Aug 14 14:12:59 1998  Jason Merrill  <jason@yorick.cygnus.com>

	* i386.h (MODES_TIEABLE_P): Reorganize to shut up warnings.
	* alias.c (memrefs_conflict_p): Add braces to shut up warnings.
	* cse.c (cse_basic_block): Add parens to shut up warnings.

Fri Aug 14 12:58:21 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>

	* config/sparc/sparc.c (sparc_emit_set_const64_quick2,
	sparc_emit_set_const64_longway, const64_is_2insns,
	create_simple_focus_bits, sparc_emit_set_const64): Fix more bugs
	in 64-bit constant formation.
	* config/sparc/sparc.md (snesi_zero_extend split): Generate
	rtl for addx not subx.
	(define_insn movdi_const64_special): Make available even when
	HOST_BITS_PER_WIDE_INT is not 64.
	(movdi_lo_sum_sp64_cint, movdi_high_sp64_cint): Remove.
	(losum_di_medlow, sethm, setlo): Make op2 symbolic_operand.
	(cmp_siqi_trunc_set, cmp_diqi_trunc_set): Encapsulate both
	instances of operand 1 inside a QI subreg.
	(xordi3_sp64_dbl): Remove '%' constraint for op1.
	(one_cmpldi2_sp64): Fix output string.
	(one_cmplsi2_not_liveg0): Rewrite to remove unneeded extra
	alternative case.
	(unnamed arch64 ashift DI): Truncate shift count if greater than
	63, not 31.

Fri Aug 14 21:52:53 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* expr.c (store_expr): Don't optimize away load-store pair
	when either source or destination have a side effect.

Fri Aug 14 16:50:10 1998  John Carr  <jfc@mit.edu>

	* genrecog.c (add_to_sequence): Fatal error if the modes of the
	operands of SET are incompatible.

	* alpha.md: Fix max and min patterns so modes of SET operands match.

Fri Aug 14 12:22:55 1998  Ian Lance Taylor  <ian@cygnus.com>

	* configure.in: Avoid [[ by using test and changequote.
	* configure: Rebuild.

Fri Aug 14 01:22:31 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>

	* rtl.def (CONSTANT_P_RTX): Fix typo in string name.

	* config/sparc/sparc.md (seqdi_special_trunc, snedi_special_trunc,
	seqsi_special_extend, snesi_special_extend, snesi_zero_extend and
	split, snedi_zero_trunc and split, seqsi_zero_extend and split,
	seqdi_zero_trunc and split, pic_lo_sum_di, pic_sethi_di,
	movdi_cc_sp64_trunc, movdi_cc_reg_sp64_trunc, addx_extend_sp32 and
	split, addx_extend_sp64, subx_extend_sp64, subx_extend and split):
	Fix mismatching modes in SET operands.
	(conditional move patterns): Fix formatting.
	(unnamed subx arch64 pattern): Remove duplicate insn.
	
Fri Aug 14 00:34:34 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>

	* config/sparc/sparc.c (const64_operand, const64_high_operand):
	Get it right when HOST_BITS_PER_WIDE_INT is not 64.
	(input_operand): Fixup test for what we accept for constant
	integers.
	(sparc_emit_set_const32, sparc_emit_set_symbolic_const64): Give
	set VOIDmode.
	(safe_constDI): Remove.
	(sparc_emit_set_safe_HIGH64, gen_safe_SET64, gen_safe_OR64,
	gen_safe_XOR64): New functions.
	(sparc_emit_set_const64_quick1, sparc_emit_set_const64_quick2,
	sparc_emit_set_const64_longway, sparc_emit_set_const64): Use
	them.
	* config/sparc/sparc.md (define_insn xordi3_sp64_dbl): Only make
	available when HOST_BITS_PER_WIDE_INT is not 64.
	(define_insn movdi_sp64_dbl, movdi_const64_special): Likewise and
	move before movdi_insn_sp64 pattern.
	(define_insn movdi_lo_sum_sp64_dbl, movdi_high_sp64_dbl): Remove.
	(define_insn sethi_di_medlow, seth44, setm44, sethh): Use
	symbolic_operand as predicate for second operand.
	(DImode minus split on arch32, negsi2 expander, one_cmplsi2
	expander): Give set VOIDmode.
	
Fri Aug 14 01:45:06 1998  Mumit Khan  <khan@xraylith.wisc.edu>

	* i386/cygwin32 (DEFAULT_PCC_STRUCT_RETURN): Define.

Fri Aug 14 01:40:21 1998  Geoffrey Keating  <geoffk@ozemail.com.au>

	* rs6000/linux.h (LINK_SPEC): Pass -G args to the linker.

Fri Aug 14 01:23:23 1998  Richard Earnshaw (rearnsha@arm.com)

	* arm/netbsd.h (TARGET_DEFAULT): Default includes software floating 
	point.
	(CPP_FLOAT_DEFAULT_SPEC): Re-define accordingly.

Fri Aug 14 01:19:08 1998  Robert Lipe  <robertl@dgii.com>

	* install.texi: Various SCO OpenServer tweaks.

Thu Aug 13 20:14:40 1998  Jim Wilson  <wilson@cygnus.com>

	* reload1.c (eliminate_regs_in_insn): Handle another case when
	eliminating the frame pointer to the hard frame pointer.  Add
	missing	ep->to_rtx check to one existing case.

	* mips/mips.md (movhi_internal2+2): Fix typo mem:SI -> mem:HI.

Thu Aug 13 17:08:11 1998  Jason Merrill  <jason@yorick.cygnus.com>

	* tree.h: De-conditionalize init_priority code.

	* mips.h (NM_FLAGS): Change from -Bp to -Bn.
	* collect2.c (NM_FLAGS): Change from -p to -n.

	* configure.in: Turn on collect2 for mipstx39-elf.
	Handle use_collect2=no properly.

	* c-common.c: De-conditionalize init_priority code.
	* collect2.c (extract_init_priority, sort_ids): New fns.
	(main): Call sort_ids.
	Move sequence_number to file scope.

	* configure.in: Handle --enable-init-priority.
	* c-common.c (attrs): Add A_INIT_PRIORITY.
	(init_attributes, decl_attributes): Likewise.
	* tree.h (DEFAULT_INIT_PRIORITY, MAX_INIT_PRIORITY): New macros.
	* tree.c (get_file_function_name_long): Split out...
	(get_file_function_name): ...from here.

Thu Aug 13 16:09:53 1998  Martin von Loewis  <loewis@informatik.hu-berlin.de>

	* expr.c (safe_from_p): Change code to ERROR_MARK only when not
	accessing nodes.

Thu Aug 13 15:24:48 1998  Jason Merrill  <jason@yorick.cygnus.com>

	* toplev.c (display_help): Add braces to shut up warnings.
	* tree.c (simple_cst_equal): Likewise.

	* fold-const.c (non_lvalue): Don't deal with null pointer 
	constants here.
	(fold, case COMPOUND_EXPR): Wrap a constant 0 in a NOP_EXPR.

	* c-typeck.c (initializer_constant_valid_p): Allow conversion of 0
	of any size to a pointer.

Thu Aug 13 12:53:13 1998  Jim Wilson  <wilson@cygnus.com>

	* i386/winnt.c (i386_pe_asm_file_end): Check TREE_SYMBOL_REFERENCED.

Wed Aug 12 17:25:18 1998  Jeffrey A Law  (law@cygnus.com)

	* mn10300.c (REG_SAVE_BYTES): Only reserve space for registers
	which will be saved.
	* mn10300.md (prologue insn): Only save registers which need saving.
	(epilogue insn): Similarly.

	* mn10300.c, mn10300.h, mn10300.md: Remove "global zero register"
	optimizations.

Wed Aug 12 12:39:16 1998  Gavin Romig-Koch  <gavin@cygnus.com>

	* mips/mips.h (ENCODE_SECTION_INFO): Set SYMBOL_REF_FLAG for
	VAR_DECL's in gp addressable sections.

Tue Aug 11 23:02:31 1998  John Carr  <jfc@mit.edu>

	* sparc.c: Change return <exp> to <exp>; return; in functions
 	returning void.
	* sparc.md: Add empty semicolon statement after final label in
	move expanders.

Tue Aug 11 22:42:01 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>

	* config/sparc/sparc.md (define_insn addx_extend): Rename to
	addx_extend_sp64, only allow when TARGET_ARCH64.
	(define_insn addx_extend_sp32 and split): Version that works when
	not TARGET_ARCH64.
	(define_insn subx_extend): Likewise.
	(define_split adddi3 and subdi3 with zero extension): Fixup and
	correct bugs when not TARGET_ARCH64.

Tue Aug 11 16:04:34 1998  John Carr  <jfc@mit.edu>

	* except.c (set_exception_lang_code, set_exception_version_code):
	Use prototype-style definition if __STDC__, to match declaration
	in except.h.

	* genemit.c: Change FAIL and DONE macros not to use loops.

Tue Aug 11 12:27:03 1998  Jim Wilson  <wilson@cygnus.com>

	* dwarf2out.c (ASM_OUTPUT_DWARF_ADDR_CONST): Use
	ASM_OUTPUT_DWARF2_ADDR_CONST if defined.

	* mips/mips.md (reload_outsi): Use M16_REG_P when TARGET_MIPS16.

Tue Aug 11 18:12:53 1998  Dave Love  <d.love@dl.ac.uk>

	* README.g77: Update from Craig.

Tue Aug 11 04:46:01 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>

	* config/sparc/sparc.c (sparc_emit_set_const32): INTVAL is of
	type HOST_WIDE_INT.
	(safe_constDI sparc_emit_set_const64_quick1,
	sparc_emit_set_const64_quick2, sparc_emit_set_const64_longway,
	analyze_64bit_constant, const64_is_2insns,
	create_simple_focus_bits): Fix some bugs when compiled on real
	64-bit hosts.
	(function_arg_record_value_3, function_arg_record_value_2,
	function_arg_record_value): Add fully prototyped forward decls.
	* config/sparc/sparc.md (define_insn cmpsi_insn_sp32): Rename back
	to cmpsi_insn and use on both 64 and 32 bit targets.
	(define_insn cmpsi_insn_sp64): Remove.
	(define_expand zero_extendsidi2): Allow for 32-bit target too.
	(define_insn zero_extendsidi2_insn): Rename to
	zero_extendsidi2_insn_sp64.
	(define_insn zero_extendsidi2_insn_sp32): New pattern and
	assosciated forced split for it.

	* config/sparc/sparc.c (const64_operand, const64_high_operand):
	New predicates.
	* config/sparc/sparc.h: Declare them.
	(PREDICATE_CODES): Add them.
	* config/sparc/sparc.md (movdi_lo_sum_sp64_dbl,
	movdi_high_sp64_dbl, xordi3_sp64_dbl): Use them.

Mon Aug 10 22:57:24 1998  John Carr  <jfc@mit.edu>

	* config/sparc/sparc.md (define_insn jump): Output ba,pt not b,pt
	in v9 case as the latter makes the Solaris assembler crash.

Mon Aug 10 22:39:09 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>

	* config/sparc/sparc.c (input_operand): Do not accept a LO_SUM MEM
	for TFmode when !v9.  We require offsettable memory addresses.
	* config/sparc/sparc.h (ALTER_HARD_SUBREG): Handle TFmode to
	DFmode register number conversions.
	* config/sparc/sparc.md (define_split DFmode moves): If register
	is a SUBREG do alter_subreg on it before using.
	(define_expand movtf): Fixup comment about alignment on v9.
	(define_split TFmode moves): Don't use gen_{high,low}part, create
	explicit SUBREGs instead.

Mon Aug 10 19:02:55 1998  John Carr  <jfc@mit.edu>

	* Makefile.in (mbchar.o): Depend on mbchar.c.

Mon Aug 10 04:28:13 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>
			  Richard Henderson  <rth@cygnus.com>
	
	Rewrite Sparc backend for better code generation and
	improved sparc64 support.
	* config/sparc/sp64-elf.h: Set JUMP_TABLES_IN_TEXT_SECTION to
	zero.
	* config/sparc/sysv4.h: Likewise.
	* config/sparc/sparc.c (v8plus_regcmp_p, sparc_operand,
	move_operand, v8plus_regcmp_op, emit_move_sequence,
	singlemove_string, doublemove_string, mem_aligned_8,
	output_move_double, output_move_quad, output_fp_move_double,
	move_quad_direction, output_fp_move_quad, output_scc_insn):
	Remove.
	(small_int_or_double): New predicate.
	(gen_compare_reg): Remove TARGET_V8PLUS cmpdi_v8plus emission.
	(legitimize_pic_address): Emit movsi_{high,lo_sum}_pic instead of
	old pic_{sethi,lo_sum}_si patterns.
	(mem_min_alignment): New generic function to replace
	mem_aligned_8, which uses REGNO_POINTER_ALIGN information when
	available and can test for arbitrary alignments.  All callers
	changed.
	(save_regs, restore_regs, build_big_number,
	output_function_prologue, output_cbranch, output_return,
	sparc_flat_save_restore, sparc_flat_output_function_prologue,
	sparc_flat_output_function_epilogue): Prettify
	insn output.
	(output_function_epilogue): Likewise and add code to output
	deferred case vectors.
	(output_v9branch): Likewise, add new arg INSN and use it to tack
	on branch prediction settings.  All callers changed.
	(print_operand): Likewise and output %l44 for LO_SUMs when
	TARGET_CM_MEDMID.
	(sparc_splitdi_legitimate): New function to make sure DImode
	splits can be run properly when !arch64.
	(sparc_initialize_trampoline, sparc64_initialize_trampoline):
	Reformat example code in comments.
	(set_extends): Remove UNSPEC/v8plus_clear_high case.
	(sparc_addr_diff_list, sparc_addr_list): New statics to keep track
	of deferred case vectors we need to output.
	(sparc_defer_case_vector): Record a case vector.
	(sparc_output_addr_vec, sparc_output_addr_diff_vec,
	sparc_output_deferred_case_vectors): New functions to output them.
	(sparc_emit_set_const32): New function to form 32-bit constants in
	registers when that requires more than one instruction.
	(safe_constDI, sparc_emit_set_const64_quick1,
	sparc_emit_set_const64_quick2, sparc_emit_set_const64_longway,
	analyze_64bit_constant, const64_is_2insns,
	create_simple_focus_bits, sparc_emit_set_const64): New functions
	which do the same for 64-bit constants when arch64.
	(sparc_emit_set_symbolic_const64): New function to emit address
	loading for all code models on v9.
	* config/sparc/sparc.h (CONDITIONAL_REGISTER_USAGE): Do not make
	%g1 fixed when arch64, unfix %g0 when TARGET_LIVE_G0.
	(ALTER_HARD_SUBREG): Fix thinko, return REGNO + 1 not 1.
	(SECONDARY_INPUT_RELOAD_CLASS, SECONDARY_OUTPUT_RELOAD_CLASS): Fix
	inaccuracies in comments, add symbolic and text_segment operands
	when TARGET_CM_MEDANY and TARGET_CM_EMBMEDANY respectively.  Use
	GENERAL_REGS in these cases as a temp REG is needed to load these
	addresses into a register properly.
	(EXTRA_CONSTRAINT): Document more accurately, remove Q case as it
	is no longer used.
	(GO_IF_LEGITIMATE_ADDRESS): Allow TFmode for LO_SUM on v9 since fp
	quads are guarenteed to have 16-byte alignment.
	(LEGITIMIZE_ADDRESS): For SYMBOL_REF, CONST, and LABEL_REF use
	copy_to_suggested_reg instead of explicit LO_SUM and HIGH.
	(ASM_OUTPUT_ADDR_VEC, ASM_OUTPUT_ADDR_DIFF_VEC): New macros for
	deferred case vector implementation.
	(ASM_OUTPUT_ADDR_VEC_ELT): Use fputc to output newline.
	(ASM_OUTPUT_ADDR_DIFF_ELT): Parenthesize LABEL in macro calls.
	Generate "internal label - label" instead of "label - 1b".
	(PRINT_OPERAND_ADDRESS): For LO_SUM use %l44 on TARGET_CM_MEDMID.
	(PREDICATE_CODES): Remove sparc_operand, move_operand,
	v8plus_regcmp_op.  Add small_int_or_double, input_operand, and
	zero_operand.
	(doublemove_string, output_block_move, output_fp_move_double,
	output_fp_move_quad, output_move_double, output_move_quad,
	output_scc_insn, singlemove_string, mem_aligned_8, move_operand,
	sparc_operand, v8plus_regcmp_op, v8plus_regcmp_p): Remove externs.
	(sparc_emit_set_const32, sparc_emit_set_const64,
	sparc_emit_set_symbolic_const64, input_operand, zero_operand,
	mem_min_alignment, small_int_or_double): Add externs.
	* config/sparc/sparc.md: Document the many uses of UNSPEC and
	UNSPEC_VOLATILE in this backend.
	(define_function_unit ieu): Rename to ieu_unnamed.  Add move and
	unary to types which execute in it.
	(define_function_unit ieu_shift): Rename to ieu0.
	(define_function_unit ieu1): New, executes compare, call, and
	uncond_branch type insns.
	(define_function_units for type fdivs, fdivd, fsqrt): These
	execute in the fpu multiply unit not the adder on UltraSparc.
	(define_expand cmpdi): Disallow TARGET_V8PLUS.
	(define_insn cmpsi_insn): Rename to cmpsi_insn_sp32.
	(define_insn cmpsi_insn_sp64): New, same as sp32 variant except it
	allows the arith_double_operand predicate and rHI constraint when
	TARGET_ARCH64.
	(define_insn cmpdi_sp64, cmpsf_fpe, cmpdf_fpe, cmptf_fpe,
	cmpsf_fp, cmpdf_fp, cmptf_fp, sltu_insn, neg_sltu_insn,
	neg_sltu_minux_x, neg_sltu_plus_x, sgeu_insn, neg_sgeu_insn,
	sltu_plus_x, sltu_plus_x, sltu_plus_x_plus_y, x_minus_sltu,
	sgeu_plus_x, x_minus_sgeu, movqi_cc_sp64, movhi_cc_sp64,
	movsi_cc_sp64, movdi_cc_sp64, movsf_cc_sp64, movdf_cc_sp64,
	movtf_cc_sp64, movqi_cc_reg_sp64, movhi_cc_reg_sp64,
	movsi_cc_reg_sp64, movdi_cc_reg_sp64, movsf_cc_reg_sp64,
	movdf_cc_reg_sp64, movtf_cc_reg_sp64, zero_extendhisi2_insn,
	cmp_siqi_trunc, cmp_siqi_trunc_set, sign_extendhisi2_insn,
	sign_extendqihi2_insn, sign_extendqisi2_insn,
	sign_extendqidi2_insn, sign_extendhidi2_insn,
	extendsfdf2, extendsftf2, extenddftf2, truncdfsf2, trunctfsf2,
	trunctfdf2, floatsisf2, floatsidf2, floatsitf2, floatdisf2,
	floatdidf2, floatditf2, fix_truncsfsi2, fix_truncdfsi2,
	fix_trunctfsi2, fix_truncsfdi2, fix_truncdfdi2, fix_trunctfdi2,
	adddi3_sp64, addsi3, cmp_ccx_plus, cmp_cc_plus_set, subdi_sp64,
	subsi3, cmp_minus_ccx, cmp_minus_ccx_set, mulsi3, muldi3,
	muldi3_v8plus, cmp_mul_set, mulsidi3, mulsidi3_v8plus,
	const_mulsidi3_v8plus, mulsidi3_sp32, const_mulsidi3,
	smulsi3_highpart_v8plus, unnamed subreg mult,
	const_smulsi3_highpart_v8plus, smulsi3_highpart_sp32,
	const_smulsi3_highpart, umulsidi3_v8plus, umulsidi3_sp32,
	const_umulsidi3, const_umulsidi3_v8plus, umulsi3_highpart_v8plus,
	const_umulsi3_highpart_v8plus, umulsi3_highpart_sp32,
	const_umulsi3_highpart, divsi3, divdi3, cmp_sdiv_cc_set, udivsi3,
	udivdi3, cmp_udiv_cc_set, smacsi, smacdi, umacdi, anddi3_sp64,
	andsi3, and_not_di_sp64, and_not_si, iordi3_sp64, iorsi3,
	or_not_di_sp64, or_not_si, xordi3_sp64, xorsi3, xor_not_di_sp64,
	xor_not_si, cmp_cc_arith_op, cmp_ccx_arith_op,
	cmp_cc_arith_op_set, cmp_ccx_arith_op_set, cmp_ccx_xor_not,
	cmp_cc_xor_not_set, cmp_ccx_xor_not_set, cmp_cc_arith_op_not,
	cmp_ccx_arith_op_not, cmp_cc_arith_op_not_set,
	cmp_ccx_arith_op_not_set, negdi2_sp64, cmp_cc_neg, cmp_ccx_neg,
	cmp_cc_set_neg, cmp_ccx_set_neg, one_cmpldi2_sp64, cmp_cc_not,
	cmp_ccx_not, cmp_cc_set_not, cmp_ccx_set_not, addtf3, adddf3,
	addsf3, subtf3, subdf3, subsf3, multf3, muldf3, mulsf3,
	muldf3_extend, multf3_extend, divtf3, divdf3, divsf3, negtf2,
	negdf2, negsf2, abstf2, absdf2, abssf2, sqrttf2, sqrtdf2, sqrtsf2,
	ashlsi3, ashldi3, unnamed DI ashift, cmp_cc_ashift_1,
	cmp_cc_set_ashift_1, ashrsi3, ashrdi3, unnamed DI ashiftrt,
	ashrdi3_v8plus, lshrsi3, lshrdi3, unnamed DI lshiftrt,
	lshrdi3_v8plus, tablejump_sp32, tablejump_sp64, call_address_sp32,
	call_symbolic_sp32, call_address_sp64, call_symbolic_sp64,
	call_address_struct_value_sp32, call_symbolic_struct_value_sp32,
	call_address_untyped_struct_value_sp32,
	call_symbolic_untyped_struct_value_sp32, call_value_address_sp32,
	call_value_symbolic_sp32, call_value_address_sp64,
	call_value_symbolic_sp64, branch_sp32, branch_sp64,
	flush_register_windows, goto_handler_and_restore,
	goto_handler_and_restore_v9, goto_handler_and_restore_v9_sp64,
	flush, all ldd/std peepholes, return_qi, return_hi, return_si,
	return_addsi, return_di, return_adddi, return_sf, all call+jump
	peepholes, trap, unnamed trap insns): Prettify output strings.
	(define_insn anddi3_sp32, and_not_di_sp32, iordi3_sp32,
	or_not_di_sp32, xordi3_sp32, xor_not_di_sp32, one_cmpldi2):
	Likewise and force + implement splits for integer cases.
	(define_insn return_sf_no_fpu): Likewise and allow to match when
	no-fpu because of our subreg SFmode splits.
	(define_insn zero_extendqihi2, zero_extendqisi2_insn,
	zero_extendqidi2_insn, zero_extendhidi2_insn,
	zero_extendsidi2_insn, sign_extendsidi2_insn): Likewise and use
	input_operand for second operand.
	(cmp_minus_cc, cmp_minus_cc_set): Likewise and use
	reg_or_0_operand for operand 2 so new splits can use it.
	(cmp_zero_extendqisi2, cmp_zero_extendqisi2_set, cmp_cc_plus,
	cmp_cc_xor_not): Likewise and don't forget to check TARGET_LIVE_G0
	too.
	(cmp_zero_extract, cmp_zero_extract_sp64): Likewise and allow
	CONST_DOUBLEs for operand 2.
	(define_insn move_label_di): Likewise and label distance
	optimization because it no longer works with new deferred case
	vector scheme.  To be revisited.
	(define_insn x_minus_y_minus_sltu, x_minus_sltu_plus_y): Likewise
	and allow reg_or_0_operand and J constraint for second operand.
	(define_insn jump): Set branch predict taken on V9.
	(define_insn tablejump): Emit LABEL_REF + PLUS memory address for
	new deferred case vector scheme.
	(define_insn pic_tablejump_32, pic_tablejump_64): Remove.
	(define_insn negdi2_sp32): Force + implement splits.
	(define_insn negsi2, one_cmplsi2): Rename to negsi2_not_liveg0 and
	one_cmplsi2_not_liveg0 respectively, and create	expander of original
	names which emit special rtl for TARGET_LIVE_G0.
	(define_insn cmpdi_v8plus, scc_si, scc_di): Remove.
	(define_insn seq, sne, slt, sge, sle, sltu, sgeu): Don't do
	gen_compare_reg, FAIL instead.
	(define_insn sgtu, sleu): Likewise and check gen_s*() return
	values when trying to reverse condition codes, if they FAIL then
	do likewise.
	(define_insn snesi_zero, neg_snesi_zero, snesi_zero_extend,
	snedi_zero, neg_snedi_zero, snedi_zero_trunc, seqsi_zero,
	neg_seqsi_zero, seqsi_zero_extend, seqdi_zero, neg_seqdi_zero,
	seqdi_zero_trunc, x_plus_i_ne_0, x_minus_i_ne_0, x_plus_i_eq_0,
	x_minus_i_eq_0): Add new splits to perform these multi-insn cases,
	set output string to # to indicate they are mandatory splits.
	(define_insn pic_lo_sum_si, pic_sethi_si, pic_lo_sum_di,
	pic_sethi_di, move_pic_label_si): Remove.
	(define_insn movsi_low_sum, movsi_high, movsi_lo_sum_pic,
	movsi_high_pic, movsi_pic_label_reg): New patterns to take their
	place.
	(define_expand movsi_pic_label_ref, define_insn
	movsi_high_pic_label_ref, movsi_lo_sum_pic_label_ref): New
	expander and insns to handle PIC label references and deferred
	case vectors.
	(define_insn get_pc_via_rdpc): Comment out as it is no longer
	used.
	(define_expand movqi, movhi, movsi, movdi, movsf, movdf, movtf):
	Rewrite to not use emit_move_sequence, make use of new constant
	formation code, and new splits for all multi-insn cases.
	(define_insn movqi_insn): Remove sethi case, it can never happen.
	Use reg_or_zero_operand instead of const0_rtx explicit test,
	use input_operand instead of move_operand for source, and use
	general_operand now for dest.
	(define_insn movhi_insn): Similar but leave sethi case.
	(define_insn lo_sum_qi, store_qi, store_hi): Remove.
	(define_insn sethi_hi lo_sum_hi): Rename to movhi_high and
	movhi_lo_sum respectively, prettify output string.
	(define_insn movsi_zero_liveg0): New pattern to put zero into a
	register when needed on TARGET_LIVE_G0.
	(define_insn movsi_insn): Use general_operand and input_operand
	for dest and src respectively.  Simplify applicability test.
	Prettify output strings, and add clr alternative for J
	constraint.
	(define_insn movdi_sp32_v9, movdi_sp32, define_splits for
	deprecated std and reg-reg DI moves): Remove and...
	(define_insn movdi_insn_sp32, movdi_insn_sp64): Replace with new
	implementation which uses forced splits for all non-single insn
	cases.
	(define_split DI move cases on !arch64): New splits to handle all
	situations of 64-bit double register DImode on 32bit, and
	unaligned registers and memory addresses for all subtargets.
	(define_insn movsf_const_insn, movdf_const_insn, store_sf):
	Remove.
	(define_insn movsf_insn, movsf_no_f_insn): Use general_operand and
	input_operand for dest and src respectively, prettify output
	strings.
	(define_insn movdf_insn, movdf_no_e_insn, store_df,
	movtf_const_insn, movtf_insn, movtf_no_e_insn, store_tf): Remove
	and...
	(define_insn movdf_insn_sp32, movdf_no_e_insn_sp32,
	movdf_insn_sp64, movdf_no_e_insn_sp64, movtf_insn,
	movtf_no_e_insn_sp32, movtf_insn_hq_sp64, movtf_insn_sp64,
	movtf_no_e_insn_sp64) Replace with new
	implementation which uses forced splits for all non-single insn
	cases.
	(define_split DF move cases): New splits in similar vein to DI
	move counterparts.
	(define_insn sethi_di_medlow, sethi_di_medium_pic,
	sethi_di_embmedany_data, sethi_di_embmedany_text, sethi_di_sp64,
	movdi_sp64_insn): Remove old v9 code model and constant loading
	support insns and..
	(define_insn pic_lo_sum_di, pic_sethi_di,
	sethi_di_medlow_embmedany_pic, sethi_di_medlow, losum_di_medlow,
	seth44, setm44, setl44, sethh, setlm, sethm, setlo,
	embmedany_sethi, embmedany_losum, embmedany_brsum,
	embmedany_textuhi, embmedany_texthi, embmedany_textulo,
	embmedany_textlo, movdi_lo_sum_sp64_cint, movdi_lo_sum_sp64_dbl,
	movdi_high_sp64_cint, movdi_high_sp64_dbl): Replace with new
	scheme, using unspecs, secondary reloads, and one to one sparc
	insn to rtl insn mapping for better scheduling and code gen.
	(define_expand reload_indi, reload_outdi): Reload helpers for
	MEDANY and EMBMEDANY symbol address loading cases which require a
	temporary register.
	(define_expand movsicc): Remove v8plus_regcmp cases.
	(define_insn movdi_cc_sp64_trunc, movdi_cc_reg_sp64_trunc,
	cmp_zero_extendqidi2, cmp_zero_extendqidi2_set, cmp_qidi_trunc,
	cmp_diqi_trunc_set): New patterns used by some of the new scc
	splits on arch64.
	(define_insn xordi3_sp64_dbl): New pattern used for constant
	formation when crossing from 32-bit targets.
	(define_insn movsi_cc_reg_v8plus, v8plus_clear_high, and helper
	split): Remove.
	(define_insn addx, subx): Make visible and prettify.
	(define_insn adddi3_insn_sp32): Likewise and force split.
	(define_insn addx_extend, subx_extend, unnamed): New patterns for
	64bit scc split usage.
	(define_insn unnamed plusDI zero_extend, unnamed minusDI
	zero_extend, subdi3): Force and implement splits.
	
	* final.c (final_scan_insn): Don't output labels if target
	specifies ASM_OUTPUT_ADDR_{DIFF}_VEC.  Do these macro operations
	instead.
	
	* reorg.c (dbr_schedule): When taking on BR_PRED notes at the end,
	don't forget to walk inside SEQUENCESs too as these are what the
	delay slot scheduler will create.
	
Mon Aug 10 01:21:01 1998  Richard Henderson  <rth@cygnus.com>

	* alpha.md (extxl+1,+2): New patterns to work around
	combine lossage.

Sat Aug  8 19:20:22 1998 Gary Thomas (gdt@linuxppc.org)

	* rs6000.c (rs6000_allocate_stack_space) Fix typo which
	caused bad assembly code to be generated.

Sat Aug  8 18:53:28 1998  Jeffrey A Law  (law@cygnus.com)

	* netbsd.h: Fix typo.

Mon Aug  3 00:06:42 1998  Robert Lipe  <robertl@dgii.com> 

	* config.sub: Fix typo.

Sun Aug  2 22:39:08 1998  Hans-Peter Nilsson  <hp@axis.se>

	* invoke.texi (Environment Variables): Typo: Change "ascpects"
	into "aspects".
	(Running Protoize): Typo: Change "ther" into "other".

Sun Aug  2 00:42:50 1998  Jeffrey A Law  (law@cygnus.com)

	* i386/netbsd.h: Undo previous change to DWARF2_UNWIND_INFO.
	* m68k/netbsd.h: Likewise.
	* ns32k/netbsd.h: Likewise.
	* sparc/netbsd.h: Likewise.

Sat Aug  1 17:59:30 1998  Richard Henderson  <rth@cygnus.com>

        * ginclude/va-alpha.h (va_list): Use a typedef, not a define.
        * ginclude/va-clipper.h (va_list): Likewise.

Fri Jul 31 20:22:02 1998  Michael Meissner  <meissner@cygnus.com>

	* rs6000.c (rs6000_override_options): If big endian and -Os, use
	load/store multiple instructions unless user overrides.

Fri Jul 31 17:08:59 1998  Jeffrey A Law  (law@cygnus.com)

	* ns32k/netbsd.h: Fix typo.

Fri Jul 31 10:23:55 1998  Doug Evans  <devans@canuck.cygnus.com>

	* m32r/m32r.h (ASM_OUTPUT_SOURCE_LINE): Always output line number
	labels with .debugsym if no parallel insns.

Thu Jul 30 19:15:53 1998  Richard Henderson  <rth@cygnus.com>

	* alpha.md (fp cmp): Replicate patterns for ALPHA_TP_INSN.
	(fcmov): Remove ALPHA_TP_INSN patterns -- fcmov doesn't trap.

Thu Jul 30 19:50:15 1998  David Edelsohn  <edelsohn@mhpcc.edu>

	* rs6000/x-aix43 (AR_FOR_TARGET_FLAGS): Delete.
	(AR_FOR_TARGET): Define.

Thu Jul 30 12:29:12 1998  Mark Mitchell  <mark@markmitchell.com>

	* dyn-string.h: New file.
	* dyn-string.c: Likewise.
	* Makefile.in (OBJS): Add dyn-string.o.
	(dwarf2out.o): Add dyn-string.h dependency.
	(dyn-string.o): List dependencies.
	* dwarf2out.c: Include dyn-string.h.
	(ASM_NAME_TO_STRING): Use dyn_string_append, rather than strcpy.
	(addr_const_to_string): Take a dyn_string_t, not a char* as a
	prototype.  Use dyn_string_append rather than strcat, throughout.
	(addr_to_string): Use dyn_string_t.

Thu Jul 30 13:08:07 1998  Ken Raeburn  <raeburn@cygnus.com>

	Function entry/exit profiling instrumentation:
	* expr.h (profile_function_entry_libfunc,
	profile_function_exit_libfunc): Declare new variables.
	* optabs.c: Define them here.
	(init_optabs): Initialize them.
	* tree.h (struct tree_decl): New flag
	no_instrument_function_entry_exit.
	(DECL_NO_INSTRUMENT_FUNCTION_ENTRY_EXIT): New accessor macro.
	* c-decl.c (duplicate_decls): Merge it.
	* c-common.c (enum attrs): New value A_NO_INSTRUMENT_FUNCTION.
	(init_attributes): Use it for "no_instrument_function".
	(decl_attributes): Handle it, for functions that have not yet been
	compiled.  Set decl flag.
	* flags.h (flag_instrument_function_entry_exit): Declare new
	variable.
	* toplev.c (flag_instrument_function_entry_exit): Define it here.
	(f_options): New option "instrument-functions".
	* function.h (struct function): New field instrument_entry_exit.
	* function.c (current_function_instrument_entry_exit): New
	variable.
	(push_function_context_to, pop_function_context_from): Save and
	restore.
	(expand_function_start): Set current_ variable, maybe emit return
	label and entry profile call.
	(expand_function_end): Maybe emit exit profile call.

Thu Jul 30 00:58:34 1998  Jeffrey A Law  (law@cygnus.com)

	* i386.md (movqi): When optimizing a load of (const_int 1) into a
	NON_QI_REG_P, pretend the register is SImode.

Wed Jul 29 23:49:23 1998  Todd Vierling <tv@netbsd.org>

	* configure.in: Use xm-netbsd.h as the NetBSD xm file (not xm-siglist).
	Accept arm32 as arm, m68k4k as m68k, mipsle as mips-dec, and any
	manufacturer id for ns32k.
	* configure: Regenerated.
	* config/netbsd.h: When using ASM_WEAKEN_LABEL, make it global too.
	* config/t-netbsd: Don't compile libgcc1-test as the fns are in libc.
	* config/i386/netbsd.h: Undefine DWARF2_UNWIND_INFO, not define as 0.
	* config/m68k/netbsd.h: Same.
	* config/ns32k/netbsd.h: Same.
	* config/sparc/netbsd.h: Same.

Wed Jul 29 22:39:21 1998  Jeffrey A Law  (law@cygnus.com)

	* unroll.c (unroll_loop): Do not abort for an UNROLL_MODULO
	or UNROLL_COMPLETELY loop that starts with a jump to its
	exit code.

Wed Jul 29 22:18:14 1998  David Edelsohn  <edelsohn@mhpcc.edu>

	* rs6000/rs6000.md (absdi2 define_split): Swap operands of MINUS.
	* rs6000/rs6000.c (mask64_operand): Use HOST_BITS_PER_WIDE_INT.
	(print_operand, case 'B'): Don't fall through.
	(print_operand, case 'S'): Correct mask begin/end computation.
	Use HOST_BITS_PER_WIDE_INT.
	* rs6000/rs6000.h (CPP_PREDEFINES): Define _LONG_LONG.
	(CONDITIONAL_REGISTER_USAGE): GPR13 fixed if TARGET_64BIT.
	* rs6000/aix41.h (CPP_PREDEFINES): Same.
	* rs6000/aix43.h (CPP_PREDEFINES): Same.

Wed Jul 29 11:47:10 1998  Nick Clifton  <nickc@cygnus.com>

	* config/arm/thumb.md (extendqisi2_insn): Remove earlyclobber
	constraint from second alternative.

Tue Jul 28 23:29:04 1998  Jason Merrill  <jason@yorick.cygnus.com>

	* configure.in: Fix --without/--disable cases for local-prefix, 
	gxx-include-dir and checking.

Tue Jul 28 22:01:23 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>

	* configure.in (enable_haifa): Set by default for sparc64 too.
	configure: Rebuilt.

Tue Jul 28 23:29:04 1998  Jason Merrill  <jason@yorick.cygnus.com>

	* i386/cygwin32.h (VALID_MACHINE_TYPE_ATTRIBUTE): New macro.
	* i386/winnt.c (associated_type): New fn.
	(i386_pe_valid_type_attribute_p): New fn.
	(i386_pe_check_vtable_importexport): Remove.
	(i386_pe_dllexport_p): Use associated_type.
	(i386_pe_dllimport_p): Likewise.

	From Antonio M. O. Neto <anmendes@cruzeironet.com.br>:
	* i386.c (i386_valid_type_attribute_p): Also accept
	attributes for METHOD_TYPEs.

Tue Jul 28 23:17:39 1998  Peter Gerwinski <peter@gerwinski.de>

	* tree.c (build_range_type): Copy TYPE_SIZE_UNIT.

Tue Jul 28 22:31:12 1998  Craig Burley  <burley@gnu.org>

	* gcc.c: Fix commentary describing %g, %u, %U, and %O.

	* gcc.c (do_spec_1): Fix handling of %g%O and %U%O to prevent
	them from generating a new base name for each occurence of
	a specific suffix.

1998-07-28  Vladimir N. Makarov  <vmakarov@cygnus.com>

	* cse.c (cse_insn): Enable subsitution inside libcall only for REG,
	SUBREG, MEM.
	* rtlanal.c (replace_rtx): Prohibit replaces in	CONST_DOUBLE. 



	* cplus-dem.c (type_kind_t): New type.
	(demangle_template_value_parm): Add type_kind_t parameter.  Rely
	on this paramter, rather than demangling the type again.
	(demangle_integral_value): Pass tk_integral.
	(demangle_template_: Pass the value returned from do_type.
	(do_type): Return a type_kind_t.  Pass tk_integral to
	demangle_template_value_parm for array bounds.
	(demangle_fund_type): Likewise.
	
Mon Jul 27 00:54:41 1998  Jason Merrill  <jason@yorick.cygnus.com>

	* tree.c (simple_cst_equal, case CONSTRUCTOR): OK if the elts are
	identical.

Mon Jul 27 22:18:36 1998  Jeffrey A Law  (law@cygnus.com)

	* pa.c (move_operand): Accept CONSTANT_P_RTX.

Mon Jul 27 17:18:52 1998  Dave Brolley  <brolley@cygnus.com>

	* stor-layout.c (layout_type): Handle arrays of bits, for Chill.

	* expr.c (get_inner_reference): Handle zero-based, unsigned, array
	index conversion.

Mon Jul 27 14:51:33 1998  Jeffrey A Law  (law@cygnus.com)

	* mn10300.h (DEBUGGER_AUTO_OFFSET): Define.
	(DEBUGGER_ARG_OFFSET): Likewise.

	* mn10300.md (movsf): Remove last change.  Not needed.

Mon Jul 27 14:22:36 1998  Dave Brolley  <brolley@cygnus.com>

	* c-lex.c (yylex): Fix boundary conditions in character literal and
	string literal loops.

Mon Jul 27 11:43:54 1998  Stan Cox  <scox@cygnus.com>

	* longlong.h (count_leading_zeros): Sparclite scan instruction was
	being invoked incorrectly.

	* i386.c (ix86_prologue): Added SUBTARGET_PROLOGUE invocation.
	* i386/cygwin32.h (STARTFILE_SPEC, LIB_SPEC, SUBTARGET_PROLOGUE): 
	Add -pg support. 
	* i386/win32.h: New file.  Hybrid mingw32.h/cygwin32.h configuration.
	* configure.in: Added i[34567]86-*-win32
	* config.sub: Ditto.
	* configure: Rebuilt.
	
Sun Jul 26 01:11:12 1998  H.J. Lu  (hjl@gnu.org)

	* i386.h (CONST_DOUBLE_OK_FOR_LETTER_P): Return 0 when eliminating
	the frame pointer and compiling PIC code and reload has not completed.

	* i386.c (output_to_reg): Add code to emulate non-popping DImode
	case.

Sun Jul 26 01:01:32 1998  Jeffrey A Law  (law@cygnus.com)

	* regmove.c (regmove_optimize): Fix typo initializing regmove_bb_head.

Sat Jul 25 23:29:23 1998  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* Makefile.in (install-info): Only try to update the info
	directory file if it exists in the first place.

Fri Jul 24 18:58:37 1998  Klaus Espenlaub  <kespenla@student.informatik.uni-ulm.de>

	* rs6000.h (ASM_OUTPUT_CONSTRUCTOR, ASM_OUTPUT_DESTRUCTOR): Delete.

Fri Jul 24 14:20:26 1998  Jeffrey A Law  (law@cygnus.com)

	* mn10300.md (movqi, movhi, movsi, movsf): Correctly handle
	CONST_DOUBLE source.

Fri Jul 24 11:17:04 1998  Nick Clifton  <nickc@cygnus.com>

	* config/arm/thumb.c (thumb_print_operand): Decode %_ in asm
	strings as the insertion of USER_LABEL_PREFIX.
	* config/arm/thumb.h (PRINT_OPERAND_PUNCT_VALID_P): Accept _ as a
	valid code.
	* config/arm/thumb.md: Use %_ as a prefix to gcc library function
	calls. 

Thu Jul 23 18:53:20 1998  Jim Wilson  <wilson@cygnus.com>

	* dbxout.c (dbxout_range_type): Only call dbxout_type_index for
	already defined type.

Thu Jul 23 13:49:41 1998  Jeffrey A Law  (law@cygnus.com)

	* expr.c (check_max_integer_computation_mode): Allow conversions
	of constant integers to MAX_INTEGER_COMPUTATION_MODE.
	(expand_expr): Likewise.

Thu Jul 23 11:12:06 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* expr.c (expand_expr): Expand RETURN_EXPR.

Thu Jul 23 11:00:29 1998  Jim Wilson  <wilson@cygnus.com>

	* dwarf2out.c (dwarf2out_finish): Call stripattributes on TEXT_SECTION.

Wed Jul 22 19:10:00 1998  Catherine Moore  <clm@cygnus.com>

        * dwarf2out.c (output_aranges):  Call stripattributes
        for TEXT_SECTION references.
        (output_line_info): Likewise.

Wed Jul 22 14:08:54 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>

	* profile.c (branch_prob): Call allocate_reg_info after outputting
	profile rtl in instrument_arcs.

Wed Jul 22 12:47:49 1998  Jim Wilson  <wilson@cygnus.com>

	* fixinc.irix (math.h): Install wrapper instead of copying.

Wed Jul 22 12:37:14 1998  Alexandre Petit-Bianco <apbianco@cygnus.com>

	* tree.def (EXPR_WITH_FILE_LOCATION): Defined as an 'e' expression
 	so WFL are expanded correctly when contained in a COMPOUND_EXPR.
	* tree.h (EXPR_WFL_EMIT_LINE_NOTE): Change macro not to use
 	lang_flag_0. Added documentation in the flag table.

Tue Jul 21 23:28:35 1998  Klaus Kaempf <kkaempf@rmi.de>

	* cccp.c (do_include): Fix vax c style include handling.

Tue Jul 21 13:28:19 1998  Jason Merrill  <jason@yorick.cygnus.com>

	* cplus-dem.c (do_type): Use demangle_template_value_parm for arrays.

Sun Jul 12 01:27:05 1998  Jason Merrill  <jason@yorick.cygnus.com>

	* fold-const.c (non_lvalue): Don't deal with null pointer 
	constants here.
	(fold, case COMPOUND_EXPR): Wrap a constant 0 in a NOP_EXPR.

Tue Jul 21 15:49:31 1998  David Edelsohn  <edelsohn@mhpcc.edu>

	* rs6000.h (PREDICATE_CODES): Add CONSTANT_P_RTX.
	* rs6000.md (movsi, movdi): Add CONSTANT_P_RTX.
	* rs6000.c (short_cint_operand): Add CONSTANT_P_RTX.
	(u_short_cint_operand): Same.
	(reg_or_cint_operand): Same.
	(logical_operand): Same.
	(input_operand): Same.
	(reg_or_short_operand): Use u_short_cint_operand.

Tue Jul 21 08:56:42 1998  Richard Henderson  <rth@cygnus.com>

	* alpha.md (fix_truncdfsi2, fix_truncsfsi2): Remove the define_expands,
	but keep the insns and splits.  Adjust so when the ultimate destination
	is memory, use cvtql.

Tue Jul 21 08:55:09 1998  Richard Henderson  <rth@cygnus.com>

	* flow.c (regno_uninitialized): Fixed regs are never uninitialized.

Tue Jul 21 00:31:01 1998  Jeffrey A Law  (law@cygnus.com)

	* gcc.c (do_spec): Call "error" not "warning".

	* configure.in: Fix minor problems with gas feature detection code.
	* configure: Rebuilt.

	* gcc.c (do_spec): Issue a warning for '%[]' usage.

	* Undo this change.
	* gcc.c: Delete %[spec] support.
	(do_spec_1, case '('): Likewise.
	(do_spec_1, case '['): Call error.

Mon Jul 20 22:34:17 1998  Richard Henderson  <rth@cygnus.com>

	* alpha.h (CPP_SPEC): Tidy.  Hook to cpp_cpu and cpp_subtarget.
	(CPP_SUBTARGET_SPEC): Default to empty string.
	(CPP_AM_*, CPP_IM_*, CPP_CPU_*, CPP_CPU_SPEC): New.
	(EXTRA_SPECS, SUBTARGET_EXTRA_SPECS): New.
	* alpha/elf.h (LD_SPEC): Use %(elf_dynamic_linker).
	* alpha/linux-elf.h (SUBTARGET_EXTRA_SPECS): New.
	(LIB_SPEC): Tidy.
	* alpha/linux.h (CPP_PREDEFINES): Tidy.
	* alpha/netbsd-elf.h (SUBTARGET_EXTRA_SPECS): New.
	* alpha/netbsd.h (CPP_PREDEFINES): Tidy.
	* alpha/osf.h (CPP_PREDEFINES): Remove bits subsumed by CPP_CPU_SPEC.
	* alpha/win-nt.h (CPP_PREDEFINES): Likewise.
	* alpha/vsf.h (CPP_PREDEFINES): Likewise.
	(CPP_SUBTARGET_SPEC): New.  Do this instead of overriding CPP_SPEC.
	* alpha/vxworks.h: Likewise.

Mon Jul 20 22:51:57 1998  Ken Raeburn  <raeburn@cygnus.com>

	* mips.md (reload_outsi): Added missing REGNO call.
	(smulsi3_highpart, umulsi3_highpart): Provide prototype for
	function pointer.
	(mul_acc_di, mul_acc_64bit_di): Don't use match_op_dup, use
	another match_operator and compare the codes.

	* mips.h (MASK_DEBUG_E, MASK_DEBUG_I): Set to zero.

	* MIPS multiply pattern fixes:
	* mips.h (enum reg_class, REG_CLASS_NAMES, REG_CLASS_CONTENTS):
	Add union classes for HI, LO, or HILO plus general registers.
	(GENERATE_MADD): Deleted.
	* mips.md (mulsi3_mult3): Don't disparage output-LO alternative.
	Add TARGET_MAD to condition.
	(mulsi3): Test HAVE_mulsi3_mult3, not specific flags.
	(mul_acc_si): Expand GENERATE_MADD here; it's the only use.  Use
	"*d" for accumulator, to give preference to LO initially but not
	during reload.

Mon Jul 20 16:16:38 1998  Dave Brolley  <brolley@cygnus.com>

	* configure.in (enable_c_mbchar): New configure option.
	(extra_cpp_objs): Always available now.

	* cexp.y (mbchar.h): #include it.
	(yylex): Handle Multibyte characters in character literals.

	* cccp.c (mbchar.h): #include it.
	(main): Set character set based on LANG environment variable.
	(rescan): Handle multibyte characters in comments.
	(skip_if_group): See above.
	(validate_else): See above.
	(skip_to_end_of_comment): See above.
	(macarg1): See above.
	(discard_comments): See above.
	(rescan): Handle multibyte characters in string and character literals.
	(collect_expansion): See above.
	(skip_quoted_string): See above.
	(macroexpand): See above.
	(macarg1): See above.
	(discard_comments): See above.
	(change_newlines): See above.

	* c-lex.c (mbchar.h): #include it.
	(GET_ENVIRONMENT): New macro.
	(init_lex): Set character set based on LANG environment variable.
	(yylex): Handle multibyte characters in character literals.
	(yylex): Handle multibyte characters in string literals.

	* Makefile.in (mbchar.o): New target.
	(cccp$(exeext)): @extra_cpp_objs@ is always available.
	(cppmain$(exeext)): @extra_cpp_objs@ is always available.

	* mbchar.[ch]: New files for multibyte character handling.

Mon Jul 20 01:11:11 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>

	* jump.c (jump_optimize): When simplifying noop moves and
	PUSH_ROUNDING, fix thinko so we use same criterion for identifying
	the PUSHes to rewrite in second loop as we did in the first.

Sun Jul 19 08:23:53 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* cplus-dem.c (demangle_nested_args): Make function definition
	static to match the prototype.

Fri Jul 17 14:58:44 1998  Richard Henderson  <rth@cygnus.com>

	* alloca.c: Respect USE_C_ALLOCA.
	* gencheck.c (xmalloc): Ignore __GNUC__ for definition.
	* gengenrtl.c (xmalloc): Likewise.

Fri Jul 17 14:18:14 1998  Richard Henderson  <rth@cygnus.com>

	* loop.h (struct induction): Add no_const_addval.
	* loop.c (the_movables, reg_address_cost): New variables.
	(init_loop): Init reg_address_cost.
	(loop_optimize): Call end_alias_analysis.
	(scan_loop): Init the_movables.
	(record_giv): Init induction->no_const_addval.
	(basic_induction_var) [PLUS]: Use rtx_equal_p instead of ==.
	[REG]: Rearrange loop search test to catch more cases.
	(general_induction_var): Return success not benefit; take an extra
	argument for that.  Change all callers.
	(simplify_giv_expr) [PLUS]: Always combine invariants.  Use sge_plus.
	[MULT]: Use rtx_equal_p instead of ==.  Combine simple invariants.
	[default]: Search the_movables for additional combinations.
	(sge_plus_constant, sge_plus): New functions.
	(express_from_1): New function.
	(express_from): Always define.  Rewrite using express_from_1.
	(combine_givs_p): Handle more cases.  Ignore address cost.
	(cmp_combine_givs_stats): New function.
	(combine_givs_used_once, combine_givs_benefit_from): New functions.
	(combine_givs): Rewrite to do best-fit combination.

	* fold-const.c (operand_equal_p): Handle RTL_EXPR.
	(fold): Do a complete (A*C)+(B*C) association check.

Fri Jul 17 11:21:55 1998  Jim Wilson  <wilson@cygnus.com>

	* function.c (fixup_var_refs_insns): Handle CLOBBER of a CONCAT.

Fri Jul 17 11:48:55 1998  Jeffrey A Law  (law@cygnus.com)

	* mn10300.c (MODES_TIEABLE_P): Fix typo.

Fri Jul 17 03:26:12 1998  Rihcard Earnshaw (rearnsha@arm.com)

	* tree.c (valid_machine_attribute): Only create a new type variant if
	there is a decl to use it.

Thu Jul 16 14:48:04 1998  Nick Clifton  <nickc@cygnus.com>

	* gcc.c (do_spec_1): Cope with %g/%u/%U options which do not have
	a suffix.

Fri Jul 17 03:24:40 1998  Hans-Peter Nilsson  <hp@axis.se>

	* extend.texi (Explicit Reg Vars): Typo: change "may deleted" into "may
	be deleted" 

Thu Jul 16 14:48:47 1998  Jeffrey A Law  (law@cygnus.com)

	* mn10300.c (count_tst_insns): New arg oreg_countp.  Callers changed.
	Simplify tests for clearing an address register.
	(expand_prologue): Corresponding changes.

	* mn10300.md (movXX patterns): Make sure the destination is an
	ADDRESS_REG when substituting "zero_areg" for (const_int 0).
	(logical patterns): Split into expanders + patterns
	(zero and sign extension patterns): Similarly.
	(shift patterns): Similarly.

Thu Jul 16 01:17:44 1998  Richard Henderson  <rth@cygnus.com>

	* loop.c (emit_iv_add_mult): Scan the entire insn list generated
	for the sequence, recording base values.

Wed Jul 15 10:49:55 1998  Richard Henderson  <rth@cygnus.com>

	* i386.h (CPP_CPU_SPEC): Remove -Asystem(unix).

Tue Jul 14 14:15:30 1998  Nick Clifton  <nickc@cygnus.com>

	* gcc.c: Remove ANSI-C ism from --help code.

	* toplev.c: Support --help with USE_CPPLIB.

Tue Jul 14 14:46:08 1998  Jeffrey A Law  (law@cygnus.com)

	* configure.in: Rework gas feature code to work with symlink based
	source trees.

	* extend.texi: Clarify some issues related to local variables
	assigned to explicit registers.

	* mn10300.md (mulsi): Turn into expander + pattern.

	* mn10300.md (movsi, movsf, movdi, movdf): Remove "x" from I -> a
	alternative.

Tue Jul 14 07:41:59 1998  Richard Earnshaw (rearnsha@arm.com)

	* arm/tcoff.h (USER_LABEL_PREFIX): Make it empty to match coff.h.

Tue Jul 14 03:02:44 1998  Jeffrey A Law  (law@cygnus.com)

	* version.c: Bump again to distinguish mainline tree from the
	egcs-1.1 branch.

Tue Jul 14 02:20:38 1998  Jeffrey A Law  (law@cygnus.com)

	* version.c: Bump to avoid problems with old spec files during
	bootstrap.

Mon Jul 13 23:11:44 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>

	* config/sparc/sparc.c (output_scc_insn): Enclose || conditions in
	parens while walking over notes.
	* config/sparc/sparc.md (reg movdi split): Clean up matching
	conditions.
	(all DI arithop splits on 32-bit): Handle immediate arguments
	correctly when they are CONST_INTs.

Mon Jul 13 23:57:21 1998  Kamil Iskra  <iskra@student.uci.agh.edu.pl>

	* m68k/m68k.h (TARGET_SWITCHES): Clear MASK_68040_ONLY for
	-m68020-40, -m68020-60 and -m5200.

Mon Jul 13 23:52:05 1998  Weiwen Liu <weiwen.liu@yale.edu>

	* gcc.c (do_spec_1): Fix %O handling for secure temporary file
	creation.

Mon Jul 13 23:42:36 1998  Ralf Corsepius <corsepiu@faw.uni-ulm.de>

	* sh/elf.h (MAX_OFILE_ALIGNMENT): Undefine before including svr4.h.

Mon Jul 13 23:36:08 1998  Jim Wilson  <wilson@cygnus.com>

	* i386/i386.h (CPP_486_SPEC, CPP_586_SPEC, CPP_686_SPEC): New specs.
	(CPP_CPU_DEFAULT_SPEC, CPP_CPU_SPEC): Use them.
	(EXTRA_SPECS): Support them.
	* gcc.c: Delete %[spec] support.
	(do_spec_1, case '('): Likewise.
	(do_spec_1, case '['): Call error.
	* i386/aix386ng.h, cygwin32.h, freebsd-elf.h, gas.h, isc.h,
	linux-aout.h, linux-oldld.h, linux.h, osfelf.h, osfrose.h, sco.h,
	sco4.h, sco4dbx.h, sco5.h, sol2.h, sysv3.h (CPP_SPEC): Delete
	%[cpp_cpu].

Mon Jul 13 23:31:04 1998  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* m68k.c (output_scc_di): Use cmpw #0 only for address registers.

Mon Jul 13 23:26:43 1998  Jeffrey A Law  (law@cygnus.com)

	* tree.h (tree_common): Note front-end dependencies on layout of
	this structure.

Mon Jul 13 23:18:39 1998  Craig Burley  <burley@gnu.org>

	* stmt.c (expand_expr_stmt): If not assigning fresh
	value to last_expr_value, zero it, so old garbage
	doesn't get dereferenced.

Mon Jul 13 23:06:55 1998  Henning.Petersen@t-online.de (Henning Petersen)

	* gcse.c (hash_scan_insn): Add missing argument declaration.

Mon Jul 13 18:59:13 1998  Jim Wilson  <wilson@cygnus.com>

	* configure.in (mips-sgi-irix5cross64, mips-sgi-irix5*): Remove
	HAVE_INTTYPES_H from xm_defines.  Define xm_file to mips/xm-iris5.h.
	* mips/xm-iris5.h (USG): Delete.

Mon Jul 13 17:18:47 1998  Nick Clifton  <nickc@cygnus.com>

	* cccp.c (main): Add support for parsing --help.
	(display_help): New function: display command line switches.

	* cpplib.c (cpp_handle_option): Add support for parsing --help.
	(display_help): New function: display command line switches.

	* gcc.c (main): Add support for parsing --help, and passing it on
	to the sub-processes invoked by gcc.
	(display_help): New function: display comman line switches.	

	* tm.texi (TARGET_SWITCHES and TARGET_OPTIONS): Document
	'description' field added to structure.  

	* toplev.c: Add support for parsing --help.
	Add documentation strings to command line option tables.
	(display_help): New function: display comman line switches.

Mon Jul 13 16:15:10 1998  John Carr  <jfc@mit.edu>

	* sparc.c, sparc.h, sparc.md: New trampoline code.
	Allow integer operand 1 to V8+ DImode shift instructions.
	Fix bugs in V8+ wide multiply patterns.
	In 32 bit mode, split DImode register moves and logical instructions. 
	Write V9 branch prediction flag.
	Use V9 conditional move more often for scc.

Mon Jul 13 15:10:09 1998  Philippe De Muyter  <phdm@macqel.be>

	* invoke.texi(-fno-builtin): Explain that the names of built-in
	functions begin with `__builtin_', not `__'.

Mon Jul 13 19:01:52 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload1.c (reload_reg_free_before_p): Abort for RELOAD_FOR_OUTPUT.

Mon Jul 13 10:50:17 1998  Mark Mitchell  <mark@markmitchell.com>

	* cplus-dem.c (SCOPE_STRING): Remove DMGL_JAVA stuff.
	(cplus_demangle_opname):  Initialize work.
	(demangle_template): Remove is_java_array.
	(do_type): Remove DMGL_JAVA stuff.
	(long_options): Remove "java".
	(main): Remove 'j' option.

Mon Jul 13 10:19:00 1998  Jeffrey A Law  (law@cygnus.com)

	* mn10300.h (REG_CLASS_FROM_LETTER): Map 'y' to SP_REGS.
	Handle 'x' as NO_REGS for this cpu.
	(REGNO_OK_FOR_BIT_BASE_P): Define.
	(REG_OK_FOR_BIT_BASE_P): Define.
	(GO_IF_LEGITIMATE_ADDRESS): Use them.
	(REG_OK_FOR_INDEX_P): Tweak.
	* mn13000.c (REG_SAVE_BYTES): Define.
	(expand_epilogue, initial_offset): Use it.
	(secondary_reload_class): Slightly reformat.
	(output_tst): Tweak comments.
	* mn10300.md: Change 'x' to 'y' for SP_REGS.  Then add 'x' to many
	patterns.
	(addsi3): Turn into a define_expand/define_insn pair.  Rework code for
	three operand addition case to be more efficient.
	(subsi3): Turn into a define_expand/define_insn pair.

	* expr.c (expand_expr): Only set MEM_IN_STRUCT_P if the memory address
	is not varying for REFERENCE_TYPE or when we think we might have found
	an optimized access to the first element in an array.

Mon Jul 13 02:24:08 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>

	* regclass.c (reg_scan_mark_refs): New arg min_regno.  Only update
	regscan information for REGs with numbers greater than or equal to
	this.  All callers changed.
	(reg_scan_update): New function to efficiently update regscan
	information on the fly.
	* rtl.h: Add prototype.
	* jump.c (jump_optimize): Call it when we make a transformation
	which generates new pseudo-REGs.

Sun Jul 12 13:08:14 1998  Jeffrey A Law  (law@cygnus.com)

	* collect2.c (main): Use "-x c" instead of "-lang-c" for force the
	compiler into C mode.

Sun Jul 12 01:27:05 1998  Jason Merrill  <jason@yorick.cygnus.com>

	* cplus-dem.c (demangle_nested_args): Return a value.

	* tree.h (TYPE_P): New macro.

Sat Jul 11 16:19:48 1998  Mark Mitchell  <mark@markmitchell.com>

	* cplus-dem.c (string): Move definition before work_stuff.
	(work_stuff): Add volatile_type, forgetting_types,
	previous_argument, and nrepeats fields.
	(SCOPE_STRING): New macro.
	(demangle_template): Add `remember' parameter.  Add comment.
	Register the `B' code type here, if remembering.  Tidy.  Fix crash
	on NULL tmpl_argvec.  Be consistent with use of tname/trawname.
	(demangle_nested_args): New function.
	(internal_cplus_demangle): Handle volatile-qualified member
	functions. 
	(mop_up): Delete the previous_argument string if present.
	(demangle_signature): Tidy.  Handle volatile-qualified member
	functions.  Handle back-references using the `B' code.  Use extra
	parameter to demangle_template and SCOPE_STRING where appropriate.
	(demangle_template_value_parm): Fix thinko; 'B' is not an integral
	code. 
	(demangle_class): Use SCOPE_STRING.
	(gnu_special): Pass additional argument to demangle_template.
	Use SCOPE_STRING.
	(demangle_qualified): Save qualified types for later
	back-references.  Handle constructors and destructors for template
	types correctly.
	(do_type): Tidy.  Use SCOPE_STRING.  Pass extra argument to
	demangle_template.  Use demangled_nested_args.  Don't remember
	qualified types here; that's now done in demangle_qualified.
	Similarly for templates.
	(do_arg): Improve commment.  Handle 'n' repeat code.
	(remember_type): Check forgetting_types.
	(demangle_args): Deal with 'n' repeat codes.  Tidy.
	
Sat Jul 11 02:59:08 1998  Richard Earnshaw  <rearnsha@arm.com>

	* arm.md (extendhisi2_mem, movhi, movhi_bytes): Propagate the volatile
	and structure attribute flags to MEMs generated.
	(splits for sign-extended HI & QI mode from memory):  Also propagate 
	the volatile flag.

	* configure.in (thumb-*-coff*): Don't cause fixincludes to be run.

Fri Jul 10 19:06:59 1998  Michael Meissner  <meissner@cygnus.com>

	* varray.h: Include system.h if it hasn't already been included
	before to get size_t declared.

Fri Jul 10 12:53:58 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>

	* jump.c (jump_optimize): If after_regscan and our transformations
	generate new REGs, rerun reg_scan.

Fri Jul 10 11:50:43 EDT 1998  Andrew MacLeod  <amacleod@cygnus.com>

	* config/i960/i960.c (i960_address_cost): MEMA operands with
	positive offsets < 4096 are free.

Fri Jul 10 12:34:37 1998  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* config/m68k/m68k.c (const_uint32_operand): Recognize
	CONSTANT_P_RTX.
	(const_sint32_operand): Likewise. 

Thu Jul  9 22:58:59 1998  Jeffrey A Law  (law@cygnus.com)

	* Makefile.in (alias.o): Depend on $(EXPR_H).

Thu Jul  9 18:24:56 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload1.c (choose_reload_regs): If using an equivalence from
	find_equiv_reg and reg_reloaded_valid is not set for this register,
	clear the associated spill_reg_store.

Thu Jul  9 18:12:49 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload1.c (emit_reload_insns): If an output reload copies only
	to a secondary reload register, indicate that the secondary reload
	does the actual store.

Thu Jul  9 18:01:05 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload.c (find_equiv_reg): If need_stable_sp is set,
	check if stack pointer is changed directly in a PARALLEL.

Thu Jul  9 10:38:14 1998  Jeffrey A Law  (law@cygnus.com)

	* jump.c (duplicate_loop_exit_test): Fix thinko.

Thu Jul  9 01:30:37 1998  Joel Sherrill  <joel@OARcorp.com>
			  Ralf Corsepius <corsepiu@faw.uni-ulm.de>

	* config/i386/rtemself.h: Updated to keep in sync with
	config/i386/linux.h.

	* configure.in: Added sh-rtemself.
	* configure: Rebuilt.
	* config/sh/rtems.h: Removed -D__ELF__ since it is now COFF.
	* config/sh/rtemself.h: New file.

	* config/rs6000/rtems.h: Defined STARTFILE_DEFAULT_SPEC.

Wed Jul  8 21:43:14 1998  Jeffrey A Law  (law@cygnus.com)

	* configure.in: Check if the assembler supports ".balign" and
	".p2align" and define HAVE_GAS_BALIGN_AND_P2ALIGN appropriately.
	* acconfig.h (HAVE_GAS_BALIGN_AND_P2ALIGN): New tag.
	* i386/gas.h (ASM_OUTPUT_ALIGN): If the assembler has support for
	".balign" then use it.

	* print-rtl.c (print_rtx): Revert previous patch.

	* jump.c (duplicate_loop_exit_test): Do not duplicate the loop exit
	test if the exit code has an insn with ASM_OPERANDS.

	* i386/cygwin32.h (STDIO_PROTO): Fix typo.
	* m32r.h (STDIO_PROTO): Fix typo.

	* pa.h (LEGITIMIZE_RELOAD_ADDRESS): Handle addresses created by
	LEGITIMIZE_RELOAD_ADDRESS.
	* tm.texi (LEGITIMIZE_RELOAD_ADDRESS): Note that this macro must be
	able to handle addresses created by previous invocations of the macro.

	* flow.c (find_auto_inc): Remove most recent change.  Real bug was
	elsewhere.

	* cse.c (count_reg_usage): Count registers used in addresses of
	CLOBBERs.

Wed Jul  8 15:08:29 1998  Jim Wilson  <wilson@cygnus.com>

	* Makefile.in (STAGESTUFF): Readd line lost during June 9 FSF merge.

	* configure.in (mips64orion-*-rtems*): Use elf64.h not elfl64.h.

1998-07-08  Vladimir N. Makarov  <vmakarov@cygnus.com>

	* config/fp-bit.c (__gexf2, __fixxfsi, __floatsixf): Add function
	stubs.

	* toplev.c (lang_options): Add -Wlong-long, -Wno-long-long
	options.
	* c-decl.c (warn_long_long): Define.
	(c_decode_option): Parse -Wlong-long, -Wno-long-long options.
	(grokdeclarator): Add flag `warn_long_long' as guard for
	warning "ANSI C does not support `long long'".
	* invoke.texi: Add description of options -Wlong-long,
	-Wno-long-long.
	* gcc.1: The same as above.
	
Wed Jul  8 02:43:34 1998  Jeffrey A Law  (law@cygnus.com)

	* rtlanal.c (reg_overlap_mentioned_p): Handle STRICT_LOW_PART.  If
	either argument is CONSTANT_P, then return zero.
	* reload.c (reg_overlap_mentioned_for_reload_p): Similarly.

	* configure.in: Also look at $srcdir/gas/configure to find a 
	gas version #.

Wed Jul  8 00:28:22 1998  Carlo Wood <carlo@runaway.xs4all.nl>

	* dsp16xx.h : Clean up of macro OPTIMIZATION_OPTIONS

Tue Jul  7 21:18:14 1998  Mumit Khan  <khan@xraylith.wisc.edu>

	* i386/cygwin32.h (ASM_DECLARE_FUNCTION_NAME): Merge duplicate
	definitions from last two patches.

Tue Jul  7 23:03:34 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload1.c (choose_reload_regs): Don't set reload_override_in
	if EQUIV is clobbered in INSN and the reload is done after INSN.

Tue Jul  7 21:23:36 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* expr.c (emit_queue): If emitting a SEQUENCE, set QUEUED_INSN
	to the first insn of the sequence.

Tue Jul  7 21:05:25 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* cse.c (cse_insn): Don't make change without validation.

Tue Jul  7 11:40:05 1998  Jeffrey A Law  (law@cygnus.com)

	* mn10200.md (various zero/sign extension patterns): zero and sign
	extensions which use "sub" clobber cc0.

Tue Jul 7 09:12:08 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Tue Jul  7 10:07:20 1998  Jeffrey A Law  (law@cygnus.com)

	* print-rtl.c (print_rtx): Use REAL_VALUE_TYPE instead of "double".

Tue Jul  7 08:41:27 1998  Richard Henderson  (rth@cygnus.com)

	* print-rtl.c (print_rtx): Only print fp values when REAL_VALUE_TYPE
	is a double.

Tue Jul 7 00:31:58 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Tue Jul  7 01:03:03 1998  Mumit Khan <khan@xraylith.wisc.edu>

	Support for dllimport and dllexport attributes for i386-pe.

	* tree.h (DECL_NON_ADDR_CONST_P): New accessor macro.
	(struct tree_decl): Add non_addr_const_p field.
	* tree.c (staticp): Use.

	* i386/cygwin32.h (CPP_PREDEFINES): Map __declspec(x) to GCC
	attributes.
	(SUBTARGET_SWITCHES): Switches to turn on/off dllimport|export
	attributes. Also accept -mwindows option.
	(VALID_MACHINE_DECL_ATTRIBUTE): New macro.
	(MERGE_MACHINE_DECL_ATTRIBUTE): New macro.
	(REDO_SECTION_INFO_P): New macro.
	(DRECTVE_SECTION_FUNCTION): New macro.
	(drectve_section): Cover function to implement above.
	(SWITCH_TO_SECTION_FUNCTION): New macro.
	(switch_to_section): Covert function to implement above.
	(EXTRA_SECTIONS): Add in_drectve.
	(EXTRA_SECTION_FUNCTIONS): Add in_drectve and switch_to_section.
	(ENCODE_SECTION_INFO): Delete old macro and redefine as a function.
	(STRIP_NAME_ENCODING): Handle new attributes.
	(ASM_OUTPUT_LABELREF): New macro.
	(ASM_OUTPUT_FUNCTION_NAME): New macro.
	(ASM_OUTPUT_COMMON): New macro.
	(ASM_OUTPUT_DECLARE_OBJECT_NAME): New macro.

	* i386/mingw32.h (CPP_PREDEFINES): Map __declspec(x) to GCC
	attributes.

	* i386/winnt.c (i386_pe_valid_decl_attribute_p): New function.
	(i386_pe_merge_decl_attributes): New function.
	(i386_pe_check_vtable_importexport): New function.
	(i386_pe_dllexport_p): New function.
	(i386_pe_dllimport_p): New function.
	(i386_pe_dllexport_name_p): New function.
	(i386_pe_dllimport_name_p): New function.
	(i386_pe_mark_dllexport): New function.
	(i386_pe_mark_dllimport): New function.
	(i386_pe_encode_section_info): New function.
	(i386_pe_unique_section): Strip encoding from name first.

Tue Jul  7 00:50:17 1998  Manfred Hollstein   (manfred@s-direktnet.de)

        * libgcc2.c (L_exit): Provide a fake for atexit on systems which
        define ON_EXIT but not HAVE_ATEXIT.

Tue Jul  7 00:44:35 1998  Franz Sirl <Franz.Sirl-kernel@lauterbach.com>

	* m68k.md (zero_extend QI to HI): Correctly handle TARGET_5200.

Tue Jul  7 00:36:41 1998  Ulrich Drepper <drepper@cygnus.com>

	* i386.c: Remove random whitespace at end of lines.

	* i386.c (ix86_epilogue): For pentium processors, try to deallocate
	4 or 8 byte stacks with pop instructions instead of an add instruction.

Tue Jul  7 00:30:08 1998  Klaus Kaempf <kkaempf@rmi.de>

	* alpha.c: Include tree.h before expr.h.

Mon Jul  6 22:50:48 1998  Jason Merrill  <jason@yorick.cygnus.com>

	* c-parse.in (struct_head, union_head, enum_head): New nonterminals.
	(structsp): Use them.  Update files generated from c-parse.in.
	* extend.texi (Type Attributes): Document it.

	* c-decl.c: Add warn_multichar.
	(c_decode_option): Handle -Wno-multichar.
	* c-lex.c (yylex): Check it.
	* c-tree.h: Declare it.
	* toplev.c (lang_options): Add it.
	* invoke.texi: Document it.

Mon Jul  6 22:47:55 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload.c (find_equiv_reg): When looking for stack pointer + const,
	make sure we don't use a stack adjust.

	* reload.c (find_equiv_reg): If need_stable_sp is set,
	check if stack pointer is changed directly.

	* reload1.c (delete_dead_insn): Don't delete feeding insn
	if that insn has side effects.

	* flow.c (find_auto_inc): Clear UNCHANGING bit of register that is
	changed.

	* reload1.c (reload_reg_free_before_p): RELOAD_FOR_OPADDR_ADDR
	precedes RELOAD_FOR_OUTADDR_ADDRESS.

	* gcse.c (hash_scan_insn): New argument IN_LIBCALL_BLOCK.  Changed
	caller.

Mon Jul  6 22:21:56 1998  Kamil Iskra  <iskra@student.uci.agh.edu.pl>

	* m68k.c (output_scc_di): Use cmpw #0 instead of tstl when
	testing address registers on the 68000.

Mon Jul  6 22:17:19 1998  Alasdair Baird	<alasdair@wildcat.demon.co.uk>

	* i386.c (is_fp_test): Fix thinko.

	* jump.c (jump_optimize) Check for CONST_INT before using INTVAL.

Mon Jul  6 22:14:31 1998  Richard Henderson  (rth@cygnus.com)

	* print-rtl.c (print_rtx): Display the real-value equivalent of
	a const_double when easy.

	* real.h (REAL_VALUE_TO_TARGET_SINGLE): Use a union to pun types.
	Zero memory first for predictability.
	(REAL_VALUE_TO_TARGET_DOUBLE): Likewise.
	* varasm.c (immed_real_const_1): Notice width of H_W_I == double.

	* regclass.c (allocate_reg_info): Initialize the entire reg_data
	virtual array.

Mon Jul  6 22:09:32 1998  Ian Lance Taylor  <ian@cygnus.com>
			  Jeff Law	    <law@cygnus.com>


	* i386/cygwin32.h: Add some declaration of external functions.
 	(ASM_DECLARE_FUNCTION_NAME): Define.
	(ASM_OUTPUT_EXTERNAL, ASM_OUTPUT_EXTERNAL_LIBCALL): Define.
	(ASM_FILE_END): Define.
	* i386/winnt.c (i386_pe_declare_function_type): New function.
	(struct extern_list, extern_head): Define.
	(i386_pe_record_external_function): New function.
	(i386_pe_asm_file_end): New function.

	* cpplib.c (cpp_options_init): Initialize cplusplus_comments to 1,
	matching July 18, 1995 change to cccp.c.  If -traditional then
	disable cplusplus_comments.

Mon Jul  6 21:28:14 1998  Jeffrey A Law  (law@cygnus.com)

	* combine.c (expand_compound_operation): Fix thinko in code to optimize
	(zero_extend:DI (subreg:SI (foo:DI) 0)) to foo:DI.

	* Disable the following change from gcc2.  Not appropriate for egcs:

	Sun Jun  7 09:30:31 1998  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>
        * reload.c (find_reloads): Give preference to pseudo that was the
        reloaded output of previous insn.

Mon Jul  6 21:07:14 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* aclocal.m4 (GCC_FUNC_PRINTF_PTR): Don't define HOST_PTR_PRINTF.
  	Instead, define a new macro HAVE_PRINTF_PTR which only signifies
	whether we have the %p format specifier or not.

	* acconfig.h: Delete stub for HOST_PTR_PRINTF, add HAVE_PRINTF_PTR.
	
	* machmode.h (HOST_PTR_PRINTF): When determining the definition,
 	check HAVE_PRINTF_PTR to see whether "%p" is okay.

	* mips-tfile.c: Include machmode.h to get HOST_PTR_PRINTF.

	* Makefile.in (mips-tfile.o): Depend on machmode.h.

Mon Jul  6 10:42:05 1998  Mark Mitchell  <mark@markmitchell.com>

	* jump.c (duplicate_loop_exit_test): Don't refuse to copy a
	section of code just because it contains
	NOTE_INSN_BLOCK_{BEG,END}.
	* stmt.c (expand_end_loop): Likewise.  Also, don't refuse to 
	move CALL_INSNs or CODE_LABELs.  When moving code, don't move
	NOTE_INSN_BLOCK_{BEG,END}.

Mon Jul  6 09:38:15 1998  Mark Mitchell  <mark@markmitchell.com>

	* cse.c (CSE_ADDRESS_COST): New macro, based on ADDRESS_COST, but 
	dealing with ADDRESSOF.
	(find_best_addr): Use it. 

Mon Jul  6 09:27:08 1998  Richard Henderson  <rth@cygnus.com>

	* alpha/vms.h (TRAMPOLINE_TEMPLATE): Revert last change.

Mon Jul  6 09:25:06 1998  Dave Love  <d.love@dl.ac.uk>

	* libgcc2.c (__eprintf): Make args consistent with prototype in
	assert.h.

Mon Jul  6 00:28:43 1998  Mark Mitchell  <mark@markmitchell.com>

	* cse.c (cse_insn): When SETting (MEM (ADDRESSOF (X))) to Y,
	don't claim that the former is equivalent to the latter.

Sun Jul  5 23:58:19 1998  Jeffrey A Law  (law@cygnus.com)

	* cse.c (cse_insn): Second arg is an RTX now.  Update all callers.
	(cse_basic_block): Keep track of the current RETVAL insn for a
	libcall instead of just noting that we're in a libcall.

	* combine.c (simplify_comparison): Do not commute a AND into
	a paradoxical SUBREG if not WORD_REGISTER_OPERATIONS.

	* i386/freebsd-elf.h (ASM_OUTPUT_MAX_SKIP_ALIGN): Protect with
	HAVE_GAS_MAX_SKIP_P2ALIGN.
	* i386/linux.h: Likewise.
	
Fri Jul  3 02:33:35 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>

	* sparc.c (sparc_operand, move_operand,	arith_operand,
	arith11_operand, arith10_operand, arith_double_operand,
	arith11_double_operand, arith10_double_operand, small_int,
	uns_small_int): Recognize CONSTANT_P_RTX.
	(output_sized_memop, output_move_with_extension,
	output_load_address, output_size_for_block_move,
	output_block_move, delay_operand): Remove, has not been
	enabled or referenced for years.
	* sparc.md (movstrsi, block_move_insn): Likewise.
	* sparc.h (PREDICATE_CODES): Define.
	* linux-aout.h (MACHINE_STATE_{SAVE,RESTORE}): Override with
	version which uses getcc/setcc traps to save/restore condition
	codes.
	* linux64.h: Likewise.
	* sunos4.h: Likewise.
	* linux.h: Likewise.
	* sol2.h: Likewise.
	* sun4o3.h: Likewise.

Fri Jul  3 02:28:05 1998  Richard Henderson  <rth@cygnus.com>

	* alpha.c (alpha_initialize_trampoline): Hack around Pmode/ptr_mode
	lossage on VMS.  Reported by kkaempf@rmi.de.
	* alpha/vms.h (TRAMPOLINE_TEMPLATE): Add missing 0.

Thu Jul  2 17:41:14 1998  Nick Clifton  <nickc@cygnus.com>

	* config/m32r/m32r.h (MUST_PASS_IN_STACK): Override default
	version. 

Thu Jul  2 14:34:48 1998  David Edelsohn  <edelsohn@mhpcc.edu>

	* expr.h (STACK_SIZE_MODE): New macro.
	* explow.c (allocate_dynamic_stack_space): Use it for
	mode of allocate_stack pattern increment operand.
	* tm.texi (STACK_SAVEAREA_MODE, STACK_SIZE_MODE): Document.
	* md.texi (stack_save_block, ...): Reflect use of macro.

	* rs6000.h (PROMOTE_MODE): Always promote to word_mode.
	(PROMOTE_FUNCTION_ARGS): Define.
	(PROMOTE_FUNCTION_RETURN): Define.
	(FUNCTION_VALUE): Promote to word_mode if smaller.
	Convert to gen_rtx_FOO.
	* rs6000.md (call_indirect): Store doubleword in 64-bit mode.
	Convert to gen_rtx_FOO.
	* rs6000.c: Convert to gen_rtx_FOO.
	
Thu Jul  2 14:16:11 1998  Michael Meissner  <meissner@cygnus.com>

	* varray.{c,h}: New files to provide virtual array support.

	* Makefile.in (OBJS): Add varray.o.
	(varray.o): Add new file.
	(REGS_H): New variable for dependencies for files including
	regs.h.  Add varray.h and files it includes.  Change all regs.h
	dependencies to $(REGS_H).

	* toplev.c (x{m,re}alloc): If size is 0, allocate 1 byte.
	(xcalloc): Provide frontend for calloc.
	* {tree,rtl}.h (xcalloc): Add declaration.

	* basic-block.h (REG_BASIC_BLOCK): Convert reg_n_info to be a
	varray.

	* regs.h (toplevel): Include varray.h.
	(reg_n_info): Switch to use a varray.
	(REG_*): Ditto.
	(allocate_reg_info): Change num_regs argument to be size_t.

	* regclass.c (reg_info_data): New structure to remember groups of
	reg_info structures allocated that are to be zeroed.
	({pref,alt}class_buffer): New statics to hold buffers
	allocate_reg_info allocates for {pref,alt}class_buffer.
        (regclass): Use {pref,alt}class_buffer to initialize
        {pref,alt}class.
	(allocate_reg_info): Switch to make reg_n_info use varrays.
	Allocate buffers for the preferred and alter register class
	information.  Change num_regs argument to be size_t, not int.

	* flow.c (reg_n_info): Switch to use varrays.

Thu Jul  2 10:11:47 1998  Robert Lipe  <robertl@dgii.com>

	* install.texi (sco3.2v5): Document new --with-gnu-as flag.
	* config/i386/sco5.h (JUMP_TABLES_IN_TEXT_SECTION): Defined as
	in other targets.
	(USE_GAS): Conditionalize away native assembler usage.
	* config/i386/sco5gas.h: New file.
	* config/i386/t-sco5gas: New file.
	* configure.in (ix86-sco3.2v5*): Use new files if --with-gnu-as

Thu Jul 2 08:20:00 1998  Catherine Moore  <clm@cygnus.com>

        * haifa-sched.c (alloc_EXPR_LIST):  Change to use
        unused_expr_list.

Thu Jul  2 14:13:28 1998  Dave Love  <d.love@dl.ac.uk>

	* Makefile.in (install-info): Don't use $realfile.  Ignore
	possible errors from the install-info program.

Thu Jul  2 01:53:32 1998  Alasdair Baird	<alasdair@wildcat.demon.co.uk>

	* combine.c (simplify_comparison): Apply SUBREG_REG to SUBREGs.

Wed Jul  1 23:06:03 1998  Richard Henderson  <rth@cygnus.com>

	* i386.h (HARD_REGNO_MODE_OK): Kill spurrious test.
	(MODES_TIEABLE_P): Tie SImode and HImode.

1998-07-01  Andreas Jaeger  <aj@arthur.rhein-neckar.de>

	* invoke.texi (Optimize Options): Fix typo.

Wed Jul  1 22:25:43 1998  Jim Wilson  <wilson@cygnus.com>

	* xcoffout.c (xcoffout_begin_function): Call xcoffout_block for
	the zero'th block.

Wed Jul  1 23:12:58 1998  Ken Raeburn  <raeburn@cygnus.com>

	* h8300.c (print_operand): Delete %L support.
	* h8300.md (branch_true, branch_false): Use %= with a prefix
	instead of %L for local branch labels.

Wed Jul  1 21:27:13 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload1.c (emit_reload_insns): Use proper register classes for
	SECONDARY_INPUT_RELOAD_CLASS / SECONDARY_MEMORY_NEEDED code.

Wed Jul  1 21:17:36 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload.c (find_reloads): If there are multiple
	RELOAD_FOR_INPUT_ADDRESS / RELOAD_FOR_OUTPUT_ADDRESS reloads for
	one operand, change RELOAD_FOR_INPADDR_ADDRESS /
	RELOAD_FOR_OUTADDR_ADDRESS for all but the first
	RELOAD_FOR_INPUT_ADDRESS / RELOAD_FOR_OUTPUT_ADDRESS reloads.

Wed Jul  1 17:23:23 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* regmove.c (fixup_match_2): Check that P has RTX_CLASS 'i' before
	using its PATTERN.

Wed Jul  1 05:04:41 1998  Richard Henderson  <rth@cygnus.com>

	* expr.c (emit_group_load, emit_group_store): Rewrite considering
	the size and alignment of the structure being manipulated. 
	* expr.c, calls.c, function.c: Update all callers.
	* expr.h: Update prototypes.
	* cse.c (invalidate): Cope with parallels.

Wed Jul  1 04:22:23 1998  Richard Henderson  <rth@cygnus.com>

	* sparc.c (function_arg_record_value): Take a MODE arg with which to
	create the PARALLEL.  Update all callers.

Wed Jul  1 04:10:35 1998  Richard Henderson  <rth@cygnus.com>

	* expr.c (expand_assignment, store_constructor, expand_expr): Use
	convert_memory_address instead of convert_to_mode when possible.

Wed Jul  1 03:48:00 1998  Richard Henderson  <rth@cygnus.com>

	* alpha.c (alpha_initialize_trampoline): Take arguments describing
	the layout.  Use ptr_mode.  Disable hint generation.  Use gen_imb.
	* alpha.h (INITIALIZE_TRAMPOLINE): Pass extra args to the init func.
	(TRANSFER_FROM_TRAMPOLINE): Move ...
	* alpha/osf.h: ... here.
	* alpha/vms.h (INITIALIZE_TRAMPOLINE): Use alpha_initialize_trampoline.
	(TRANSFER_FROM_TRAMPOLINE): Remove undef.
	* alpha/win-nt.h: Likewise.
	* alpha/vxworks.h: Likewise.

	* alpha/linux.h: Revert gcc2 merge lossage.

Wed Jul  1 10:56:55 1998  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* c-decl.c (grokdeclarator): Don't warn about implicit int in
	`typedef foo = bar'.

Wed Jul  1 02:12:33 1998  Robert Lipe  <robertl@dgii.com>

	* i386.c (asm_output_function_prefix): Make 686 function
	prologues not issue .types for non-global lables.

Tue Jun 30 23:46:53 1998  Dmitrij Tejblum <tejblum@arc.hq.cti.ru>

	* i386/freebsd.h (WCHAR_TYPE): Chagne to an "int".
	(WCHAR_TYPE_SIZE): Update appropriately.

Tue Jun 30 23:16:39 1998  Jeffrey A Law  (law@cygnus.com)

	* flow.c (recompute_reg_usage): Does not return a value.
	* rtl.h (recompute_reg_usage): Update prototype.

	* jump.c (jump_optimize): Show that the jump chain is not
	valid when not optimizing.

Tue Jun 30 16:01:01 1998  Richard Henderson  <rth@cygnus.com>

	* rtl.def (CONSTANT_P_RTX): New.
	* rtl.h (CONSTANT_P): Recognize it.
	* cse.c (fold_rtx): Eliminate it.
	* expr.c (can_handle_constant_p): New variable.
	(init_expr_once): Initialize it.
	(expand_builtin): Generate CONSTANT_P_RTX if the expression is not
	immediately recognizable as a constant.

	* alpha.c (reg_or_6bit_operand): Recognize CONSTANT_P_RTX.
	(reg_or_8bit_operand, cint8_operand, add_operand): Likewise.
	(sext_add_operand, and_operand, or_operand): Likewise.
	(reg_or_cint_operand, some_operand, input_operand): Likewise.
	* alpha.h (PREDICATE_CODES): Add CONSTANT_P_RTX where needed.

1998-06-30  Benjamin Kosnik  <bkoz@bliss.nabi.net>

        * dbxout.c (dbxout_type_methods): Remove warn_template_debugging.

Tue Jun 30 14:03:34 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* aclocal.m4 (GCC_NEED_DECLARATION): Accept an optional second
	argument, which is typically preprocessor code used to draw in
	additional header files when looking for a function declaration.
	(GCC_NEED_DECLARATIONS): Likewise.

	* configure.in (GCC_NEED_DECLARATIONS): Add checks for getrlimit
	and setrlimit, search for them in sys/resource.h.

	* acconfig.h: Add stubs for NEED_DECLARATION_GETRLIMIT and
	NEED_DECLARATION_SETRLIMIT.

	* system.h: Prototype getrlimit/setrlimit if necessary.

Tue Jun 30 10:54:48 1998  Mark Mitchell  <mark@markmitchell.com>

	* rtl.texi: Don't say that RTX_INTEGRATED_P is not depended
	upon.

Tue Jun 30 13:11:42 1998  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* rs6000/sysv4.h (asm output): add tabs for asm directives.

Tue Jun 30 13:11:42 1998  David Edelsohn <edelsohn@mhpcc.edu>

	* Makefile.in (FLAGS_TO_PASS): Set AR_FLAGS to AR_FOR_TARGET_FLAGS.

Tue Jun 30 08:59:15 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* gansidecl.h (ATTRIBUTE_UNUSED): Use __unused__ not `unused'.
  	Don't define NULL here.  Also, remove all vestiges of autoconf
 	based checks for bcmp/bcopy/bzero/index/rindex.

	* system.h: Immediately after including stdio.h, check for and if
	necessary provide a default definition of NULL.

Tue Jun 30 08:22:05 1998  Michael Meissner  <meissner@cygnus.com>

	* reload1.c (reload_cse_simplify_operands): Call
	fatal_insn_not_found, not abort.

Tue Jun 30 02:34:02 1998  Jeffrey A Law  (law@cygnus.com)

	* choose-temp.c (make_temp_file): Accept new argument for the
	file suffix to use.  Allocate space for it and add it to the
	template.
	* mkstemp.c (mkstemps): Renamed from mkstemp.  Accept new argument
	for the length of the suffix.  Update template struture checks
	to handle optinal suffix.
	* collect2.c (make_temp_file): Update prototype.
	(main): Put proper suffixes on temporary files.
	* gcc.c (make_temp_file): Update prototype.
	(do_spec_1): Put proper suffixes on temporary files.

Tue Jun 30 00:56:19 1998  Bruno Haible <haible@ilog.fr>

	* invoke.texi: Document new implicit structure initialization
	warning.

Mon Jun 29 22:12:06 1998  Jeffrey A Law  (law@cygnus.com)

	* Merge from gcc2 June 9, 1998 snapshot.  See ChangeLog.13 for
	details.

	* pa.c, pa.h, pa.md: Convert to gen_rtx_FOO.

Mon Jun 29 20:12:41 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

        * Makefile.in (fix-header): Don't needlessly depend on cpperror.o.

	* alias.c (CHECK_ALIAS_SETS_FOR_CONSISTENCY): Cast expansion to
	void since it is evaluated in a comma list.

	* mips.h (ASM_GENERATE_INTERNAL_LABEL): Always sprintf `NUM'
 	argument as a long and cast `NUM' to long to ensure it is of the
 	proper width.  Wrap macro arguments in parens when they appear in
 	the expansion.

	* sol2.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.

	* sparc.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.
	(ASM_DECLARE_RESULT): Fix fprintf format specifier to match
	function argument return type.
	(REGNO_OK_FOR_INDEX_P, REGNO_OK_FOR_BASE_P, REGNO_OK_FOR_FP_P,
	REGNO_OK_FOR_CCFP_P): Use `(unsigned)' not `U'.

	* cpplib.c (cpp_message_from_errno): Remove unneeded argument to
	cpp_message.

        * dbxout.c: Fix the comments after an #endif to reflect the actual
	condition tested in the preceding #if.

	* except.c (find_all_handler_type_matches): Switch to old-style
 	function definition.

	* expr.c (expand_builtin): Remove unused variable `type' twice.

        * gbl-ctors.h (DO_GLOBAL_CTORS_BODY): Cast -1 before comparing it
 	to an unsigned long.

	* haifa-sched.c (print_insn_chain): Remove unused function.

        * objc/objc-act.c (build_msg_pool_reference): Hide prototype and
	definition.

        * toplev.c: When testing whether to include dbxout.h, also include
	it when XCOFF_DEBUGGING_INFO is defined.

        * unroll.c (unroll_loop): Add parentheses around assignment used
	as truth value.

Mon Jun 29 12:18:00 1998  Catherine Moore  <clm@cygnus.com>

        * config/lb1spc.asm (.div, .udiv): Replace routines.

Mon Jun 29 09:44:24 1998  Mark Mitchell  <mark@markmitchell.com>

	* rtl.h: Update comment about special gen_rtx variants.
	* emit-rtl.c (gen_rtx): Handle MEMs using gen_rtx_MEM.

Sun Jun 28 20:58:51 1998  Jeffrey A Law  (law@cygnus.com)

	* choose-temp.c (choose_temp_base): Restore original variant of
	this function for compatibility.
	(make_temp_file): This is the new, preferred interface to create
	temporary files.
	* collect2.c (choose_temp_base): Delete declaration.
	(make_temp_file): Declare.
	(temp_filename_length, temp_filename): Delete.
	(main): Use make_temp_file to get temporary files.  Use --lang-c
	to force the resulting ctort/dtor file to be compiled with the C
	compiler.  Make sure to remove temporary files on all exit paths.
	* gcc.c (make_temp_file): Provide prototype if MKTEMP_EACH_FILE is
	defined.
	(choose_temp_base): Only provide prototype if MKTEMP_EACH_FILE is
	not defined.
	(do_spec): Use make_temp_file if MKTEMP_EACH_FILE is defined.

Sun Jun 28 08:57:09 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* configure.in (GCC_NEED_DECLARATIONS): Add strerror, getcwd and
	getwd.

	* acconfig.m4: Add stubs for NEED_DECLARATION_STRERROR,
	NEED_DECLARATION_GETCWD and NEED_DECLARATION_GETWD. 

	* cccp.c: Remove strerror()/sys_nerr/sys_errlist decls.
	(my_strerror): Add prototype and make it static.

	* collect2.c: Likewise.

	* cpplib.c: Likewise.

	* gcc.c: Likewise, but keep `my_strerror' extern.

	* protoize.c: Likewise.

	* pexecute.c (my_strerror): Add argument to prototype.

	* system.h: Add prototypes for getcwd, getwd and strerror.  Add
	extern decls for sys_nerr and sys_errlist.  Make abort decl
	explicitly extern.

	* getpwd.c: Remove decls for getwd and getcwd.

Sun Jun 28 02:11:16 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Sat Jun 27 23:32:25 1998  Richard Henderson  <rth@cygnus.com>

	* jump.c (jump_optimize): Use side_effects_p & may_trap_p instead
	of rtx_unsafe_p.  Use modified_between_p instead of reg_set_between_p.
	Allow FP moves to be optimized.
	(rtx_unsafe_p): Delete.

Sat Jun 27 23:02:04 1998  Richard Henderson  <rth@cygnus.com>

	* objc/archive.c: Remove <string.h> prototypes.

Sat Jun 27 22:37:05 1998  Jeffrey A Law  (law@cygnus.com)

	* tm.texi (NEED_MATH_LIBRARY): Document new target macro.

	* Makefile.in (gencheck): Remove $(TREE_H) dependency.

Sat Jun 27 20:20:00 1998  John Carr  <jfc@mit.edu>

	* dsp16xx.h (FIRST_PSEUDO_REGISTER): Add parentheses to definition.
	* dsp16xx.c (next_cc_user_unsigned): New function.
	Remove save_next_cc_user_code.
	(print_operand): Use HOST_WIDE_INT_PRINT_* macros.
	* dsp16xx.md: Call next_cc_user_unsigned instead of using
 	save_next_cc_user_code.
	Use gen_rtx_* functions instead of gen_rtx.

Sat Jun 27 20:18:34 1998  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* rs6000.h: Add trap_comparison_operator to PREDICATE_CODES.

Sat Jun 27 16:45:42 1998  Jeffrey A Law  (law@cygnus.com)

	* flow.c (count_reg_sets): New function.
	(count_reg_sets_1, count_ref_references): Likewise.
	(recompute_reg_usage): Likewise.
	* rtl.h (recompute_reg_usage): Add prototype.
	* toplev.c (rest_of_compilation): Call recompute_reg_usage just
	before local register allocation.

Sat Jun 27 13:15:30 1998  Richard Henderson  <rth@cygnus.com>

	* alpha.md (negsf, negdf): Revert Jan 22 change.

Sat Jun 27 07:35:21 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* mkstemp.c: Include gansidecl.h.  Rename uint64_t to gcc_uint64_t.
	(mkstemp): Remove size specifier for variable `letters'.  Call
	gettimeofday, not __gettimeofday.

	* Makefile.in (EXPR_H): New dependency variable.
	(c-typeck.o): Depend on $(EXPR_H) instead of expr.h.
	(c-iterate.o): Likewise.
	(gencheck): Depend on $(TREE_H) instead of tree.h, etc.
	(stor-layout.o): Depend on $(EXPR_H) instead of expr.h.
	(toplev.o): Likewise.  Also depend on $(RECOG_H) instead of recog.h.
	(varasm.o): Depend on $(EXPR_H) instead of expr.h.
	(function.o): Likewise.
	(stmt.o): Likewise.
	(except.o): Likewise.
	(expr.o): Likewise.
	(calls.o): Likewise.
	(expmed.o): Likewise.
	(explow.o): Likewise.
	(optabs.o): Likewise.
	(sdbout.o): Likewise.
	(dwarf2out.o): Likewise.
	(emit-rtl.o): Likewise.
	(integrate.o): Likewise.
	(jump.o): Likewise.
	(cse.o): Likewise.
	(gcse.o): Likewise.  Also depend on $(BASIC_BLOCK_H) instead of
	basic-block.h.
	(loop.o): Depend on $(EXPR_H) instead of expr.h.
	(unroll.o): Likewise.
	(combine.o): Likewise.
	(reload.o): Likewise.
	(reload1.o): Likewise.
	(caller-save.o): Likewise.
	(reorg.o): Likewise.
	(alias.o): Don't depend on insn-codes.h.
	(regmove.o): Depend on $(RECOG_H)/$(EXPR_H) instead of recog.h/expr.h.
	(insn-emit.o): Depend on $(EXPR_H) instead of expr.h.
	(insn-opinit.o): Likewise.

Sat Jun 27 01:35:14 1998  Jeffrey A Law  (law@cygnus.com)

	* choose-temp.c (choose_temp_base): Remove MPW bits.  Use mkstemp
	instead of mktemp.
	* gcc.c (MKTEMP_EACH_FILE): Define.
	(main): No need to call choose_temp_base if we are going to
	use choose_temp_base to create each file later.
	* mkstemp.c: New file.  Adapted from glibc.
	* Makefile.in (xgcc, colect2, protoize, unprotoize): Link in mkstemp.o
	(mkstemp.o): Add dependencies.

        * configure.in (gettimeofday): Check for its existance.
        * config.in (HAVE_GETTIMEOFDAY): Define.
        * configure: Rebuilt.

1998-06-26  Michael Meissner  <meissner@cygnus.com>

	* rs6000.md (ne 0, non power case): Add missing & constraint.
	Name pattern ne0.
	(negative abs insns): Add pattern names.

Fri Jun 26 17:36:42 1998  Dave Love  <d.love@dl.ac.uk>

	* Makefile.in (install-info): Run install-info program in separate
	loop.

Fri Jun 26 16:03:15 1998  Michael Meissner  <meissner@cygnus.com>

	* haifa-sched.c (schedule_block): Add hooks for the machine
	description to reorder the ready list, and update how many more
	instructions can be issued this cycle.
	* tm.texi (MD_SCHED_{INIT,REORDER,VARIABLE_ISSUE}): Document.
	
Fri Jun 26 11:54:11 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>

	* config/sparc/sparc.h (REGNO_OK_FOR_{INDEX,BASE,FP,CCFP}_P):
	Explicitly mark the constant being compared against as unsigned.
	* config/sparc/sparc.c (sparc_select, cpu_default, cpu_table):
	Fully initialize final members.
	(mem_aligned_8): Explicit init of offset to zero.
	(output_function_prologue): Explicit init of n_regs to zero.
	(output_function_epilogue): Likewise, and mark arg size as
	unused.
	(init_cumulative_args): Mark libname and indirect as unused.
	(function_arg_pass_by_reference): Likewise for cum and named.
	(sparc_builtin_saveregs): Likewise for arglist.
	(sparc_flat_eligible_for_epilogue_delay): Likewise for slot.

Fri Jun 26 06:58:54 1998  Richard Earnshaw (rearnsha@arm.com)

	* arm.h (SECONDARY_INPUT_RELOAD_CLASS): Only need a secondary reload
	if reloading a MEM.

	* arm.h (arm_adjust_cost): Renamed bogus prototype from 
	arm_adjust_code.
	(bad_signed_byte_operand): Add prototype.
	* arm.c (arm_override_options): Make I unsigned.
	(const_ok_for_arm): Add casts to the constants.	
	(load_multiple_operation): Don't redeclare elt in sub-block.
	(arm_gen_movstrqi): Delete external declaration of optimize.
	(gen_compare_reg): Declare parameter fp.

	* arm.c (final_prescan_insn): Only initialize scanbody if the insn
	has a pattern.

Fri Jun 26 09:31:24 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* alpha.c: Include system.h and toplev.h.
	(cint8_operand): Mark parameter `mode' with ATTRIBUTE_UNUSED.
	(const48_operand): Likewise.
	(mode_width_operand): Likewise.
	(mode_mask_operand): Likewise.
	(mul8_operand): Likewise.
	(current_file_function_operand): Likewise.
	(signed_comparison_operator): Likewise.
	(divmod_operator): Likewise.
	(any_memory_operand): Likewise.
	(alpha_return_addr): Likewise for parameter `frame'.
	(alpha_builtin_saveregs): Likewise for parameter `arglist'.
	(vms_valid_decl_attribute_p): Likewise for parameters `decl' and
	`attributes'.
	(alpha_start_function): Likewise for parameter `decl'.  Use
 	HOST_WIDE_INT_PRINT_DEC in call to fprintf.  Fix various format
 	specifiers.  Remove unused variables `lab' and `name'.
	(alpha_end_function): Mark parameter `decl' with ATTRIBUTE_UNUSED.
	(check_float_value): Likewise for parameter `overflow'.
	(alpha_need_linkage): Likewise for parameters `name' and `is_local'.
	
	* alpha.h (ASM_IDENTIFY_GCC, ASM_IDENTIFY_LANGUAGE): Define as
	taking an argument.
	(ASM_OUTPUT_SHORT): Cast argument to `int' in call to fprintf.
	(ASM_OUTPUT_CHAR): Likewise.
	(ASM_OUTPUT_BYTE): Likewise.
	(PRINT_OPERAND_ADDRESS): Use HOST_WIDE_INT_PRINT_DEC in call to
	fprintf.
	(PUT_SDB_EPILOGUE_END): Mention argument `NAME' in definition.
	Add prototypes for functions in alpha.c.

	* alpha.md (ashldi3): Add default case in switch.

1998-06-26  Manfred Hollstein  <manfred@s-direktnet.de>

	* Makefile.in (gcc_version, gcc_version_trigger): New macros.
	(version): Initialize from $(gcc_version).

	* configure.in (version): Rename to gcc_version.
	(gcc_version_trigger): New variable; call AC_SUBST for it and
	emit it into the generated config.status.
	* configure: Regenerate.

Thu Jun 25 12:47:41 1998  Mark Mitchell  <mark@markmitchell.com>

	* fold-const.c (make_range): Don't go looking at TREE_OPERANDs of
	nodes that are not expressions.

Thu Jun 25 15:08:16 1998  Mark Mitchell  <mark@markmitchell.com>

	* invoke.texi (-fstrict-aliasing): Document.
	* rtl.texi (MEM_ALIAS_SET): Document.

	* flags.h (flag_strict_aliasing): Declare.
	* toplev.c (flag_strict_aliasing): Define.
	(f_options): Add -strict-aliasing.
	(main): Set flag_strict_aliasing if -O2 or higher.

	* tree.h (tree_type): Add alias_set field.
	(TYPE_ALIAS_SET): New macro.
	(TYPE_ALIAS_SET_KNOWN_P): Likewise.
	(get_alias_set): Declare.
	* tree.c (lang_get_alias_set): Define.
	(make_node): Initialize TYPE_ALIAS_SET.
	(get_alias_set): New function.
	* print-tree.c (print_node): Dump the alias set for a type.

	* c-tree.h (c_get_alias_set): Declare.
	* c-common.c (c_get_alias_set): New function.
	* c-decl.c (init_decl_processing): Set lang_get_alias_set.

	* expr.c (protect_from_queue): Propogage alias sets.
	(expand_assignment): Calculate alias set for new MEMs.
	(expand_expr): Likewise.
	* function.c (put_var_into_stack): Likewise.
	(put_reg_into_stack): Likewise.
	(gen_mem_addressof): Likewise.
	(assign_parms): Likewise.
	* stmt.c (expand_decl): Likewise.
	* varasm.c (make_decl_rtl): Eliminate redundant clearing of
	DECL_RTL.  Calculate alias set for new MEMs. 

	* rtl.def (REG): Add dummy operand.
	(MEM): Add extra operand to store the MEM_ALIAS_SET.
	* rtl.h (MEM_ALIAS_SET): New macro.
	(gen_rtx_MEM): Declare.
	* emit-rtl.c (gen_rtx_MEM): New function.
	* gengenrtl.c (sepcial_rtx): Make MEMs special.

	* alias.c (CHECK_ALIAS_SETS_FOR_CONSISTENCY): New macro.
	(DIFFERENT_ALIAS_SETS_P): Likewise.
	(canon_rtx): Propogate the alias set to the new MEM.
	(true_dependence): Check the alias sets.
	(anti_dependence): Likewise.
	(output_dependence): Likewise.
	* explow.c (stabilize): Progoate alias sets.
	* integrate.c (copy_rtx_and_substitute): Likewise.
	* final.c (alter_subreg): Make sure not to leave MEM_IN_STRUCT_P
	in an unpredictable state.  Propogate alias sets.
	* reload1.c (reload): Clear MEM_ALIAS_SET for new MEMs about which
	we have no alias information.
	
Thu Jun 25 16:59:18 EDT 1998  Andrew MacLeod  <amacleod@cygnus.com>

	* except.h (CATCH_ALL_TYPE): Definition moved to eh-common.h.
	(find_all_handler_type_matches): Add function prototype.
	* eh-common.h (CATCH_ALL_TYPE): Definition added.
	* except.c (find_all_handler_type_matches): Add function to find all
	runtime type info in the exception table.
	(output_exception_table_entry): Special case for CATCH_ALL_TYPE.

Thu Jun 25 15:47:55 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (xcoffout.o): Depend on toplev.h, output.h and dbxout.h.

	* config/fp-bit.c (_fpmul_parts): Move variables `x', `ylow',
 	`yhigh' and `bit' into the scope in which they are used.
	(_fpdiv_parts): Remove unused variables `low', `high', `r0', `r1',
	`y0', `y1', `q', `remainder', `carry', `d0' and `d1'.

	* rs6000.c: Move include of output.h below tree.h.  Include toplev.h.
	(any_operand): Mark unused parameters `op' and `mode' with
	ATTRIBUTE_UNUSED. 
	(count_register_operand): Likewise for parameter `mode'.
	(fpmem_operand): Likewise.
	(short_cint_operand): Likewise.
	(u_short_cint_operand): Likewise.
	(non_short_cint_operand): Likewise.
	(got_operand): Likewise.
	(got_no_const_operand): Likewise.
	(non_add_cint_operand): Likewise.
	(non_logical_cint_operand): Likewise.
	(mask_operand): Likewise.
	(current_file_function_operand): Likewise.
	(small_data_operand): Likewise for parameters `op' and `mode' but
	only when !TARGET_ELF.
	(init_cumulative_args): Mark parameters `libname' with
 	ATTRIBUTE_UNUSED.
	(function_arg_pass_by_reference): Likewise for parameters `cum',
	`mode' and `named'.
	(expand_builtin_saveregs): Likewise for parameter `args'.
	(load_multiple_operation): Likewise for parameter `mode'.
	(store_multiple_operation): Likewise.
	(branch_comparison_operator): Likewise.
	(secondary_reload_class): Likewise.
	(print_operand): Add parentheses around & operation.
	(output_prolog): Mark parameter `size' with ATTRIBUTE_UNUSED.
	(output_epilog): Likewise.  Cast argument to fprintf to int.
	(rs6000_adjust_cost): Mark parameter `dep_insn' with ATTRIBUTE_UNUSED.
	(rs6000_valid_decl_attribute_p): Likewise for parameters `decl',
	`attributes', `identifier' and `args'.
	(rs6000_valid_type_attribute_p): Likewise for parameter `attributes'.
	(rs6000_comp_type_attributes): Likewise for parameters `type1' and
	`type2'.
	(rs6000_set_default_type_attributes): Likewise for parameter `type'.

	* rs6000.h (RTX_COSTS): Add parentheses around & operation.
	(toc_section, private_data_section, trap_comparison_operator): Add
	prototypes.

	* dbxout.h (dbxout_parms, dbxout_reg_parms, dbxout_syms): Add
	prototypes.

	* xcoffout.c: Include toplev.h, outout.h and dbxout.h.

	* xcoffout.h (stab_to_sclass, xcoffout_begin_function,
	xcoffout_begin_block, xcoffout_end_epilogue,
	xcoffout_end_function, xcoffout_end_block,
	xcoff_output_standard_types, xcoffout_declare_function,
	xcoffout_source_line): Add prototypes.

Thu Jun 25 09:54:55 1998  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.h (REG_ALLOC_ORDER): Add ARG_POINTER_REGNUM,
	noticed by grahams@rcp.co.uk.

Thu Jun 25 11:12:29 1998  Dave Brolley  <brolley@cygnus.com>

	* gcc.c (default_compilers): Use new | syntax to eliminate
	string concatenation.

Thu Jun 25 01:00:48 1998  Richard Henderson  <rth@cygnus.com>

	* alpha.c (alpha_function_name): Delete.
	(alpha_ra_ever_killed): Notice current_function_is_thunk.
	(alpha_sa_mask, alpha_sa_size, alpha_does_function_need_gp): Likewise.
	(alpha_start_function): Reorg from output_prologue.
	(alpha_end_function): Reorg from output_epilogue.
	* alpha.h (ASM_DECLARE_FUNCTION_NAME): Call alpha_start_function.
	(ASM_DECLARE_FUNCTION_SIZE): New.
	(FUNCTION_PROLOGUE, FUNCTION_EPILOGUE): Delete.
	(PROFILE_BEFORE_PROLOGUE): Set.
	(ASM_OUTPUT_MI_THUNK): Remove bits now output by start/end_function.
	* alpha/win-nt.h (ASM_OUTPUT_MI_THUNK): Likewise.

Thu Jun 25 01:18:47 1998  John Wehle  (john@feith.com)

	* i386/freebsd-elf.h (ASM_OUTPUT_MAX_SKIP_ALIGN): Define.

1998-06-25 Herman A.J. ten Brugge <Haj.Ten.Brugge@net.HCC.nl>

	* expr.c (expand_assignment): Rework address calculation for structure
	field members to expose more invariant computations to the loop
	optimizer.
	(expand_expr): Likewise.

Wed Jun 24 22:44:22 1998  Jeffrey A Law  (law@cygnus.com)

	* local-alloc.c (block_alloc): Do not try to avoid false dependencies
	when SMALL_REGISTER_CLASSES is nonzero.

Wed Jun 24 17:55:15 1998  Klaus Kaempf  <kkaempf@progis.de>

	* alpha.md (call_vms, call_value_vms): Strip leading * from symbol.

Wed Jun 24 16:27:23 1998  John Carr  <jfc@mit.edu>

	* expr.c (get_memory_rtx): New function.
	(expand_builtin): Call get_memory_rtx for MEM arguments to builtin
	string functions.

	* expmed.c (init_expmed): Initialize all elements of *_cost arrays.

	* optabs.c: Use gen_rtx_FOO (...) instead of gen_rtx (FOO, ...).
	* expr.c: Likewise.
	* explow.c: Likewise.
	* combine.c: Likewise.
	* reload1.c: Likewise.
	* gcse.c: Likewise.

Wed Jun 24 15:13:01 1998  Dave Brolley  <brolley@cygnus.com>

	* README.gnat: Add patch for new lang_decode_options interface.

Wed Jun 24 09:14:04 EDT 1998  Andrew MacLeod  <amacleod@cygnus.com>

	* except.c (start_catch_handler): Do nothing if EH is not on.

1998-06-24  Manfred Hollstein  <manfred@s-direktnet.de>

	* configure.in (gxx_include_dir): Initialize default value depending on
	new flag --enable-version-specific-runtime-libs; remove superfluous
	default initialization afterwards.
	* configure: Regenerate.

Wed Jun 24 01:32:12 1998  David S. Miller  <davem@pierdol.cobaltmicro.com>

	* toplev.c (rest_of_compilation): Revert May 15 change.

Tue Jun 23 21:27:27 1998  Ken Raeburn  <raeburn@cygnus.com>

	* reload.c (find_reloads): Fix check for failure to match any
	alternative, to account for Mar 26 change in initial "best" cost.

Tue Jun 23 16:44:21 1998  Dave Brolley  <brolley@cygnus.com>

	* cpplib.c (do_line): Typo broke #line directive.
	(cpp_message_from_errno): New function.
	(cpp_error_from_errno): Call cpp_message_from_errno.
	* cpplib.h (cpp_message_from_errno): New function.

Tue Jun 23 13:38:18 EDT 1998  Andrew MacLeod  <amacleod@cygnus.com>

	* libgcc2.c (__get_eh_table_version, __get_eh_table_language): New
	functions to return exception descriptor information.
	(find_exception_handler): Pass match_info field to runtime matcher,
	not a descriptor table entry.

Tue Jun 23 09:30:58 1998  Dave Love  <d.love@dl.ac.uk>

	* cpp.texi, gcc.texi: Add @dircategory, @direntry meant to
	accompany previous Makefile.in (install-info) change.

Tue Jun 23 10:06:07 EDT 1998  Andrew MacLeod  <amacleod@cygnus.com>

	* eh-common.h (struct __eh_info): Remove coerced value field.
	* libgcc2.c (find_exception_handler): Don't set coerced_value field.
	* except.c (get_dynamic_handler_chain, get_dynamic_cleanup_chain): Use 
	POINTER_SIZE instead of Pmode.
	(expand_start_all_catch): Call start_catch_handler() if we are not
	using new style exceptions.

Tue Jun 23 06:45:00 1998  Catherine Moore  <clm@cygnus.com>

        * varasm.c (assemble_variable): Remove reference to warn_bss_align.

Mon Jun 22 23:57:31 1998  David S. Miller <davem@pierdol.cobaltmicro.com>

	* config/sparc/sparc.md (zero_extendhidi2, extendhisi2,
	extendqihi2, extendqisi2, extendqidi2, extendhidi2, adddi3,
	subdi3, negdi2, call, call_value, untyped_return, nonlocal_goto,
	splits and peepholes): Change remaining generic gen_rtx calls to
	specific genrtl ones.
	* config/sparc/sparc.c: Likewise.
	
Mon Jun 22 22:21:46 1998  Richard Henderson  <rth@cygnus.com>

	* gcc.c (handle_braces): Recognize | between options as an or.

Mon Jun 22 23:13:47 1998  John Wehle  (john@feith.com)

	* i386/freebsd-elf.h (JUMP_TABLES_IN_TEXT_SECTION): Define as flag_pic.
	* i386/sysv4.h (JUMP_TABLES_IN_TEXT_SECTION): Define as flag_pic.

	* i386.md (exception_receiver): Define.

Mon Jun 22 12:01:48 1998  Jim Wilson  <wilson@cygnus.com>

	* Makefile.in (PROTOIZE_INSTALL_NAME, UNPROTOIZE_INSTALL_NAME,
	PROTOIZE_CROSS_NAME, UNPROTOIZE_CROSS_NAME): New variables.
	(install-common): Use them.

	* gcse.c (add_label_notes): New function.
	(pre_insert_insn): Call it.
	* unroll.c (unroll_loop): Look for insns with a REG_LABEL note, and
	pass the label to set_label_in_map.

Mon Jun 22 19:01:14 1998  Dave Love  <d.love@dl.ac.uk>

	* Makefile.in (install-info): Fix typpo in previous change.

Mon Jun 22 11:10:00 1998  Catherine Moore  <clm@cygnus.com>

        * varasm.c (assemble_variable):  Emit alignment warning.

Mon Jun 22 08:18:46 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (varasm.o): Depend on sdbout.h.
	(sdbout.o): Depend on toplev.h.

	* collect2.c (scan_prog_file): Cast fprintf argument to `long' and
	use %ld specifier.

	* final.c (shorten_branches): Cast first arg of `bzero' to char *.

	* genextract.c (main): When creating insn-extract.c, mark variable
	`i' with ATTRIBUTE_UNUSED.

	* genpeep.c (main): When creating insn-peep.c, mark variables
	`insn', `x' and `pat' with ATTRIBUTE_UNUSED.

	* objc/init.c (__objc_tree_print): Wrap function definition in
	macro `DEBUG'.

	* objc/objc-act.c (encode_array): Cast sprintf argument to `long'
	and use %ld specifier.
	(adorn_decl): Likewise, twice.

	* reload1.c (reload_cse_regs): Cast first arg of `bzero' to char *.

	* sdbout.c: Include output.h and toplev.h.
	(PUT_SDB_INT_VAL): Use HOST_WIDE_INT_PRINT_DEV to print argument
	`a'.  Cast `a' to HOST_WIDE_INT to force it to always be so.
	(PUT_SDB_SIZE): Likewise.

	* sdbout.h (sdbout_mark_begin_function): Add prototype.

	* stmt.c (check_for_full_enumeration_handling): Cast argument of
	`warning' to long and use %ld specifier.

	* toplev.c (main): Likewise for `fprintf'.

	* toplev.h (output_file_directive): Add prototype.

	* unroll.c (unroll_loop): Use HOST_WIDE_INT_PRINT_DEC specifier in
	call to `fprintf'.
	(precondition_loop_p): Likewise.

	* varasm.c Include sdbout.h.
	(assemble_static_space): Move sometimes-unused variable `rounded'
	into the scope in which it is used. 
	
	* mips.c (gpr_mode): Don't say `static' twice.

	* cpplib.c (cpp_handle_option): Don't pass unneeded NULL to cpp_fatal.

	* objc/objc-act.c (init_selector): Hide prototype and definition.

	* optabs.c (gen_cond_trap): Remove unused variable `icode'.
	
	* regmove.c (copy_src_to_dest): Likewise for `i'.

	* mips-tfile.c (add_local_symbol): Cast width format specifier to int.
	(add_ext_symbol): Likewise.
	(add_file): Likewise.
	(parse_def): Likewise.
	(write_varray): Use HOST_PTR_PRINTF to print a pointer.  Fix
	remaining format specifiers and arguments.
	(write_object): Likewise, several times.
	(read_seek): Likewise.
	(out_of_bounds): Likewise.
	(allocate_cluster): Likewise.
	(xmalloc): Likewise.
	(xcalloc): Likewise.
	(xrealloc): Likewise.
	(xfree): Likewise.

	* mips-tdump.c (print_symbol): Likewise.
	
Sun Jun 21 17:05:34 1998  Dave Love  <d.love@dl.ac.uk>

	* Makefile.in (install-info): Use install-info program if
	available, per GNU standard.

Sun Jun 21 18:56:44 1998  Jeffrey A Law  (law@cygnus.com)

	* invoke.texi: Document -mrelax for the mn10300 and mn10200.

	* basic-block.h (init_regset_vector): Delete declaration.
	* flow.c (init_regset_vector): Make it static and add a prototype.

	* bitmap.h (debug_bitmap): Declare.

	* haifa-sched.c (debug_ready_list): Make static.

	* toplev.h (fancy_abort): Declare.

Sun Jun 21 18:30:13 1998  H.J. Lu  (hjl@gnu.org)

	* basic-block.h (init_regset_vector): New declaration.

	* Makefile.in (sdbout.o): Add insn-codes.h to dependency.

	* global.c: Include machmode.h amd move hard-reg-set.h before
	rtl.h.

	* haifa-sched.c (insn_issue_delay, birthing_insn_p,
	adjust_priority, print_insn_chaino): New declaration.
	(schedule_insns): Remove declaration.
	(init_target_units, get_visual_tbl_length,
	init_block_visualization): Add prototype.

	* integrate.c (pushdecl, poplevel): Remove declaration.

	* rtl.h (expand_expr): Remove declaration.

	* loop.c (oballoc): Remove declaration.
	(replace_call_address): Add prototype.

Sun Jun 21 01:08:17 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Sun Jun 21 01:16:38 1998  John Wehle  (john@feith.com)

	* i386.c (output_fp_conditional_move): Don't bother handling
	(cc_prev_status.flags && CC_NO_OVERFLOW) since the INSN patterns
	prevent this from happening.

	* i386.md (nonlocal_goto_receiver): Delete.

Sun Jun 21 00:42:20 1998  H.J. Lu  (hjl@gnu.org)

	* Makefile.in (crtbeginS.o, crtendS.o): Add -fno-exceptions and
	-DCRTSTUFFS_O.
	(INSTALL): cd $(srcdir) before make.

	* flow.c (allocate_for_life_analysis, init_regset_vector):
	Remove declaration.

	* function.h (get_first_block_beg): New declaration.

	* gbl-ctors.h (__do_global_dtors): Add prototype.

	* gcov-io.h (__fetch_long): New declaration.
	(__store_long): Likewise.
	(__read_long): Likewise.
	(__write_long): Likewise.

	* gcov.c (print_usage): New declaration.

	* Makefile.in (c-iterate.o): Depend on insn-codes.h too.

Sat Jun 20 00:36:16 1998  Jeffrey A Law  (law@cygnus.com)

	* calls.c (expand_call): Initialize "src" and "dest".
	* stmt.c (expand_return): Likewise.
	* expmed.c (extract_split_bit_field): Similarly for "result"
	* gcse.c (compute_hash_table): Mark first arg as unused.
	* jump.c (jump_optimize): Initialize reversep.
	* tree.c (make_node): Initialize length.

	* c-common.c (check_format_info): Initialize length_char and
	fci to keep -Wall quiet.

	* except.c (jumpif_rtx): Put declaration and definition
	inside a suitable #ifdef.
	(jumpifnot_rtx): Delete dead function.

	* i386.h (output_int_conditional_move): Declare.
	(output_fp_conditional_move): Likewise.
	(ix86_can_use_return_insn_p): Likewise.

	* optabs.c (init_traps): Put prototype inside a suitable #ifdef.

Sat Jun 20 00:27:40 1998  Graham  <grahams@rcp.co.uk>

	* alias.c: Include toplev.h
	* caller-save.c: Include toplev.h
	* combine.c: Include toplev.h
	* flow.c Include toplev.h
	* global.c: Include toplev.h
	* jump.c: Include toplev.h
	* local-alloc.c: Include toplev.h
	* loop.c: Include toplev.h
	* regmove.c: Include toplev.h
	* stupid.c: Include toplev.h
	* unroll.c: Include toplev.h
	* Makefile.in: Add toplev.h dependencies.

Fri Jun 19 22:40:25 1998  Jason Merrill  <jason@yorick.cygnus.com>

	* regmove.c (copy_src_to_dest): Add decl for loop_depth.

	* svr4.h (ASM_GENERATE_INTERNAL_LABEL): Cast arg to unsigned.
	* dwarf2out.c (ASM_OUTPUT_DWARF_DATA1): Likewise.
	Add parens to various macros.

Fri Jun 19 23:22:42 1998  Bruno Haible  <bruno@linuix.mathematik.uni-karlsruhe.de>

	* c-typeck.c (pop_init_level): Warn about implicit zero initialization
	of struct members.

Fri Jun 19 23:06:33 1998  Jason Merrill  <jason@yorick.cygnus.com>

	* varasm.c (assemble_start_function): Add weak_global_object_name.
	* tree.c (get_file_function_name): Use it.

Fri Jun 19 22:55:14 1998  Jeffrey A Law  (law@cygnus.com)

	* except.c (jumpif_rtx): Make static and add prototype.
	(jumpifnot_rtx): Likewise.

	* README.gnat: Add a build patch from Fred Fish.

	* c-lang.c (GNU_xref_begin, GNU_xref_end): Deleted.

	* Makefile.in (c-iterate.o): Depend on expr.h.

Fri Jun 19 20:38:34 1998  H.J. Lu  (hjl@gnu.org)

	* except.h (emit_unwinder, end_eh_unwinder): Removed.

	* dwarfout.c (getpwd): Add prototype.
	(is_pseudo_reg, type_main_variant, is_tagged_type,
	is_redundant_typedef): New declaration.
	(output_decl): Add prototype for FUNC.
	(type_main_variant): Make it static.
	(is_tagged_type): Likewise.
	(is_redundant_typedef): Likewise.

	* expr.c (do_jump_by_parts_greater_rtx): Removed.
	(truthvalue_conversion): Likewise.

	* c-iterate.c: Include "expr.h".
	(expand_expr): Use proper values when calling the function.

	* explow.c (emit_stack_save): Add prototype for FCN.
	(emit_stack_restore): Likewise.

	* dwarf2out.c (getpwd): Add prototype.

	* dwarf2out.h (debug_dwarf, debug_dwarf_die): New declarations.

	* c-typeck.c (c_expand_asm_operands): Use proper values when calling
	expand_expr.

	* c-lex.c (yyprint): Add prototype.
	(check_newline, build_objc_string): Remove declaration.

	* c-tree.h (comptypes_record_hook): Removed.
	(finish_incomplete_decl): New prototype.

	* alias.c (find_base_value): Add prototype.
	(true_dependence): Add prototype for function argument.

	* c-aux-info.c (xmalloc): Remove declaration.

Fri Jun 19 20:23:05 1998   Robert Lipe  <robertl@dgii.com>

        * i386.c: Include system.h.   Remove redundant includes.
        (optimization_options): Mark param 'size' with ATTRIBUTE_UNUSED.
        (i386_cc_probably_useless_p): Likewise for 'decl', 'attributes',
        'identifier', 'args'.
        (i386_valid_type_attribute_p): Likewise for 'attributes'.
        (i386_comp_type_attribute_p): Likewise for 'type1', 'type2'.
        (function_arg_partial_nregs): Likewise for 'cum', 'mode', 'type',
        and 'named'.
        (symbolic_operand): Likewise for 'mode'.
        (call_insn_operand): Likewise.
        (expander_call_insn_operand): Likewise.
        (ix86_logical_operator): Likewise.
        (ix86_binary_operator_ok): Likewise.
        (emit_pic_move): Likewise.
        (VOIDmode_compare_op): Likewise.
        (is_mul): Likewise.
        (str_immediate_operand): Likewise.
        (ix86_uary_operator_ok): Likewise for 'code', 'mode', and 'operands'.yy
        (asm_output_function_prefix): Likewise for 'name'.
        (function_prologue): Likewise for 'file', and 'size'.
        (function_epilogue): Likewise.

1998-06-19  Jim Wilson  <wilson@cygnus.com>

	* loop.h (struct induction): Clarify comment for unrolled field.
	* unroll.c (find_splittable_givs): Move set of unrolled field
	after address validity check.

Fri Jun 19 18:38:04 1998  Michael Meissner  <meissner@cygnus.com>

	* config/fp-bit.c (INLINE): Only define if not already defined.

1998-06-19  Manfred Hollstein  <manfred@s-direktnet.de>

	* Makefile.in (installdirs): Loop over directories in $(libsubdir)
	creating probably missing ones, instead of single if statements.

Fri Jun 19 10:43:52 1998  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* c-common.c (truthvalue_conversion): Protect side effects in the
	expression when splitting a complex value.
	* fold-const.c (fold): Likewise. 

Fri Jun 19 02:31:16 1998  Klaus Kaempf (kkaempf@progis.de)

	* cccp.c (hack_vms_include_specification): rewrite to handle
	'#include <dir/file.h>' correctly.

Fri Jun 19 02:24:11 1998  H.J. Lu  (hjl@gnu.org)

	* config/i386/linux.h (ASM_OUTPUT_MAX_SKIP_ALIGN): Defined.

Fri Jun 19 02:10:10 1998  John Wehle  (john@feith.com)

	* i386.c (notice_update_cc): Integer conditional moves don't
	affect cc0.

	* i386.md (movsfcc, movdfcc, movxfcc): Use emit_store_flag
	to support LT, LE, GE, and GT signed integer comparisons.
	(movsfcc+1, movsfcc+2, movdfcc+1, movdfcc+2,
	movxfcc+1, movxfcc+2): Pattern doesn't match if the comparison
	is LT, LE, GE, or GT.
	(movdicc): Remove code resulting from an earlier patch which
	didn't apply correctly.

Fri Jun 19 02:00:19 1998  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* reload1.c (reload_cse_regno_equal_p): If -ffloat-store, don't
	consider a MEM in FP mode as equal.

Fri Jun 19 01:02:17 1998  Jeffrey A Law  (law@cygnus.com)

	* c-decl.c (duplicate_decls): Avoid setting TREE_ASM_WRITTEN for
	duplicate declarations of a function.

Fri Jun 19 00:33:33 1998  H.J. Lu  (hjl@gnu.org)

	* config/float-i386.h: New.

	* configure.in (i[34567]86-*-linux-*): Set float_format to i386.

Thu Jun 18 20:11:00 1998  Jim Wilson  <wilson@cygnus.com>

	* sched.c (schedule_insns): Use xmalloc not alloca for max_uid
	indexed arrays.  Call free at the end of the function for them.
	* haifa-sched.c (schedule_insns): Likewise.

Thu Jun 18 18:16:01 1998  Jim Wilson  <wilson@cygnus.com>

	* dwarf2out.c (size_of_string): Do count backslashes.

Thu Jun 18 11:43:54 1998  Nick Clifton  <nickc@cygnus.com>

	* config/arm/thumb.h (GO_IF_LEGITIMATE_ADDRESS): Disallow REG+REG 
	addressing when one register is the frame pointer or stack
	pointer.  Disallow REG+CONST addressing in HI mode.

Thu Jun 18 17:30:39 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload.c (find_reloads): Don't narrow scope of RELOAD_OTHER to
	RELOAD_FOR_INSN.

Thu Jun 18 09:36:50 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (c-lang.o): Depend on output.h.

	* c-lang.c: Include output.h.

	* sparc.c (sparc_builtin_saveregs): Remove unused variable `fntype'.

	* except.c (expand_builtin_eh_stub): Likewise for variable `jump_to'.

	* genrecog.c (write_subroutine): When writing insn-recog.c, mark
	variables `insn', `pnum_clobbers', `x[0 .. max_depth]' and `tem'
	with ATTRIBUTE_UNUSED.

	* regmove.c (copy_src_to_dest): Make function static to match its
	prototype.

	* reload1.c Include hard-reg-set.h before rtl.h to get macro
	HARD_CONST.  Include machmode.h before hard-reg-set.h.

	* rtl.h: Prototype `retry_global_alloc' and wrap with macro
	HARD_CONST to protect usage of typedef HARD_REG_SET.

	* tree.c: Prototype `_obstack_allocated_p'.

	* varasm.c: Wrap prototype of `asm_output_aligned_bss' in macro
	BSS_SECTION_ASM_OP.

Thu Jun 18 09:20:47 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* pa.c: Include system.h and toplev.h.  Remove redundant code.
	(call_operand_address): Mark parameter `mode' with ATTRIBUTE_UNUSED.
	(symbolic_operand): Likewise.
	(symbolic_memory_operand): Likewise.
	(pic_label_operand): Likewise.
	(fp_reg_operand): Likewise.
	(pre_cint_operand): Likewise.
	(post_cint_operand): Likewise.
	(ireg_or_int5_operand): Likewise.
	(int5_operand): Likewise.
	(uint5_operand): Likewise.
	(int11_operand): Likewise.
	(uint32_operand): Likewise.
	(ior_operand): Likewise.
	(lhs_lshift_cint_operand): Likewise.
	(pc_or_label_operand): Likewise.
	(legitimize_pic_address): Likewise.
	(hppa_legitimize_address): Likewise for parameter `old'.
	(output_block_move): Likewise for parameter `size_is_constant'.
	(output_function_prologue): Likewise for parameter `size'.
	(output_function_epilogue): Likewise.
	(return_addr_rtx): Likewise for parameter `count'.
	(output_mul_insn): Likewise for parameter `unsignedp'.
	(hppa_builtin_saveregs): Likewise for parameter `arglist'.
	(output_bb): Likewise for parameter `operands'.
	(output_bvb): Likewise.
	(function_label_operand): Likewise for parameter `mode'.
	(plus_xor_ior_operator): Likewise.
	(shadd_operand): Likewise.
	(non_hard_reg_operand): Likewise.
	(eq_neq_comparison_operator): Likewise.
	(movb_comparison_operator): Likewise.
	(pa_combine_instructions): Likewise for parameter `insns'.

	* pa.h: Add prototypes for functions `output_deferred_plabels',
 	`override_options', `output_ascii', `output_function_prologue',
 	`output_function_epilogue', `print_operand',
 	`symbolic_expression_p', `reloc_needed', `compute_frame_size',
 	`hppa_address_cost', `and_mask_p', `symbolic_memory_operand',
 	`pa_adjust_cost', `pa_adjust_insn_length' and
 	`secondary_reload_class'.

Wed Jun 17 22:28:48 1998  Jason Merrill  <jason@yorick.cygnus.com>

	* configure.in: Don't turn on collect2 unconditionally.

Wed Jun 17 20:20:48 1998  Mark Mitchell  <mark@markmitchell.com>

	* cse.c (cse_basic_block): Don't include NOTE insns in the count
	that is used to decide whether or not it is time to erase the
	equivalence table.

Wed Jun 17 18:30:43 1998 Franz Sirl <Franz.Sirl-kernel@lauterbach.com> 

        * rs6000/linux.h (JUMP_TABLES_IN_TEXT_SECTION): Define to zero.

Wed Jun 17 19:05:03 1998  John Carr  <jfc@mit.edu>

	* haifa-sched.c (haifa_classify_insn): TRAP_IF is risky.
	(sched_analyze_2): Allow scheduling TRAP_IF.

	* reorg.c (mark_referenced_resources): Examine operands of TRAP_IF.

	* rtl.h (TRAP_CODE): New macro.

	* rtl.def (TRAP_IF): Change second operand type to rtx.

	* optabs.c (gen_cond_trap): New function.
	(init_traps): New function.
	(init_optabs): Call init_traps.
	* expr.h: Declare gen_cond_trap.

	* jump.c (jump_optimize): Optimize jumps to and around traps.

	* sparc.md: Define trap instructions.

	* rs6000.md: Define trap instructions.
	* rs6000.c (print_operand): New code 'V' for trap condition.
	(trap_comparison_operator): New function.

	* m88k.md: Update use of TRAP_IF.

	* tree.h (enum built_in_function): New function code BUILT_IN_TRAP.
	* c-decl.c (init_decl_processing): New builtin __builtin_trap.
	* expr.c (expand_builtin): Handle BUILT_IN_TRAP.

	* expr.c (expand_builtin): Error if __builtin_longjmp second argument
	is not 1.

Wed Jun 17 15:20:00 PDT 1998  Catherine Moore  <clm@cygnus.com>

         * reload1.c (spill_hard_reg):  Check mode of register when
         spilling from scratch_list.
 
Wed Jun 17 16:25:38 EDT 1998  Andrew MacLeod  (amacleod@cygnus.com)

	* except.c (add_new_handler): fix bug in finding last region handler.
	* libgcc2.c (find_exception_handler): Pass exception table pointer
	to runtime type matcher, not the match info field.

Wed Jun 17 15:57:48 EDT 1998  Andrew MacLeod  (amacleod@cygnus.com)

	* eh-common.h (struct eh_context): Add comment for hidden use of
	field dynamic_handler_chain.
	* except.c (get_dynamic_handler_chain): Comment on, and use the
	correct offset of the dynamic_handler_chain field.

1998-06-17 12:46:56 1998  Jim Wilson  <wilson@cygnus.com>

	* mips/iris6.h (LINK_SPEC): Add -woff 131.

1998-06-17  Jason Merrill  <jason@yorick.cygnus.com>

	* dwarf2out.c: Disable EH_FRAME_SECTION if we don't have .init.

	* configure.in: Don't disable collect2 when we have GNU ld.

Wed Jun 17 08:38:13 1998  Jeffrey A Law  (law@cygnus.com)

	* fold-const.c (make_range): Do not widen the type of the expression.

	* expr.c (check_max_integer_computation_mode): New function.
	(expand_expr): Avoid integer computations in modes wider than
	MAX_INTEGER_COMPUTATION_MODE.
	* fold-const.c (fold): Likewise.
	* tree.h (check_max_integer_computation_mode): Declare.
	* tm.texi (MAX_INTEGER_COMPUTATION_MODE): Document it.

	* configure.in (nm): Make a link to "nm" in the build tree too.

	* mn10300.md (andsi3): Fix typo.

Tue Jun 16 22:58:40 1998  Richard Henderson  <rth@cygnus.com>

	* reload1.c (reload_cse_regs): Call bzero instead of looping.

Tue Jun 16 18:30:35 1998  Jim Wilson  <wilson@cygnus.com>

	* dwarf2out.c (stripattributes): Prepend '*' to the section name.

Tue Jun 16 16:49:26 1998  Richard Henderson  <rth@cygnus.com>

	* alpha.c (alpha_expand_prologue, alpha_expand_epilogue): New fns.
	(output_prologue, output_epilogue): Merge VMS and OSF versions;
	Remove anything related to the actual code generation.
	(output_end_prologue): New function.
	(alpha_sa_mask, alpha_sa_size): Merge VMS and OSF versions.
	(alpha_does_function_need_gp): Return false for VMS.
	(alpha_function_needs_gp): Make static.
	(add_long_const): Delete.
	(summarize_insn): Don't assume a SUBREG is of a REG.
	Prototype all static functions.  Rename VMS-specific global
	variables vms_*.
	* alpha.h (TARGET_CAN_FAULT_IN_PROLOGUE): Default to 0.
	(FUNCTION_BOUNDARY): Align to cache line.
	(LOOP_ALIGN, ALIGN_LABEL_AFTER_BARRIER): Align to octaword.
	(FUNCTION_END_PROLOGUE): New macro.
	* alpha.md (attribute length): New.  Mark all insns.
	(return_internal, prologue_stack_probe_loop) New patterns.
	(prologue, init_fp, epilogue): New patterns.
	Disable peepholes.
	* linux.h (TARGET_CAN_FAULT_IN_PROLOGUE): Define.

Tue Jun 16 17:36:35 1998  Dave Brolley  <brolley@cygnus.com>

	* toplev.c (lang_options): Add -trigraphs option for cpplib.

Tue Jun 16 23:33:24 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload1.c (reload_reg_free_before_p): RELOAD_FOR_OUTADDR_ADDRESS
	is earlier than RELOAD_FOR_OUTPUT_ADDRESS; RELOAD_FOR_INPADDR_ADDRESS
	is earlier than RELOAD_FOR_INPUT_ADDRESS.

Tue Jun 16 13:15:16 1998  Jim Wilson  <wilson@cygnus.com>

	* libgcc1-test.c (memcpy): Define.

Tue Jun 16 13:44:02 1998  Michael Meissner  <meissner@cygnus.com>

	* genattrtab.c (struct attr_desc): Change int flags to bit
	fields.  Add bit fields for this being function_units_used
	or *_blockage_range attributes.
	(write_unit_name): New function to print a function unit name
	given unit #.
	(expand_units): Indicate whether this is function_units_used or
	*_blockage_range attributes.
	(write_toplevel_expr): Print function_units_used and
	*_blockage_range attributes in a more friendly fashion.
	(make_internal_attr): Indicate whether this attribute is either
	function_units_used or *_blockage_range.

Mon Jun 15 17:06:43 1998  Michael Meissner  <meissner@cygnus.com>
			  Jim Wilson  <wilson@cygnus.com>

	* regmove.c (copy_src_to_dest): Do not copy src to dest if either
	the source or destination is special.

Mon Jun 15 13:20:33 1998  Jim Wilson  <wilson@cygnus.com>

	* c-decl.c (shadow_tag_warned): Use specs not declspecs in for loop.

Mon Jun 15 07:16:29 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Sat Jun 13 13:10:40 1998  Krister Walfridsson <cato@df.lth.se>

	* config/sparc/netbsd.h (DEFAULT_PCC_STRUCT_RETURN): Undefine before
	redefining it.

Fri Jun 12 18:06:45 1998  Doug Evans  <devans@egcs.cygnus.com>

	* m32r/m32r.h (STARTFILE_SPEC): Delete crtsysc.o.
	(ENDFILE_SPEC): Add -lgloss.

Fri Jun 12 14:57:59 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* mips.c (small_int): Mark parameter `mode' with ATTRIBUTE_UNUSED.
	(large_int): Likewise.
	(pc_or_label_operand): Likewise.
	(call_insn_operand): Likewise.
	(consttable_operand): Likewise.
	(m16_uimm3_b): Likewise.
	(m16_simm4_1): Likewise.
	(m16_nsimm4_1): Likewise.
	(m16_simm5_1): Likewise.
	(m16_nsimm5_1): Likewise.
	(m16_uimm5_4): Likewise.
	(m16_nuimm5_4): Likewise.
	(m16_simm8_1): Likewise.
	(m16_nsimm8_1): Likewise.
	(m16_uimm8_1): Likewise.
	(m16_nuimm8_1): Likewise.
	(m16_uimm8_m1_1): Likewise.
	(m16_uimm8_4): Likewise.
	(m16_nuimm8_4): Likewise.
	(m16_simm8_8): Likewise.
	(m16_nsimm8_8): Likewise.
	(m16_usym8_4): Likewise.
	(m16_usym5_4): Likewise.
	(mips_move_1word): Change type of variable `i' from int to size_t.
	(mips_move_2words): Likewise.
	(output_block_move): Mark parameter `libname' with ATTRIBUTE_UNUSED.
	(function_arg_advance): Use HOST_PTR_PRINTF to print an address.
	(function_arg): Likewise.
	(function_arg_partial_nregs): Mark parameter `named' with
 	ATTRIBUTE_UNUSED.
	(override_options): Use ISDIGIT instead of isdigit.
	(mips_output_external): Mark parameter `file' with ATTRIBUTE_UNUSED.
	(final_prescan_insn): Likewise for parameters `opvec' and `noperands'.
	(save_restore_insns): Cast HOST_WIDE_INT arguments passed to
	function `fatal' to long before printing.  Use
	HOST_WIDE_INT_PRINT_DEC in fprintf.  Both changes done several
	times in this function.
	(function_prologue): Mark parameter `size' with ATTRIBUTE_UNUSED.
	(function_epilogue): Likewise for parameters `file' and `size'.
	Print an int with "%d" not "%ld".
	(mips_select_rtx_section): Mark parameter `x' with ATTRIBUTE_UNUSED.
	(mips_function_value): Likewise for parameter `func'.
	(function_arg_pass_by_reference): Likewise for parameters `cum'
	and `named'.
	(extend_operator): Likewise for parameter `mode'
	(highpart_shift_operator): Likewise.

	* mips.md (mul_acc_si): Remove unused variable `macc'.

Fri Jun 12 09:33:44 1998  Richard Henderson <rth@cygnus.com>

	* fold-const.c (fold): Revert last change.  It breaks constant
	expressions somehow.

Fri Jun 12 10:23:36 1998  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* expr.c (do_jump, case EQ_EXPR, NE_EXPR): When comparing complex
	prevent operands from being evaluated twice.

Fri Jun 12 00:50:27 1998  Sergey Okhapkin <sos@prospect.com.ru>

	* toplev.c (lang_options): Add -remap as a preprocessor option.

Fri Jun 12 00:30:32 1998  John Wehle  (john@feith.com)

	* i386.md (cmpsi_1, cmphi_1, cmpqi_1): Remove code
	which set CC_REVERSED since reload should ensure that
	the operands are already the correct type.

Thu Jun 11 17:14:15 1998  Jim Wilson  <wilson@cygnus.com>

	* except.c (expand_builtin_eh_stub): Call emit_move_insn rather than
	calling gen_rtx_SET.

Thu Jun 11 18:45:49 1998  David Edelsohn  <edelsohn@mhpcc.edu>

	* config/rs6000/x-aix43 (AR): Delete.
	(AR_FOR_TARGET_FLAGS): Add -X32_64 here.

Thu Jun 11 16:19:17 1998  David W. Schuler  <schuld@btv.ibm.com>

	* config/i386/aix386ng.h (CPP_SPEC): Remove extraneous quote.

Thu Jun 11 12:40:27 1998  Jim Wilson  <wilson@cygnus.com>

	* mips.c (override_options): Replace word_mode with explicit
	TARGET_64BIT check.

Thu Jun 11 14:50:02 1998  Michael Meissner  <meissner@cygnus.com>

	* regmove.c (regmove_optimize): If we can't replace the
	destination in an insn that sets the source, generate an explicit
	move of the source to the destination.
	(copy_src_to_dest): New function.
	(toplevel): Include basic-block.h

	* Makefile.in (regmove.o): Add basic-block.h dependencies.

Thu Jun 11 10:30:09 1998  Dave Brolley  <brolley@cygnus.com>

	* toplev.c (lang_options): Add missing options (nostdinc, idirafter).

Wed Jun 10 23:39:32 1998  Mark Mitchell  <mark@markmitchell.com>

	* rtl.h (rtx_def): Improve documentation.
	(MEM_IN_STRUCT_P): Likewise.

Wed Jun 10 23:23:17 1998  Graham  <grahams@rcp.co.uk>

	* c-decl.c (start_decl): Correct test for -Wmain.

	* c-decl.c (grokdeclarator): Remove unused variable "last".

Wed Jun 10 14:52:27 1998  Jim Wilson  <wilson@cygnus.com>

	* expr.c (expand_builtin_setjmp): Store const1_rtx in target.
	(expand_builtin_longjmp): Abort if value isn't const1_rtx.
	Delete code storing value in static_chain_rtx.
	(expand_builtin, case BUILT_IN_LONGJMP): Pass NULL_RTX for target
	to second expand_expr call.

Wed Jun 10 13:08:41 1998  Mark Mitchell  <mark@markmitchell.com>

	* mips/mips.c: Remove -mabi=o32 and -mabi=n64.

Wed Jun 10 13:41:23 1998  Dave Brolley  <brolley@cygnus.com>

	* cppmain.c (fatal): New function.
	* configure.in (cpp_main): New configuration variable.
	* configure: Regenerated.
	* Makefile.in (CCCP): Use a configuration variable to select basex
	for cccp.
	(cppmain$(exeext)): Add @extra_cpp_objs@.

Wed Jun 10 13:07:02 1998  Dave Brolley  <brolley@cygnus.com>

	* objc/objc-act.c: Add cpplib declarations.
	(lang_decode_option): Initialize cpplib if necessary.
	(lang_decode_option): New argc/argv interface. 
	* tree.h (lang_decode_option): New argc/argv interface. 
	* toplev.c (lang_options): Add cpp options.
	(main): New interface for lang_decode_option.
	* gcc.c (default_compilers): Don't call cpp for a cpplib-enabled C compiler
	unless -E, -M or -MM is specified.
	* cpplib.h (cpp_handle_option): New function. 
	* cpplib.c (cpp_handle_option): New function.
	(cpp_handle_options): Now calls cpp_handle_option.
	* c-tree.h (c_decode_option): New argc/argv interface. 
	* c-lex.c (init_parse): cpplib now initialized in c_decode_option.
	* c-lang.c (lang_decode_option): New argc/argv interface.
	* c-decl.c: Add cpplib declarations.
	(c_decode_option): New argc/argv interface.
	(c_decode_option): Call cpp_handle_option.
	(c_decode_option): Now returns number of strings processed.

Wed Jun 10 09:47:13 1998  Richard Earnshaw (rearnsha@arm.com)

	* unroll.c (verify_addresses): Use validate_replace_rtx to undo the 
	changes.  Abort if the undo fails.

1998-06-10  Vladimir N. Makarov  <vmakarov@cygnus.com>

	* config/rs6000/rs6000.c (output_prolog): Change locations and
	directions of saving and restoring arguments of main on the stack.

Wed Jun 10 08:56:27 1998  John Carr  <jfc@mit.edu>

	* reload1.c (reload_cse_simplify_operands): Do not call gen_rtx_REG
	for each alternative.  Do not replace a CONST_INT with a REG unless
	the reg is cheaper.

Wed Jun 10 02:11:55 1998  Jeffrey A Law  (law@cygnus.com)

	* decl.c (init_decl_processing): Fix typo.

	* mips.c (gpr_mode): New variable.
	(override_options): Initialize gpr_mode.
	(compute_frame_size): Use "gpr_mode" instead of "word_mode" to
	determine size and offset of general purpose registers save slots.
	(save_restore_insns, mips_expand_prologue): Similarly.

	* reload.c (find_reloads_toplev): Use gen_lowpart common to convert
	between constant representations when we have (SUBREG (REG)) with
	REG equivalent to a constant.

Wed Jun 10 01:39:00 1998  Juha Sarlin <juha@c3l.tyreso.se> 

	* h8300.c (get_shift_alg): Add special cases for shifts of 8 and 24.

Tue Jun  9 22:05:34 1998  Richard Henderson  <rth@cygnus.com>

	* fold-const.c (fold): Even with otherwise constant trees, look for
	opportunities to combine integer constants.

Wed Jun  3 23:41:24 EDT 1998  John Wehle  (john@feith.com)

	* i386.c (notice_update_cc): Clear cc_status.value2 in the
	case of UNSPEC 5 (bsf).

	* i386.md (movsfcc, movdfcc, movxfcc): The floating point
	conditional move instructions don't support signed integer
	comparisons.

Tue Jun  9 14:31:19 1998  Nick Clifton  <nickc@cygnus.com>

	* config/v850/t-v850 (TCFLAGS): Add assembler options to warn of
	overlfows. 

	* config/v850/lib1funcs.asm (__return_interrupt): Use 'addi
	16,sp,sp' ratehr than 'add 16,sp'.  Patch courtesy of Biomedin
	<glctr@abc.it>.

Tue Jun  9 16:23:13 EDT 1998  Andrew MacLeod  <amacleod@cygnus.com>

	* except.c (expand_start_catch): Rename to start_catch_handler.
	(expand_end_catch): Delete function.
	(expand_end_all_catch): Remove catch status that expand_end_catch
	use to do.
	* except.h (expand_start_catch): Rename prototype.
	(expand_end_catch): Delete prototype.

Tue Jun  9 12:57:32 1998  Mark Mitchell  <mark@markmitchell.com>

	* invoke.texi: Add documentation for -mips4 and -mabi=*.

Tue Jun  9 12:12:34 1998  Klaus Kaempf (kkaempf@progis.de)

	* alpha/vms.h (EXTRA_SECTIONS): Add in_ctors and in_dtors.
	(EXTRA_SECTION_FUNCTIONS): Add ctors_section and dtors_section.       
	(ASM_OUTPUT_CONSTRUCTOR, ASM_OUTPUT_DESTRUCTOR): Define.                

Tue Jun  9 12:10:27 1998  John Carr  <jfc@mit.edu>

        * haifa-sched.c (update_flow_info): Use UNITS_PER_WORD, not MOVE_MAX,
        as the threshold to permit splitting memory operations.

Tue Jun  9 12:36:16 1998  Jeffrey A Law  (law@cygnus.com)

	* mips.c (gpr_mode): New variable.
	(override_options): Initialize gpr_mode.
	(compute_frame_size): Use "gpr_mode" instead of "word_mode" to
	determine size and offset of general purpose registers save slots.
	(save_restore_insns, mips_expand_prologue): Similarly.

	* Makefile.in (LIB2FUNCS_EH): Define.  Just "_eh" for now.
	(LIBGCC2_CFLAGS): Remove -fexceptions.
	(LIB2FUNCS): Remove "_eh".
	(libgcc2.a): Iterate over LIB2FUNCS_EH and build everything in
	it with -fexceptions.

	* Makefile.in (local-alloc.o): Depend on insn-attr.h.
	* local-alloc.c (block_alloc): Avoid creating false 
	dependencies for targets which use instruction scheduling.

Tue Jun  9 02:40:49 1998  Richard Henderson  <rth@cygnus.com>

	* mips/elf.h (ASM_DECLARE_OBJECT_NAME): Define.
	(ASM_FINISH_DECLARE_OBJECT): Define;
	* mips/elf64.h: Likewise.

Tue Jun  9 01:08:47 1998  Richard Henderson  <rth@cygnus.com>

	* toplev.c (flag_new_exceptions): Remove extraneous `extern'.

Mon Jun 8 23:24:48 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Mon Jun  8 23:24:58 1998  David Edelsohn  <edelsohn@mhpcc.edu>

	* rs6000.md (mulsidi3): Add !TARGET_POWERPC64 constraint.
	(mulsidi3_ppc64): Delete.

Mon Jun  8 20:57:40 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (varasm.o): Depend on dbxout.h.
	(cse.o): Depend on toplev.h and output.h.
	(gcse.o): Depend on output.h.

	* mips.c: Include system.h and toplev.h and remove redundant code.
	Include output.h after tree.h so all its prototypes get activated.
	* mips.md (table_jump): Remove unused variable `dest'.

	* sparc.h: Add prototype for `v8plus_regcmp_op'.

	* crtstuff.c (fini_dummy, init_dummy): Mark function definitions
	with __attribute__ ((__unused__)).
	(__frame_dummy): Provide prototype before use, wrap it with
	EH_FRAME_SECTION_ASM_OP.

	* cse.c: Move inclusion of <setjmp.h> above local headers.
  	Include toplev.h and output.h.

	* dbxout.h: Add prototype for `dbxout_begin_function'.

	* final.c (final_scan_insn): Wrap variable `max_skip' in macro
	ASM_OUTPUT_MAX_SKIP_ALIGN.

	* gcse.c: Include system.h and output.h.
	(dump_cuid_table, dump_rd_table, dump_cprop_data, dump_pre_data):
	Make extern instead of static.
	(compute_can_copy): Only declare variables `reg' and `insn' when
 	AVOID_CCMODE_COPIES is not defined.
	(record_set_info): Mark parameter `setter' with ATTRIBUTE_UNUSED.
	(hash_scan_clobber): Likewise for `x' and `insn'.
	(hash_scan_call): Likewise.
	(record_last_set_info): Likewise for `setter'.
	(mark_call): Likewise for `pat'.
	(pre_insert_insn): Wrap variable `note' in macro HAVE_cc0.

	* libgcc2.c (__bb_init_prg): Replace bzero with memset and fix the
 	length parameter so that it multiplies the number of elements by
 	the sizeof(element).

	* output.h: Add prototype for `weak_finish'.

	* recog.h: Likewise for `validate_replace_src'.

	* rtl.h: Likewise for `optimize_save_area_alloca',
 	`fix_sched_param', `purge_addressof', `gcse_main',
 	`regmove_optimize', `dbr_schedule', `branch_prob' and
 	`end_branch_prob'.

	* toplev.h: Likewise for `set_float_handler' and
 	`output_quoted_string'.

	* varasm.c: Include dbxout.h.

Mon Jun  8 18:12:06 1998  Jim Wilson  <wilson@cygnus.com>

	* mips.c (mips_secondary_reload_class): Use gp_reg_p instead of
	GP_REG_P.  Use gr_regs instead of GR_REGS.

Mon Jun  8 16:54:12 1998  Ken Raeburn   <raeburn@cygnus.com>
                          Jeff Law      <law@cygnus.com>

	* Revamped multiply support for MIPS chips.
	* mips.c (extend_operator): New function.
	(highpart_shift_operator): Likewise.
	* mips.h: Declare new functions.
	(PREDICATE_CODES): Add support for new predicates.
	* mips.md (mulsi3 expander): Simplify.
	(mulsi_mult3): Add another constraint alternative.  Support
	3 operand multiply instructions as found on various mips
	parts.
	(mulsi3_r4650): Delete pattern, now handled by mulsi_mult3.
	(mul_acc_si): New pattern and associated splitters.
	(mulsidi3 expander): Rework to use mulsidi3_64bit and
	mulsidi3_internal.
	(umulsidi3): New expander.
	(mulsidi3_internal): Accept either sign or zero extended
	operands and generate code as appropriate appropriately.
	(mulsidi3_64bit): Similarly.
	(smulsi3_highpart): Turn into an expander and generate code
	to match new patterns.
	(umulsi3_highpart): Likewise.
	(xmulsi3_highpart_internal): New pattern.
	(maddi patterns): Delete.  Replace with:
	(mul_acc_di, mul-acc_64bit_di): New patterns.

Mon Jun  8 14:16:15 EDT 1998  Andrew MacLeod  <amacleod@cygnus.com>

	* eh-common.h: Remove NEW_EH_MODEL compile time flag, and replace with
	flag_new_exceptions runtime flag.
	(struct old_exception_table): New struct which represents what
	the exception table looks like without the new model.
	(NEW_EH_RUNTIME): New value used as a tag in the exception table to
	flag that this is a new style table.
	* except.h: Remove compile time flag NEW_EH_MODEL.
	(expand_builtin_eh_stub_old): New prototype.
	* tree.h (enum built_in_function): Add BUILT_IN_EH_STUB_OLD.
	* expr.c (expand_builtin): New builtin func BUILT_IN_EH_STUB_OLD.
	* c-decl.c (init_decl_processing): Add new builtin function
	__builtin_eh_stub_old.
	* final.c (final_scan_insn): Replace compile time flag NEW_EH_MODEL.
	* flags.h (flag_new_exceptions): New runtime flag.
	* toplev.c (flag_new_exceptions): Initialize default to 0, 
	-fnew-exceptions sets to 1.
	* except.c (output_exception_table_entry): Output New style exception 
	identifier into table, and replace compile time flag NEW_EH_MODEL
	with runtime flag flag_new_exceptions.
	(output_exception_table): Replace compile time flag NEW_EH_MODEL.
	(expand_builtin_eh_stub_old): Duplicates original functionality of
	expand_builtin_eh_stub.
	(expand_builtin_eh_stub): Replace compile time flag NEW_EH_MODEL.
	* libgcc2.c (find_exception_handler): Remove NEW_EH_MODEL #ifdefs.
	(old_find_exception_handler): New func, same as find_exception_handler
	except it works on the old style exception table.
	(__throw): Replace NEW_EH_MODEL. Detect new model based on presence
	of identifier in the exception table, and call appropriate routines.

Mon Jun  8 01:21:13 1998  Jason Merrill  <jason@yorick.cygnus.com>

	* function.c: Define current_function_cannot_inline.
	(push_function_context_to): Save it.
	(pop_function_context_from): Restore it.
	* function.h (struct function): Provide it a home.
	* output.h: Declare it.
	* integrate.c (function_cannot_inline_p): Check it.

Mon Jun  8 10:43:15 1998  Richard Henderson  <rth@cygnus.com>

	* expr.c (force_operand): Detect PIC address loads before 
	splitting arithmetic.

Mon Jun 8 09:22:38 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Mon Jun  8 02:55:56 1998  Graham  <grahams@rcp.co.uk>

	* tree.c (tree_class_check): Add braces to eliminate ambigious
	else warning.
	(tree_check): Likewise.

Mon Jun  8 02:49:23 1998  H.J. Lu  (hjl@gnu.org)

	* reg-stack.c (subst_stack_regs_pat): Make sure the top of
	stack is the destination for conditional move insn.

Mon Jun  8 01:21:13 1998  Jason Merrill  <jason@yorick.cygnus.com>

	* tree.h (TREE_VEC_END): Cast unused value to void.

	* i386.c (print_operand): Use %lx for long operand.

Mon Jun  8 00:04:07 1998  Richard Henderson  <rth@cygnus.com>

	* alpha.c (summarize_insn): Ignore rtl slot format 'i'.

Sun Jun  7 14:15:45 1998  John Carr  <jfc@mit.edu>

	* sol2.h (INIT_SUBTARGET_OPTABS): Use Solaris libc float/long long
	conversion functions.

Sun Jun  7 14:02:58 1998  Richard Henderson  <rth@cygnus.com>

	* toplev.c (flag_exceptions): Default to 0.
	(compile_file): Remove flag_exceptions == 2 hack.
	(main): Call lang_init_options.
	* tree.h: Declare it.
	* c-lang.c: Implement it.
	* objc/objc-act.c: Likewise.
	
Sun Jun  7 12:27:30 1998  David Edelsohn  <edelsohn@mhpcc.edu>

	* rs6000.md (restore_stack_block): Generate MEM and specify mode.
	* rs6000.h (STACK_SAVEAREA_MODE): SAVE_FUNCTION is VOIDmode.
	* rs6000.c (rs6000_output_load_toc_table): Use fputs.
	(output_function_profiler): Use asm_fprintf and fputs.

Sat Jun  6 12:17:12 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* gencheck.c: Remove redundant stdio.h include.  Add a definition
 	of xmalloc for when we are forced to link with alloca.o.

	* reload1.c (reload_reg_free_for_value_p): Use `(unsigned)1'
	instead of `1U'.

	* fold-const.c (constant_boolean_node): Make definition static to
	match the prototype.

Fri Jun  5 15:53:17 1998  Per Bothner  <bothner@cygnus.com>

	* gcc.c (lang_specific_pre_link):  New LANG_SPECIFIC_DRIVER function.
	(lang_specific_extra_outfiles):  New LANG_SPECIFIC_DRIVER variable.
	(do_spec, input_filename, input_filename_length):  Make public.
	(main):  Adjust outfiles allocation by lang_specific_extra_outfiles.
	Call lang_specific_pre_link befor elinking.

Fri Jun  5 12:29:28 1998  Jeffrey A Law  (law@cygnus.com)

	* haifa-sched.c (rank_for_schedule): For "equally good insns", prefer
	the insn which has the most insns dependent on it.

Fri Jun  5 09:03:22 1998  John Carr  <jfc@mit.edu>

	* alias.c (find_base_value): Avoid reading past	end of reg_base_value.

Fri Jun  5 03:05:34 1998  Richard Henderson  <rth@cygnus.com>

	* alpha.md (insxh-1): New insxl pattern for combine.

Fri Jun  5 01:12:15 1998  H.J. Lu  (hjl@gnu.org)

	* i386/i386.c (output_fp_conditional_move): New function
	to output floating point conditional move.
	(output_int_conditional_move): New function to output integer
	conditional move.

	* i386/i386.md (movsicci+5, movhicc+5, movdicc+5): Call
	output_int_conditional_move () to output int conditional move.
	(movsfcc+5, movdfcc+5, movxfcc+5): Call
	output_fp_conditional_move () to output floating point
	conditional move.

	* i386/i386.c (put_condition_code): In INT mode, check
	cc_prev_status.flags & CC_NO_OVERFLOW for GE and LT.

Thu Jun  4 16:09:51 1998  Dave Brolley  <brolley@cygnus.com>

	* dbxout.c (dbxout_type): Output arrays of bits as if
	they were bitstrings for Chill

Thu Jun  4 14:35:27 1998  David Edelsohn  <edelsohn@mhpcc.edu>

	* tree.c (get_inner_array_type): New function.
	* tree.h (get_inner_array_type): Prototype.
	* expr.h (STACK_SAVEAREA_MODE): New macro.
	* expr.c (expand_builtin_setjmp): Initialize sa_mode using
	STACK_SAVEAREA_MODE.
	(expand_builtin_longjmp): Likewise.
	* explow.c (emit_stack_save): Likewise.
	(allocate_dynamic_stack_space): Use Pmode not insn_operand_mode.

	* rs6000/aix41.h (ASM_CPU_SPEC): Define relative to ASM_DEFAULT_SPEC.
	(CPP_CPU_SPEC): Define relative to CPU_DEFAULT_SPEC.
	* rs6000/aix43.h: New file.
	* rs6000/t-aix43: New file.
	* rs6000/x-aix41: New file.
	* rs6000/x-aix43: New file.
	* configure.in (rs6000-ibm-aix*): Use them.
	* rs6000/powerpc.h: Delete.
	* rs6000/sysv4.h: Move necessary powerpc.h definitions to here.
	* rs6000/netware.h: and here.
	* rs6000/win-nt.h: and here.

	* rs6000/rs6000.c (processor_target_table, 620): Do not affect
	MASK_POWERPC64.
	(rs6000_override_options): Ignore flag_pic for AIX.
	(rs6000_immed_double_const): Delete.
	(u_short_cint_operand): Don't assume 32-bit CONST_INT.
	(reg_or_u_short_operand): Don't assume 32-bit CONST_INT.
	(num_insns_constant): mask64_operand() is 2 insns.
	(logical_operand): Don't assume 32-bit CONST_INT.
	(non_logical_cint_operand): Don't assume 32-bit CONST_INT.
	(easy_fp_constant): Any CONST_DOUBLE_HIGH is okay for 64-bit.
	(mask_constant): HOST_WIDE_INT parameter.
	(non_and_cint_operand): Delete.
	(mask64_operand): New function.
	(and64_operand): New function.
	(function_arg_advance): DImode arguments do not need special
	alignment when 64-bit.
	(function_arg): Likewise.
	(setup_incoming_varargs): Reverse reg_size assignment.
	(print_operand): HOST_WIDE_INT second parameter.
	(print_operand, 'B'): New case.
	(print_operand, 'M'): Fix typo in lossage string.
	(print_operandm 'S'): New case.
	(rs6000_stack_info): Reverse reg_size assignment.  Use total_raw_size
	to compute AIX push_p.  Use reg_size to compute {cr,lr}_save_offset.
	(rs6000_output_load_toc_table): Reverse init_ptr assignment.  Use
	TARGET_64BIT not TARGET_POWERPC64.  Convert fprintf to fputs.
	Load GOT highpart, don't add it.  Add lowpart with {cal|la}.
	(rs6000_allocate_stack_space): Use {cal|la}.
	(output_epilog): Use {cal|la}
	(output_function_profiler): Add call glue to mcount call.
	Load GOT highpart, don't add it.  Add lowpart with {cal|la}.

	* rs6000/rs6000.h (TARGET_SWITCHES): Add powerpc64.
	(STACK_BOUNDARY): Depend on TARGET_32BIT.
	(ADJUST_FIELD_ALIGN): Calculate array alignment using innermost type.
	(CONST_OK_FOR_LETTER_P): Don't assume 32-bit CONST_INT.
	(EXTRA_CONSTRAINTS): Remove NT 'S' and 'T'.  Replace 'S' with
	64-bit mask operand.
	(RS6000_SAVE_TOC): Depend on TARGET_32BIT.
	(STACK_SAVEAREA_MODE): New macro.
	(LEGITIMATE_CONSTANT_P): DImode okay for 64bit.
	(LEGITIMIZE_RELOAD_ADDRESS): New macro.
	(RTX_COSTS, AND/IOR/XOR): Reflect current machine description.
	(ASM_FILE_START): Emit 64-bit ABI directive.
	(ASM_DECLARE_FUNCTION_NAME): Align CSECT on doubleword in 64-bit mode.
	(ASM_OUTPUT_SPECIAL_POOL_ENTRY): DImode okay for 64-bit.
	(PREDICATE_CODES): Add "and64_operand" and "mask64_operand".
	Delete "non_and_cint_operand".  "input_operand" includes CONST_DOUBLE.

	* rs6000/rs6000.md (iorsi3, xorsi3): Use HOST_WIDE_INT for mask.
	Restore define_splits.
	(floatsidf2, floatunssidf2): Remove !TARGET_POWERPC64 final constraint.
	(floatsidf2_internal, floatunssidf2_internal2): Likewise.
	Do not specify base register operand mode.
	(floatsidf2_loadaddr): Do not specify base register operand mode.
	(floatsidf2_store1, floatsidf2_store2): Operand 1 must be base
	register; do not specify mode.  Remove !TARGET_POWERPC64 final
	constraint.
	(floatsidf2_load): Do not specify base register operand mode.  Remove
	!TARGET_POWERPC64 final constraint.
	(fix_truncdfsi2_internal, fix_truncdfsi2_{store,load}): Do not specify
	base register operand mode.
	(adddi3): Split large constants early.
	(absdi3): Shift by 63, not 31.
	(*mulsidi3_ppc64): New pattern.
	(rotldi3): Add masking combiner patterns.
	(anddi3): Add rldic{r,l} masking.  Remove split of large constants
	because PPC insns zero-extend.
	(iordi3, xordi3): Split large constants early.
	(movsi matcher): Remove S and T constraints.
	(movsf const_double): create SImode constant from TARGET_DOUBLE.
	(movdf_hardfloat32): Add default abort() case.
	(movdf easy_fp_const): create DImode constant from TARGET_DOUBLE.
	(movdi): Remove 64-bit constant generator.  Try to convert
	CONST_DOUBLE to CONST_INT.  Handle TOC memory constants.
	(movdi_32): Add default abort() case.
	(movdi_64): Add numerous ways to split 64-bit constants.
	Make catch-all define_split more optimal and never FAIL.
	(movti_ppc64): Add default abort() case.
	(allocate_stack): Remove operand modes.  Use Pmode.
	(restore_stack_block): Remove operand modes.  Generate Pmode
	temporary.
	(save_stack_nonlocal, restore_stack_nonlocal):  Generate Pmode
	temporary.  Save area is double Pmode.
	(call_indirect_aix64, call_value_indirect_aix64): New patterns.
	(call, call_value): Do not specify address operand mode.  Choose
	appropriate AIX ABI.
	(*call_local64, *ret_call_local64): New patterns.
	(*call_nonlocal_aix64, *ret_call_nonlocal_aix64): New patterns.
	(*ret_call_nonlocal_aix32): Use call_value_indirect for REG.
	(compare): Materialize DImode truthvalues.

Thu Jun  4 01:26:57 1998  Craig Burley  <burley@gnu.org>

	* expr.c (safe_from_p): Avoid combinatorial explosion
	over duplicate SAVE_EXPRs by ensuring we never recurse
	on one that has already been visited.

Thu Jun  4 00:54:21 1998  Graham  <grahams@rcp.co.uk>

	* loop.c (check_dbra_loop): Initialise final_value before
	normalizing the loop.

Wed Jun  3 20:00:04 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload1.c (reload_reg_free_for_value_p): New arguments out and
	reloadnum.  Changed all callers.

1998-06-03  Ulrich Drepper  <drepper@cygnus.com>

	* system.h: Add _() and N_() macros in preparation for gettext.

Wed Jun  3 11:02:24 1998  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* c-common.c (check_format_info): Put back check for C9x `hh'
	length modifier.  Warn about %n format writing into const.  Remove
	obsolete comment.
	(format_char_info): Fix comments.

	* configure.in: Set float_format to m68k for all m68k targets that
	do not override LONG_DOUBLE_TYPE_SIZE.
	* config/float-m68k.h: New file.

Tue Jun  2 23:14:01 1998  Richard Henderson  <rth@cygnus.com>

	* jump.c (jump_optimize): Remove debug messages accidentally left in
	with the previous change.

Tue Jun  2 22:46:08 1998  Richard Henderson  <rth@cygnus.com>

	* expr.c (store_expr): Revert stray patch associated with
	1998-05-23 commit.

Tue Jun  2 21:59:01 1998  Richard Henderson  <rth@cygnus.com>

	* jump.c (rtx_unsafe_p): New function.
	(jump_optimize): Use it on if/then/else transformations and
	conditional move transformations.

Tue Jun  2 22:50:10 1998  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* fold-const.c (fold, case EQ_EXPR): When folding VAR++ == CONST
	or VAR-- == CONST construct a proper mask if VAR is a bitfield.
	Cope with CONST being out of range for the bitfield.

Tue Jun  2 22:28:31 1998  Bernd Schmidt <crux@ohara.Informatik.RWTH-Aachen.DE>

	* expr.c (emit_move_insn_1): When moving complex values in several
	steps, emit a CLOBBER to show the destination dies.

Tue Jun  2 22:17:26 1998  Jeffrey A Law  (law@cygnus.com)

	* Makefile.in (site.exp): Use the object testsuite directory as
	the temporary directory.

	* expr.c (expand_expr, case ADDR_EXPR): Handle taking the
	address of an ADDRESSOF rtx.

1998-06-02  Mike Stump  <mrs@wrs.com>

	* expr.c (expand_builtin_setjmp): Handle BUILTIN_SETJMP_FRAME_VALUE.
	* i960.h (SETUP_FRAME_ADDRESSES, BUILTIN_SETJMP_FRAME_VALUE): Define.
	* i960.md (ret, flush_register_windows): Define.
	(nonlocal_goto): Likewise.  Nested function nonlocal gotos don't
	work yet.
	* tm.texi (BUILTIN_SETJMP_FRAME_VALUE): Document new macro.

Tue Jun  2 14:02:38 1998  Richard Henderson  <rth@cygnus.com>

	* alpha.md (divsi3, udivsi3, modsi3, umodsi3): Enable, and work
	around an OSF/1 library bug wrt sign-extension of inputs.

Tue Jun  2 13:02:44 1998  Richard Henderson  <rth@cygnus.com>

	* vax/netbsd.h (DWARF2_UNWIND_INFO): Must be undef, not defined 0.

Mon Jun  1 03:44:03 1998  Catherine Moore <clm@cygnus.com>

        * config/sh/sh.h (MAX_OFILE_ALIGNMENT): Define.

        * varasm.c (assemble_variable): Augment alignment warning.

Mon Jun  1 12:14:28 1998  Michael Meissner  <meissner@cygnus.com>

	* config/fp-bit.c (_fp{add,div}_parts): Return correct IEEE result
	in the presence of IEEE negative 0's.

Sun May 31 16:11:41 1998  John Wehle  (john@feith.com)

	* reload.c (find_reloads): Record the existing mode if
	operand_mode == VOIDmode before replacing a register with
	a constant.
	* i386.md (tstsi, tsthi, tstqi, tstsf, tstdf, tstxf): Set
	i386_compare_op1 to const0_rtx for the benefit of the
	conditional move patterns.
	(movsicc, movhicc, movsfcc, movdfcc, movxfcc, movdicc): Rewrite
	based on suggestions from Jim Wilson.

Sun May 31 00:44:02 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Sun May 31 00:34:17 1998  Bruce Korb <korbb@datadesign.com>

	* Makefile.in (fixinc.sh): Update rules again.

Sun May 31 00:27:47 1998  Jeffrey A Law  (law@cygnus.com)

	* extend.texi: Bring back reference to trampoline paper.

Sun May 31 00:22:34 1998  Ulrich Drepper  <drepper@cygnus.com>

	* Makefile.in (USER_H): Add stdbool.h.
	* ginclude/stdbool.h: New file.

Fri May 29 01:48:25 1998  Jeffrey A Law  (law@cygnus.com)

	* jump.c (thread_jumps): Do not look at the NOTE_LINE_NUMBER
	of a non-note insn.

	* gcse.c (pre_delete): Fix code to determine the mode of
	the reaching pseudo register.

Fri May 29 01:07:28 1998  Bernd Schmidt <crux@Pool.Informatik.RWTH-Aachen.DE>

	* Makefile.in (GEN): Add gencheck
	(STAGESTUFF): Add tree-check.h and gencheck.

Fri May 29 00:57:37 1998  Bruce Korb <korbb@datadesign.com>

	* Makefile.in (cstamp-h.in): Remove before trying to recreate.
	(fixinc.sh): Set some additional environment variables before
	calling mkfixinc.sh.

Thu May 28 12:57:05 1998  Jeffrey A Law  (law@cygnus.com)

	* reload.c (find_reloads): Do not force a reloads of match_operators.

Thu May 28 10:22:22 EDT 1998  Andrew MacLeod  <amacleod@cygnus.com>

	* except.h (remove_handler): Add new prototype.
	* except.c (remove_handler): New function to remove handlers
	from an exception region.
	* flow.c (find_basic_blocks_1): Remove handlers from regions when
	handler label is deleted; remove exception regions with no handlers.

Thu May 28 09:36:39 1998  Michael Meissner  <meissner@cygnus.com>

	* except.h (rtx): Define rtx type correctly if needed.
	* function.h (rtx): Ditto.
	(tree): Define tree type correctly if needed.

	* c-pragma.c (toplevel): Include rtl.h.

	* stor-layout.c (toplevel): Move include of rtl.h before
	except.h.

	* Makefile.in (c-pragma.o): Add except.h, rtl.h dependencies.
	(tree.o): Add except.h dependency.

Wed May 27 22:02:40 1998  Jeffrey A Law  (law@cygnus.com)

	* reload1.c: Revert accidental checkin.

	* configure.lang: Fix thinko when adding a definition for
	target_alias to the Makefile.

Wed May 27 02:50:00 1998  Catherine Moore (clm@cygnus.com)

        * config/sparc/lb1spc.asm (.rem and .urem):  Replace
        routines.

Wed May 27 02:48:31 1998  Richard Earnshaw (rearnsha@arm.com)

	* arm.c (arm_gen_constant): Rework to eliminate uninitialized
	variable warnings.  Don't generate scratch registers if only
	counting insns.
	(find_barrier): Eliminate unused variable SRC.

1998-05-27  Manfred Hollstein  <manfred@s-direktnet.de>

	* toplev.h (rtx_def): Provide global declaration to avoid
	`limited scope' warnings.

Tue May 26 23:47:52 1998  Mumit Khan <khan@xraylith.wisc.edu>

	* Makefile.in (gencheck.o): Use HOST_CC.
	* i386/t-mingw32: New file.
	* configure.in (i386-*-mingw32*): Use.

Tue May 26 07:31:04 1998  Richard Earnshaw (rearnsha@arm.com)

	* arm.c (bad_signed_byte_operand): New predicate function.
	* arm.h (PREDICATE_CODES): Add it to the list.
	* arm.md (*extendqi[sh]i_insn): Split any addresses that ldrsb
	can't handle.
	(define_split): Two new splits for above insns.

	* arm.c: Include toplev.h.
	(arm_override_options): Add parentheses around use of tune_flags.
	(arm_split_constant): Remove unused variable.
	(arm_gen_constant, arm_gen_movstrqi, add_constant): Likewise.
	(output_func_prologue, arm_expand_prologue): Likewise.
	(arm_canonicalize_comparison): Make I unsigned; rework constants
	accordignly.  Add missing paratheses around << operation.
	(arm_rtx_costs): Correctly parenthesise MULT costs.  Add a DEFAULT
	clause.
	({load,store}_multiple_sequence): Initialize BASE_REG.
	(select_dominance_cc_mode): Add DEFAULT clauses.
	(broken_move): Return zero if the destination is not a register.
	(arm_reorg): Move unused REGNO declaration into the dead code.
	* arm.h (CANONICALIZE_COMPARISON): Ensure OP1 is updated.

Mon May 25 22:49:56 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Mon May 25 11:56:24 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Mon May 25 14:00:13 1998  Dave Brolley  <brolley@cygnus.com>

	* cpperror.c (v_cpp_message): Remove static prototype.
	* cpplib.c (v_cpp_message): Move prototype to cpplib.h.
	* cpplib.h (v_cpp_message): Add protoptype.
	(stdarg.h,varargs.h): Needed for v_cpp_message prototype.

Sun May 24 20:36:15 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Sun May 24 02:08:57 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

1998-05-24  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* m68k.h: Declare more functions used in macros.
	(REG_CLASS_CONTENTS): Completely embrace initializer.
	* m68k.md (adddi3, subdi3): Add abort call to avoid warning
	about returning no value.
	* cse.c (find_best_addr): Declare p and found_better only if
	needed.
	* dbxout.c (dbxout_continue): Define only if DBX_CONTIN_LENGTH > 0.
	* dwarfout.c (string_length_attribute): #if 0 away.
	* function.c (expand_function_end): Define varible blktramp only
	if needed.
	* jump.c (find_insert_position): Define only if !HAVE_cc0.
	* loop.c (combine_givs_p): Define variable tem only if needed.
	* real.c: Comment out unused functions eabs, eround,
	e{24,53,64,113}toasc and eiinfin.


Sat May 23 23:44:53 1998  Alexandre Oliva <oliva@dcc.unicamp.br>

	* Makefile.in (boostrap2-lean, bootstrap3-lean,
	bootstrap4-lean): New targets.

Sat May 23 23:35:14 1998  Jeffrey A Law  (law@cygnus.com)

	* warn_summary, test_summary: Moved into the contrib directory.

1998-05-23  Manfred Hollstein  <manfred@s-direktnet.de>

	* Makefile.in (ENQUIRE_CFLAGS, ENQUIRE_LDFLAGS): Move down to the end
	of the Makefile.
	(FLOAT_H_TEST): Likewise.
	(ENQUIRE): Likewise.
	(float.h-nat): Likewise.
	(float.h-cross): Likewise.
	(enquire): Likewise.
	(enquire.o): Likewise.
	(stmp-int-hdrs): Fix comment about enquire; depend upon gfloat.h.
	(stmp-headers): Move actions to stmp-int-hdrs, retaining only a
	no-op.
	(FLOAT_H): Remove old float.h-nat version; move current definition
	to CROSS_FLOAT_H location.
	(all.cross): Remove comments about enquire stuff.

	* Makefile.in (all.cross): Swap $(LIBGCC) and $(STMP_FIXPROTO).
	(rest.encap): Likewise.
	(libgcc2.ready): Depend upon $(STMP_FIXPROTO)

	* toplev.h (tree_node): Provide global declaration to avoid
	`limited scope' warnings.

Sat May 23 23:23:35 1998   Robert Lipe  <robertl@dgii.com>

	* test_summary: Display section breaks for each entry
	in a multilibbed target's output.

1998-05-23  Richard Henderson  <rth@cygnus.com>

	* expr.c (expand_expr): For {BITFIELD,COMPONENT,ARRAY}_REF, if the
	offset's mode is not ptr_mode, convert it.

1998-05-22  Jason Merrill  <jason@yorick.cygnus.com>

	* fold-const.c (ssize_binop): New fn.
	* tree.h: Declare it.

Fri May 22 03:42:05 1998  Richard Earnshaw (rearnsha@arm.com)

	* genextract.c (print_path): Handle zero-length path as a special
	case.

Fri May 22 01:38:07 1998  Hans-Peter Nilsson  <hp@axis.se>

	* cplus-dem.c (MBUF_SIZE): Bumped from 512 to 32767.

Fri May 22 00:57:00 1998  Bernd Schmidt (crux@pool.informatik.rwth-aachen.de>

	* final.c (JUMP_TABLES_IN_TEXT_SECTION): Provide a default value.
	(shorten_branches, final_scan_insn): Test value of
	JUMP_TABLES_IN_TEXT_SECTION instead of just testing whether it
	is defined.
	* tm.texi (JUMP_TABLES_IN_TEXT_SECTION): Corresponding changes.
	* arm/coff.h: Define JUMP_TABLES_IN_TEXT_SECTION to 1.
	* arm/tcoff.h: Likewise.
	* i386/386bsd.h: Likewise.
	* i386/freebsd-elf.h: Likewise.
	* i386/freebsd.h: Likewise.
	* i386/netbsd.h: Likewise.
	* i386/ptx4-i.h: Likewise.
	* i386/sysv4.h: Likewise.
	* pa/pa.h: Likewise.
	* rs6000/linux.h: Likewise.
	* rs6000/rs6000.h: Likewise.
	* sh/sh.h: Likewise.
	* sparc/sp64-elf.h: Likewise.
	* v850/v850.h: Likewise.
	* rs6000/sysv4.h: Define JUMP_TABLES_IN_TEXT_SECTION to 0.
	* i386/linux.h: Define JUMP_TABLES_IN_TEXT_SECTION to (flag_pic).

Thu May 21 19:50:13 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* regmove.c (gen_add3_insn): New function.
	(fixup_match_2): Use it instead of calling gen_addsi3.

Thu May 21 23:09:50 1998  Jeffrey A Law  (law@cygnus.com)

	* Makefile.in (gencheck): Depend on HOST_LIBDEPS.

	* alias.c (rtx_equal_for_memref_p): Handle SCRATCH as a memory
	address.

Thu May 21 20:18:13 1998  Martin von Loewis  <loewis@informatik.hu-berlin.de>

	* Makefile.in (TREE_H): Add tree-check.h.
	(tree-check.h, gencheck): New targets.
	* gencheck.c: New file.
	* tree.c (tree_check, tree_class_check): New functions.
	* tree.h (TREE_CHECK, TREE_CLASS_CHECK): Define.
	(TYPE_CHECK, DECL_CHECK): Define.
	Modify all access macros to use generated checking macros.

Wed May 20 23:44:28 EDT 1998  John Wehle  (john@feith.com)

	* acconfig.h (HAVE_GAS_MAX_SKIP_P2ALIGN): New tag.
	* configure.in: Check for it.
	* i386/gas.h (ASM_OUTPUT_MAX_SKIP_ALIGN): Use it.
	* final.c (uid_align, uid_shuid, label_align): Make static.
	(label_align): Change type to struct label_alignment pointer.
	(LABEL_TO_ALIGNMENT, shorten_branches): Update due to type change.
	(LABEL_TO_MAX_SKIP): Define.
	(LABEL_ALIGN_MAX_SKIP, LOOP_ALIGN_MAX_SKIP,
	LABEL_ALIGN_AFTER_BARRIER_MAX_SKIP): Provide defaults.
	(shorten_branches): Record the maximum bytes to skip when
	aligning a label.
	(final_scan_insn): Use the maximum bytes to skip when aligning a label
	if ASM_OUTPUT_MAX_SKIP_ALIGN is available.
	* i386.h (LOOP_ALIGN_MAX_SKIP,
	LABEL_ALIGN_AFTER_BARRIER_MAX_SKIP): Define.
	* i386.c (override_options): i386_align_jumps and i386_align_loops
	default to 4 if ASM_OUTPUT_MAX_SKIP_ALIGN is available.
	* invoke.texi: Document new i386 align-loops and align-jumps behavior.

1998-05-21  Mark Mitchell  <mmitchell@usa.net>

	* cplus-dem.c (do_type): Handle volatile qualification.

Thu May 21 12:23:17 1998  Per Bothner  <bothner@cygnus.com>

	* function.c (init_function_start):  Don't call emit_line_note if
	lineno is 0.  (Can happen when compiling Java .class files.)

Thu May 21 19:50:13 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload1.c (reload_reg_free_for_value_p): Fix RELOAD_FOR_INPUT
	end of lifetime and RELOAD_FOR_OUTPUT start of lifetime.

Thu May 21 19:32:27 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* combine.c (nonzero_bits): For paradoxical subregs, take
	LOAD_EXTENDED_OP into account.

Thu May 21 11:51:15 1998  Dave Brolley  <brolley@cygnus.com>

	* configure.in (extra_c_objs): add prefix.o.
	(extra_cxx_objs): extra objects for C++ with cpplib.
	* configure: Regenerate.

	* c-tree.h: (get_directive_line): Different prototype for cpplib.
	(GET_DIRECTIVE_LINE): Macro wrapper for get_directive_line.

	* c-lex.h: (get_directive_line): Not needed here for cpplib.

	* c-lex.c: (yy_cur,yy_lim,yy_get_token): Move to c-common.c.
	(GET_DIRECTIVE_LINE): Move to c-common.c and rename to get_directive_line.

	* c-common.c (parse_in,parse_options,cpp_token): Declare for cpplib.
	(yy_cur,yy_lim,yy_get_token,get_directive,line): Moved here from c-lex.c

Thu May 21 09:04:42 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* gengenrtl.c (type_from_format, accessor_from_format): Change
 	type of parameter `c' from `char' to `int'.

Wed May 20 22:28:34 1998  Jeffrey A Law  (law@cygnus.com)

	* warn_summary, test_summary: New scripts from
	Kaveh Ghazi and Alexandre Oliva respectively.

	* gcse.c (current_function_calls_longjmp): Declare.

1998-05-20  Jason Merrill  <jason@yorick.cygnus.com>

	* dwarf2out.c (base_type_die): Use int_size_in_bytes.

Wed May 20 01:11:02 1998  Doug Evans (devans@cygnus.com)
			  Jeff Law (law@cygnus.com)

	* Global CSE and constant/copy propagation.
	* Makefile.in (OBJS): Add gcse.o
	(STAGESTUFF): Add *.gcse.
	(gcse.o): Add dependencies.
	(mostlyclean): Remove *.gcse and */*.gcse.
	* gcse.c: New file.
	* loop.c (loop_optimize): Move call to init_alias_analysis.
	* recog.c (validate_replace_src): New function.
	* toplev.c (gcse_dump): New global variable.
	(flag_gcse, gcse_time): Likewise.
	(compile_file): Initialize gcse_time and clean out the gcse dump
	file if necessary.
	(rest_of_compilation): Call gcse_main as requested.  Dump RTL
	after gcse if requested.
	(main): Enable gcse for -O2 and above.  Handle -dG.  Enable gcse
	dumps for -da.
	* gcc.texi: Add gcse related internal documentation.
	* invoke.texi: Note new command line options for gcse.
	* tm.texi: Document AVOID_CCMODE_COPIES.
	* mips.h (AVOID_CCMODE_COPIES): Define.

Tue May 19 22:31:20 1998  Jeffrey A Law  (law@cygnus.com)

	* Makefile.in (deduced.h): Only run scan-types if $(SYSTEM_HEADER_DIR)
	exists.
	(stmp-fixproto): Simlarly for running fixproto.
	* cross-make (SYSTEM_HEADER_DIR): Now $(tooldir)/sys-include.

Tue May 19 19:08:52 1998  Jim Wilson  <wilson@cygnus.com>

	* config/mips/mips.c (double_memory_operand): Accept any MEM during
	reload when TARGET_64BIT.

Tue May 19 18:21:25 1998  Jim Wilson  <wilson@cygnus.com>

	Finish incomplete change started by Kenner.
	* configure.in (*-*-linux-gnu*): Delete NO_STAB_H from xm_defines.
	(powerpcle-*-cygwin32): Delete xm_defines.
	* final.c, mips-tfile.c, xcoffout.c, config/mips/mips.c: Use
	HAVE_STAB_H instead of NO_STAB_H.
	* config/xm-linux.h (NO_STAB_H): Delete.
	(HAVE_STAB_H): Undefine.
	* config/i386/xm-go32.h (NO_STAB_H): Delete.

1998-05-19  Jim Wilson  <wilson@cygnus.com>

	* dwarfout.c (dwarfout_file_scope_decl, case TYPE_DECL): Ignore
	LANG_TYPE trees with DECL_SOURCE_LINE of 0.

Tue May 19 15:07:54 1998  Todd Vierling  <tv@netbsd.org>

	* arm/netbsd.h: Ensure DWARF2_UNWIND_INFO is undefined.

Tue May 19 17:19:16 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload1.c (reload_reg_free_for_value_p): New function.
	(allocate_reload_reg, choose_reload_regs): Use it.

Tue May 19 11:51:00 EDT 1998  Andrew MacLeod  (amacleod@cygnus.com)

	* except.c (expand_start_catch): Correct logic for when to
	generate a new handler label, and when to use the old one.

Tue May 19 11:08:52 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (print-rtl.o): Depend on bitmap.h.
	(dbxout.o): Depend on toplev.h.
	($(SCHED_PREFIX)sched.o): Likewise.
	($(out_object_file)): Likewise for system.h and toplev.h.
	(cppmain.o): Depend on gansidecl.h.
	(cpplib.o): Likewise.
	(cpperror.o): Likewise.
	(cppexp.o): Likewise.
	(cpphash.o): Likewise.
	(cppalloc.o): Likewise.
	(fix-header.o): Depend on cpplib.h and cpphash.h.
	(scan-decls.o): Depend on gansidecl.h.

	* basic-block.h (free_regset_vector): Add prototype.

	* cccp.c (check_precompiled): Mark parameter `fname' with
	ATTRIBUTE_UNUSED.
	(do_assert): Likewise for `op' and `keyword'.
	(do_unassert): Likewise.
	(do_line): Likewise for `keyword'.
	(do_error): Likewise for `op' and `keyword'.
	(do_warning): Likewise.
	(do_ident): Likewise for `keyword'.
	(do_pragma): Likewise for `limit', `op' and `keyword'.
	(do_sccs): Likewise.
	(do_if): Likewise for `keyword'.
	(do_elif): Likewise.
	(do_else): Likewise.
	(do_endif): Likewise.

	* collect2.c (getenv): Remove redundant prototype.
	(collect_exit, collect_execute, dump_file): Likewise.
	(dump_list): Wrap prototype and definition in COLLECT_EXPORT_LIST.
	(dump_prefix_list): Hide prototype and definition.

	* sparc.c: Include toplev.h.
	(intreg_operand): Mark parameter `mode' with ATTRIBUTE_UNUSED.
	(symbolic_memory_operand): Likewise.
	(sp64_medium_pic_operand): Likewise.
	(data_segment_operand): Likewise.
	(text_segment_operand): Likewise.
	(splittable_symbolic_memory_operand): Likewise.
	(splittable_immediate_memory_operand): Likewise.
	(eq_or_neq): Likewise.
	(normal_comp_operator): Likewise.
	(noov_compare_op): Likewise.
	(v9_regcmp_op): Likewise.
	(v8plus_regcmp_op): Likewise.
	(extend_op): Likewise.
	(cc_arithop): Likewise.
	(cc_arithopn): Likewise.
	(small_int): Likewise.
	(uns_small_int): Likewise.
	(clobbered_register): Likewise.
	(legitimize_pic_address): Likewise.
	(delay_operand): Likewise.
	(sparc_builtin_saveregs): Remove unused variable `stdarg'.

	* sparc.h (order_regs_for_local_alloc, eligible_for_return_delay,
	sparc_issue_rate, v8plus_regcmp_p): Add prototypes.

	* sparc.md (cmpdi_v8plus): Add abort for default case in switch.

	* cppalloc.c: Include gansidecl.h.

	* cpperror.c: Include stdarg.h/varargs.h and gansidecl.h.
	(cpp_file_line_for_message): Mark parameter `pfile' with
	ATTRIBUTE_UNUSED.
	(v_cpp_message): New function.
	(cpp_message): Use it.  Also convert to variable arguments.
	(cpp_fatal): Likewise.
	(cpp_pfatal_with_name): Constify parameter `name'.

	* cppexp.c: Move gansidecl.h before cpplib.h.
	* cpphash.c: Likewise.
	* cpphash.h (hashf, delete_macro): Add prototypes.

	* cpplib.c: Include stdarg.h/varargs.h and move gansidecl.h before
	cpplib.h.  Don't include errno.h.
	(update_path): Add arguments to prototype.
	(cpp_fatal, cpp_file_line_for_message, cpp_message, delete_macro,
	cpp_print_containing_files): Remove redundant prototypes.
	(cpp_hash_cleanup, add_import, append_include_chain,
 	make_assertion, path_include, initialize_builtins,
 	initialize_char_syntax, finclude, validate_else, comp_def_part,
 	lookup_import, redundant_include_p, is_system_include,
 	read_name_map, read_filename_string, open_include_file,
 	check_macro_name, compare_defs, compare_token_lists,
 	eval_if_expression, change_newlines): Add prototype arguments.
	(hashf): Remove redundant prototype.
	(read_token_list, free_token_list, safe_read, xcalloc, savestring,
	conditional_skip, skip_if_group): Add prototype arguments.
	(fdopen): Remove redundant prototype.
	(do_define, do_line, do_include, do_undef, do_error, do_pragma,
	do_ident, do_if, do_xifdef, do_else, do_elif, do_endif, do_sccs,
	do_once, do_assert, do_unassert, do_warning): Add prototype arguments.
	(struct directive): Add prototype arguments to function pointer
 	member `func'.
	(handle_directive): Add missing arguments to call to `do_line'.
	(do_include): Mark parameters `unused1' and `unused2' with
	ATTRIBUTE_UNUSED.
	(do_line): Likewise for `keyword' and new parameters `unused1' and
	`unused2'.
	(do_error): Likewise for `keyword'.
	(do_warning): Likewise.  Also add missing argument `pfile' in call
	to cpp_pedwarn.
	(do_once): Mark parameter `keyword', `unused1' and `unused2' with
	ATTRIBUTE_UNUSED.
	(do_ident): Likewise for `keyword', `buf' and `limit'.
	(do_pragma): Likewise.  Also add missing arguments in call to do_once.
	(do_sccs): Mark parameter `keyword', `buf' and `limit' with
	ATTRIBUTE_UNUSED.
	(do_if): Likewise for `keyword'.
	(do_elif): Likewise.
	(eval_if_expression): Likewise for `buf' and `length'.
	(do_xifdef): Likewise for `unused1' and `unused2'.
	(do_else): Likewise for `keyword', `buf' and `limit'.
	(do_endif): Likewise.
	(parse_name): Add missing argument `pfile' in call to cpp_pedwarn.
	(cpp_handle_options): Remove superfluous NULL argument in call to
	cpp_fatal.
	(cpp_handle_options): Likewise.
	(do_assert): Mark parameter `keyword', `buf' and `limit' with
	ATTRIBUTE_UNUSED.
	(do_unassert): Likewise.
	(cpp_print_file_and_line): Add missing argument `pfile' in call to
	cpp_file_line_for_message.
	(v_cpp_error): New function.
	(cpp_error): Use it. Also accept variable arguments.
	(v_cpp_warning): New function.
	(cpp_warning): Use it. Also accept variable arguments.
	(cpp_pedwarn): Accept variable arguments.
	(v_cpp_error_with_line): New function
	(cpp_error_with_line): Use it.  Accept variable arguments.
	(v_cpp_warning_with_line): New function.
	(cpp_warning_with_line): Use it.  Accept variable arguments.  Hide
	definition.
	(cpp_pedwarn_with_line): Accept variable arguments.
	(cpp_pedwarn_with_file_and_line): Likewise.
	(cpp_error_from_errno): Constify parameter `name'.  Add missing
	argument `pfile' in call to cpp_file_line_for_message.
	(cpp_perror_with_name): Constify parameter `name'.

	* cpplib.h: Define PARAMS() in terms of PROTO().
	(fatal): Remove redundant prototype.
	(cpp_error, cpp_warning, cpp_pedwarn, cpp_error_with_line,
	cpp_pedwarn_with_line, cpp_pedwarn_with_file_and_line,
	cpp_error_from_errno, cpp_perror_with_name, cpp_pfatal_with_name,
	cpp_fatal, cpp_message, cpp_pfatal_with_name,
	cpp_file_line_for_message, cpp_print_containing_files): Add
	arguments to prototypes.
	(scan_decls, cpp_finish): Add prototypes.

	* cppmain.c: Include gansidecl.h.
	(main): Remove unused variable `i'.

	* dbxout.c: Include toplev.h.

	* demangle.h (do_tlink, collect_execute, collect_exit,
	collect_wait, dump_file, file_exists): Add prototype.

	* dwarf2out.c (dwarf_type_encoding_name, decl_start_label): Hide
	prototype and definition.
	(gen_unspecified_parameters_die): Don't assign results of call to
	function new_die() to unused variable `parm_die'.
	(dwarf2out_line): Mark parameter `filename' with ATTRIBUTE_UNUSED.
	(dwarf2out_define): Likewise for `lineno' and `buffer'.

	* dwarfout.c (output_unsigned_leb128, output_signed_leb128): Hide
	prototype and definition.
	(output_die): Add prototype arguments to function pointer arg.
	(output_unspecified_parameters_die): Mark parameter `arg' with
	ATTRIBUTE_UNUSED.

	* except.c (output_exception_table_entry): Remove unused variable
	`eh_entry'.

	* except.h (expand_fixup_region_start, expand_fixup_region_end):
	Add prototypes.

	* expr.c (do_jump_by_parts_equality_rtx): Remove prototype.

	* expr.h (do_jump_by_parts_equality_rtx): Add prototype.

	* fix-header.c: Include stdarg.h/varargs.h, move gansidecl.h
	before cpplib.h, include cpphash.h, remove redundant prototype of
	cpp_fatal, don't define `const', add a prototype for `fatal'.
	(cpp_file_line_for_message): Add missing arguments `pfile'.
	(v_cpp_message): New function.
	(cpp_message): Use it.
	(v_fatal): New function.
	(fatal, cpp_fatal): Use it.
	(cpp_pfatal_with_name): Constify parameter `name'.

	* flow.c (free_regset_vector): Remove redundant prototype.

	* function.c (round_down): Wrap prototype and definition with
	macro ARGS_GROW_DOWNWARD.
	(record_insns): Wrap prototype and definition with
 	defined (HAVE_prologue) || defined (HAVE_epilogue).

	* gansidecl.h (ATTRIBUTE_PRINTF_4, ATTRIBUTE_PRINTF_5): New macros.

	* gen-protos.c: Include gansidecl.h.
	(hashf): Don't make it static, constify parameter `name'.

	* genattrtab.c (check_attr_test): Change XEXP() to XSTR() to match
	specifier %s in calls to function `fatal'.

	* haifa-sched.c: Include toplev.h.
	(find_rgns): Remove unused variable `j'.

	* integrate.c (note_modified_parmregs): Mark parameter `x' with
	ATTRIBUTE_UNUSED.
	(mark_stores): Likewise.

	* jump.c (mark_modified_reg): Likewise.

	* output.h (insn_current_reference_address): Add prototype.
	(eh_frame_section): Likewise.

	* print-rtl.c: Include bitmap.h.

	* reload1.c (reload): Wrap variables `note' and `next' in macro
	PRESERVE_DEATH_INFO_REGNO_P.
	(forget_old_reloads_1): Mark parameter `ignored' with
	ATTRIBUTE_UNUSED.
	(choose_reload_regs): Remove unused variable `in'.
	(reload_cse_invalidate_mem): Mark parameter `ignore' with
	ATTRIBUTE_UNUSED.
	(reload_cse_check_clobber): Likewise.

	* rtl.h (expand_null_return, reg_classes_intersect_p): Add prototype.
	(mark_elimination): Fix typo in prototype.

	* scan-decls.c: Include gansidecl.h.

	* tree.h (using_eh_for_cleanups, supports_one_only): Add prototype.

Mon May 18 22:37:33 1998  Jeffrey A Law  (law@cygnus.com)

	* function.c (identify_blocks): Fix thinko when setting the
	block number for NOTE_INSN_BLOCK_END.

Mon May 18 15:30:42 1998  Nick Clifton  <nickc@cygnus.com>

	* config/v850/lib1funcs.asm: Add .text pseudo op to start of
	___udivsi3.

	* config/v850/lib1funcs.asm: Fix .size pseudo ops to use three
	underscores for the prefixes to the names of the maths functions.

	* dbxout.c (dbxout_parms): Revert to using DECL_ARG_TYPE.  Add
	comment explaining why.

Mon May 18 13:20:23 1998  Richard Henderson  <rth@cygnus.com>

	* tree.h (TYPE_SIZE_UNIT): New.
	(struct tree_type): Add size_unit member.
	* stor-layout.c (layout_type): Initialize it.
	* expr.c (get_inner_reference) [ARRAY_REF]: Use it.
	* tree.c (size_in_bytes, int_size_in_bytes): Likewise.

Mon May 18 12:07:37 1998  Richard Earnshaw (rearnsha@arm.com)

	* stor-layout.c (layout_record): Fix off-by-one error when checking
	length of the TYPE_BINFO vector.

Mon May 18 10:59:23 1998  Nick Clifton  <nickc@cygnus.com>

	* dbxout.c (dbxout_parms): Use TREE_ARG to compute the type of a
	function parameter passed in memory.

Mon May 18 09:02:09 1998  Robert Lipe  <robertl@dgii.com>

	* dwarfout.h, dwarf2out.h, dbxout.h, sdbout.h:  New files.
	Prototypes for externally used functions in respective C files.
	* dwarfout.c, dbxout.c, dwarf2out.c, sdbout.c, toplev,c,
	final.c: Include above files.
	* Makefile.in (toplev.o): Add dependency for above four headers.
	(final.o): Likewise.
	(dwarfout.o, dbxout.o, dwarf2out.o, sdbout.o): Depend on four
	respective header files.

Mon May 18 01:23:33 1998  Jeffrey A Law  (law@cygnus.com)

	* Makefile.in (TARGET_TOOLPREFIX): No longer define.
	(AR_FOR_TARGET, RANLIB_FOR_TARGET): Define to use versions in
	the build tree if they exist.
	(AR, AR_FLAGS, OLDAR, OLDAR_FLAGS, RANLIB, RANLIB_TEST): Update
	appropriately.
	(objdir): Let configure substitute value.
	(FLOAT_H): Let configure select a pre-built version from the
	config subdir.
	* build-make (INSTALL_TARGET, ALL): Disable, no longer needed.
	* configure.in: Substitute for objdir.

	* Makefile.in (build_canonical, host_canonical): Let configure
	substitute values for these variables.
	* configure.in: Substitute for build_canonical, host_canonical
	and target_subdir in generated Makefile.

	* output.h (find_basic_blocks): Declare.
	(free_basic_block_vars, set_block_num, life_analysis): Likewise.

	* Makefile.in (BISON): Use bison from the build tree if it exists.
	(FLEX): Similarly.

Mon May 18 00:08:19 1998  Nick Clifton  <nickc@cygnus.com>

	* gcc.c (SWITCH_CURTAILS_COMPILATION): Definition.
	(DEFAULT_SWITCH_CURTAILS_COMPILATION): True for options -S and -c.
	(process_command): If HAVE_EXECUTABLE_SUFFIX is defined then scan
	command line arguments to see if an executable is not being
	created, and if so - do not append the suffix.

	* tm.texi (SWITCH_CURTAILS_COMPILATION): Add description of new
	driver macro.

Sun May 17 23:59:45 1998  John Wehle  (john@feith.com)

	* i386.h (ALIGN_DFmode): Delete.
	(CONSTANT_ALIGNMENT): Define.
	* varasm.c (force_const_mem): Use it.

Sun May 17 19:31:05 1998  Richard Henderson  <rth@cygnus.com>

	* alpha.c (alpha_emit_conditional_branch): Clear cmp_code after
	using it with swap_condition, not before.

Sun May 17 13:44:32 1998  Jim Wilson  <wilson@cygnus.com>

	* alias.c (mode_alias_check): Delete.
	(true_dependence, anti_dependence, output_dependence): Revert April 21
	change.

Sun May 17 08:45:21 1998  Krister Walfridsson <cato@df.lth.se>

        * toplev.c (output_lang_identify): Enable prototype and definition.

Sun May 17 01:12:27 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Sat May 16 23:20:32 1998  Richard Henderson  <rth@cygnus.com>

	* alpha/osf.h (HAVE_STAMP_H): Define.
	* alpha.c: Use it.
	* alpha/netbsd.h, alpha/netbsd-elf.h: New files.
	* configure.in (alpha*-*-netbsd*): New.
	Based on patches from Paul H. Anderson <pha@pdq.com>.

	* configure.in (alpha*-*-linux-*): Kill xm_defines.
	(alpha*-*-linux-gnulibc1*) [fixincludes]: Define.
	* alpha/xm-linux.h: Remove file.

Sat May 16 18:32:45 1998  Doug Evans  <devans@canuck.cygnus.com>

	* dbxout.c (dbxout_parms): If mode of type of parameter living
	in memory doesn't match mode of DECL_RTL, make big endian correction.

Fri May 15 21:40:06 1998  John Wehle  (john@feith.com)

	* i386.md (movdi-1, movdi): Rewrite based on SI move patterns.

Fri May 15 18:55:22 1998  Jason Merrill  <jason@yorick.cygnus.com>

	* tree.h (BINFO_SIZE, TYPE_BINFO_SIZE): New macros.
	* stor-layout.c (layout_record): Set it.

Fri May 15 18:49:30 1998  Mark Mitchell  <mmitchell@usa.net>

	* toplev.c (rest_of_compilation): Don't defer nested functions.

Fri May 15 17:42:52 1998  Bob Manson  <manson@charmed.cygnus.com>

	* config/rs6000/rs6000.c (rs6000_stack_info): Align the stack bottom
	to an 8-byte boundary if info_ptr->fpmem_p.

Fri May 15 17:36:11 1998  Bill Moyer <ttk@cygnus.com>

        * loop.c (basic_induction_var): Added test preventing
        CCmode parameter passed to convert_modes().

Fri May 15 17:26:18 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

	* expr.c (expand_expr, case EXPR_WITH_FILE_LOCATION): Save/restore
	input_filename and lineno around expand_expr call.  Set them to values
	in WFL before expand_expr call.

Fri May 15 12:44:57 1998  Benjamin Kosnik  <bkoz@rhino.cygnus.com>

	* stor-layout.c (set_sizetype): Set TYPE_NAME on bitsizetype.

Fri May 15 07:20:03 1998  Mark Mitchell  <mmitchell@usa.net>

	* fold-const.c (constant_boolean_node): New function.
	(fold): Use it.

Fri May 15 11:21:16 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sh.c (gen_shl_and): Don't sign extend constant for kind two.
	Abort if trying to split kind 3 or 4 outside of combine.

Fri May 15 01:47:37 1998  Jeffrey A Law  (law@cygnus.com)

	* mips.c (print_operand, case 'x'): Use HOST_WIDE_INT_PRINT_HEX.

Fri May 15 01:42:45 1998  Mumit Khan <khan@xraylith.wisc.edu>

	* objc/Make-lang.in (OBJC_O): Add missing exeext.
	(libobjc.a, runtime-info.h): Likewise.

Fri May 15 01:29:39 1998  John Wehle  (john@feith.com)

	* i386.h (DATA_ALIGNMENT): Define.

Fri May 15 05:35:37 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload1.c (delete_output_reload): Ignore single USE that
	was emitted for the pseudo use of this INSN.
	If the no reference to REG between OUTPUT_RELOAD_INSN and INSN
	remains, we can always delete OUTPUT_RELOAD_INSN.

Thu May 14 18:38:50 1998  Jim Wilson  <wilson@cygnus.com>

	* reload.c (find_reloads): Don't penalize SCRATCH output reload.

Thu May 14 15:10:30 1998  Jeffrey A Law  (law@cygnus.com)

	* Makefile.in (expr.o): Remove dependency on deleted modemap.def file.

Thu May 14 16:30:47 EDT 1998  Andrew MacLeod  <amacleod@cygnus.com>

	* eh-common.h: New file for basic EH data structures.
	* except.h: Various prototypes and structures for NEW_EH_MODEL
	* function.h (struct function): Add a struct eh_stack for the catch
	clause stack.
	* except.c (gen_exception_label): New function to generate an
	exception label.
	(push_eh_entry): Use gen_exception_label() and init 'label_used' field.
	(push_entry): New function to push an existing entry onto a stack.
	(receive_exception_label): New function to emit the code required
	at the start of all catch blocks.
	(struct func_eh_entry): New structure for maintaining handlers
	associated with EH regions.
	(new_eh_region_entry): New function to register an EH region.
	(add_new_handler): New function to register a handler with a region.
	(get_new_handler): Creates  anew handler entry for registering.
	(find_func_region): New function to convert a NOTE eh region number
	to an Eh region index.
	(get_first_handler): New function to get the first handler in a region.
	(clear_function_eh_region): New function to release memory.
	(duplicate_handlers): New function to duplicate a list of handlers.
	(expand_eh_region_end): Create a new region entry node as well.
	(expand_leftover_cleanups): Call receive_exception_label() and
	register the cleanup as a handler to the current region.
	(expand_start_catch): New function to start a catch clause.
	(expand_end_catch): New function to end a catch clause.
	(expand_start_all_catch): restructure to not do the equivilent of
	what expand_start_catch() does now. Push the exception region being
	handled onto the catch stack.
	(output_exception_table_entry): Issue an entry for each handler
	associated with a region.
	(set_exception_lang_code): New function for setting the language code.
	(set_exception_version_code): New function to set the version number.
	(output_exception_table): Output version and language codes.
	(find_exception_handler_labels): Find handler labels using new scheme.
	(is_exception_handler_label): New function, returns 1 if label is
	present as a handler in some exception region.
	(check_exception_handler_labels): Use the new scheme.
	(init_eh_for_function): Initialize the catch stack.
	(save_eh_status): Save the catch stack.
	(restore_eh_status): Restore the catch stack.
	(scan_region): Don't remove unreferenced handler label. Flow does it.
	(get_reg_for_handler): New function to get the eh_context pointer
	passed by __throw.
	(expand_builtin_eh_stub): Changes required for NEW_EH_MODEL only.
	* final.c (final_scan_insn): With NEW_EH_MODEL, add EH table
	entry when processing END region rather that START region.
	* flow.c (find_basic_blocks_1): Find all potential handler regions
	now that we don't automatically know what the labels might be.
	Let scan_region() remove unreferenced EH BEGIN/END labels.
	* integrate.c (get_label_from_map): Put inlined labels onto the
	permanent obstack since we dont know which ones might be exception
	labels.
	(save_for_inline_copying): Make new copies of all the handlers.
	(expand_inline_function): Make new copies of all the handlers.
	* libgcc2.c: Remove local struct decls, and include eh-common.h.
	(find_exception_handler): With NEW_EH_MODEL the first matching
	region we find is the right one. Add eh_info as a new parameter.
	(__throw): Pass eh_info to find_exception_handler. Set handler
	and pass use different regs  under NEW_EH_MODEL.

Thu May 14 12:58:21 1998  Jim Wilson  <wilson@cygnus.com>

	* i960.h (hard_regno_mode_ok): Changed to function from array of
 	unsigned.
	(HARD_REGNO_MODE_OK): Call function instead of testing bit.
	* i960.c (hard_regno_mode_ok): Changed to function from array of
 	unsigned.

Thu May 14 08:41:46 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload.c (remove_replacements): New function.
	* reload.h (remove_replacements): Declare.
	* reload1.c (choose_reload_regs): Disable some reloads that
	belong to inherited reloads.

Thu May 14 02:17:17 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* loop.c (scan_loop): Don't call move_moveables for optimize_size.

	* reload1.c (merge_assigned_reloads):  When merging, reset
	reload_spill_index for the eliminated reload.

Wed May 13 17:51:13 1998  Jeffrey A Law  (law@cygnus.com)

	* haifa-sched.c (schedule_insns): Fix merge goof.

1998-05-13  Jim Wilson  <wilson@cygnus.com>

	* varasm.c (make_decl_rtl): Revert April 1 change.
	* alpha/alpha.h, alpha/win-nt.h, arm/arm.h, i386/unix.h, i960/i960.h,
	m68k/linux.h, pa/pa.h, sparc/sparc.h, vax/vax.h (ASM_OUTPUT_MI_THUNK):
	Get function name from the SYMBOL_REF in the DECL_RTL, not from
	DECL_ASSEMBLER_NAME.
	* i386/winnt.c (gen_stdcall_suffix): Comment for questionable use of
	DECL_ASSEMBLER_NAME.

Wed May 13 13:09:19 1998  Jim Wilson  <wilson@cygnus.com>

	* i386.c (notice_update_cc, output_float_compare): Disable
	TARGET_CMOVE support.

Wed May 13 15:28:59 1998  Michael Meissner  <meissner@cygnus.com>
			  Jeff Law <law@cygnus.com>

	* rtlanal.c (find_reg_note): Ignore notes that are not on on
	insns of class 'i'.
	(find_regno_note): Likewise.

	* Makefile.in (stor-layout.o): Depend on except.h
	(varasm.o, function.o): Likewise.
	(expr.o): Depend on except.h, modemap.def and hard-reg-set.h.

	* Makefile.in (HOST_RTL): Add $(HOST_PREFIX)bitmap.o.
	(rtl.o, emit-rtl.o): Add dependency on bitmap.h.
	($(HOST_PREFIX_1)rtl.o): Likewise.
	($(HOST_PREFIX_1)bitmap.o): New host object.
	* emit-rtl.c (toplevel): Include bitmap.h.
	(gen_rtx): Handle 't' and 'b' nodes.
	* print-rtl.c (print_rtx): Handle printing NOTE_INSN_LIVE notes.
	Print block number for block begin/end notes.  Print 't' type
	nodes as a pointer.  Know that the 3rd argument of live range
	start/stop notes is really a range_info rtx.  If type is 'b', print
	out argument as a bitmap.
	* rtl.c: Include bitmap.c.
	(copy_rtx): Copy tree nodes as is.  Copy bitmaps if type is 'b'.
	(note_insn_name): Add NOTE_INSN_RANGE_{START,END}, NOTE_INSN_LIVE.
	* rtl.def (RANGE_LIVE): New node to hold live information while we
	recalculate the basic blocks.
	(RANGE_REG, RANGE_INFO): New rtl types for live range splitting.
        (RANGE_VAR): New node, to hold information saved in symbol node for New
        communicating live range information to the debug output functions.
	* rtl.h (rtunion_def): Add rttree and rtbit fields.
	(XBITMAP, XTREE): New accessor macros.
 	(NOTE_LIVE_INFO): Overload NOTE_SOURCE_FILE for NOTE_INSN_LIVE notes.
	(NOTE_RANGE_INFO): Similarly for NOTE_INSN_RANGE_{START,END} notes.
	(NOTE_BLOCK_LIVE_RANGE_BLOCK): Define.
	(NOTE_INSN_RANGE_START, NOTE_INSN_RANGE_END, NOTE_INSN_LIVE): New notes.
	(RANGE_LIVE_{BITMAP,ORIG_BLOCK}): New accessor macros.
	(RANGE_REG_{SYMBOL,BLOCK}_NODE, RANGE_VAR_*): New accessor macros.
	(RANGE_INFO_*): Likewise.
	* sched.c (sched_analyze): Keep live range start/stop notes.
	(unlink_other_notes): Likewise.
	* haifa-sched.c (sched_analyze): Keep live range start/stop notes.
	(unlink_other_notes): Likewise.
	* tree.h (BLOCK_LIVE_RANGE_{START,END,VAR_FLAG}): New accessor macros.
	(BLOCK_LIVE_RANGE_FLAG): Likewise.
	(DECL_LIVE_RANGE_RTL): Likewise.
	(struct tree_block): Add live_range_flag, live_range_var_flag,
	live_range_start and live_range_end.
	(struct tree_decl): Add live_range_rtl field.
	* gengenrtl.c (type_from_format): Handle 'b' and 't'.
	(accessor_from_format): Likewise.

	* haifa-sched.c (schedule_block): Make verbose output line up.
	Also add a blank line in printing the individual ready lists.

Wed May 13 15:43:44 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (c-lang.o): Depend on c-tree.h, c-lex.h and toplev.h.
	(c-lex.o): Depend on output.h.
	(c-common.o): Likewise.
	(stmt.o): Likewise.
	(calls.o): Likewise.
	(integrate.o): Depend on toplev.h.
	(regclass.o): Depend on output.h.
	(final.o): Depend on reload.h.

	* c-common.c: Include output.h.
	(check_format_info): Remove unused variable `integral_format'.

	* c-decl.c (print_lang_decl): Mark parameters `file', `node' and
	`indent' with ATTRIBUTE_UNUSED.
	(print_lang_type): Likewise.
	(maybe_build_cleanup): Likewise for parameter `decl'.
	(copy_lang_decl): Likewise for parameter `node'.

	* c-lang.c: Include c-tree.h, c-lex.h and toplev.h.
	(lang_print_xnode): Mark parameters `file', `node' and `indent'
 	with ATTRIBUTE_UNUSED.
	(lookup_interface): Likewise for parameter `arg'.
	(is_class_name): Likewise.
	(maybe_objc_check_decl): Likewise for parameter `decl'.
	(maybe_objc_comptypes): Likewise for parameters `lhs', `rhs' and
	`reflexive'.
	(maybe_objc_method_name): Likewise for parameter `decl'.
	(build_objc_string): Likewise for parameters `len' and `str'.

	* c-lex.c: Include output.h.

	* c-lex.h (position_after_white_space): Correct typo in prototype.

	* c-tree.h (finish_file, c_expand_start_cond, c_expand_start_else,
 	c_expand_end_cond, init_iterators): Add prototypes.

	* caller-save.c (set_reg_live): Mark parameters `reg' and `setter'
	with ATTRIBUTE_UNUSED.

	* calls.c: Include output.h.

	* cccp.c (pipe_closed): Mark parameter `signo' with
 	ATTRIBUTE_UNUSED.

	* combine.c: Move inclusion of expr.h to after insn-config.h.

	* iris6.h (ASM_IDENTIFY_GCC, ASM_IDENTIFY_LANGUAGE): Don't define
	as empty, rather define as ((void)0).

	* sparc.c (sparc_check_64): Add braces around ambiguous `else'.
	Add parentheses around assignment used as truth value.

	* cplus-dem.c (squangle_mop_up): Change return type to void.
	(internal_cplus_demangle): Remove unused parameter `options'.
	All callers changed.
	(cplus_demangle_opname): Remove function wide variable `int i' and
 	replace with `size_t i' at each location where it is used.
	(cplus_demangle_opname): change type of `i' from int to size_t.

	* cppexp.c (right_shift): Mark parameter `pfile' with
	ATTRIBUTE_UNUSED.

	* cpphash.c (cpp_lookup): Likewise.
	(cpp_hash_cleanup): Likewise.

	* cpplib.c (parse_name): Add a prototype and make it static.
	(null_underflow): Mark parameter `pfile' with ATTRIBUTE_UNUSED.
	(null_cleanup): Likewise for parameters `pbuf' and `pfile'.
	(macro_cleanup): Likewise for parameter `pfile'.
	(file_cleanup): Likewise.

	* cpplib.h (cpp_reader_init, cpp_options_init, cpp_start_read,
 	cpp_read_check_assertion, skip_rest_of_line): Add prototypes.

	* crtstuff.c (force_to_data, __CTOR_LIST__, force_to_data,
	__DTOR_END__, __FRAME_END__): Mark with ATTRIBUTE_UNUSED.

	* cse.c (cse_check_loop_start): Mark parameter `set' with
 	ATTRIBUTE_UNUSED.

	* dbxout.c (flag_minimal_debug, have_used_extensions,
	source_label_number): Move inside macro wrapper check against
	defined (DBX_DEBUGGING_INFO) || defined (XCOFF_DEBUGGING_INFO).

	* dwarf2out.c (gen_entry_point_die): Hide prototype and definition.

	* except.h (doing_eh): Provide prototype.

	* expr.c: Move inclusion of expr.h to after insn-config.h.

	* final.c: Include reload.h.
	(shorten_branches): Cast the first argument of bzero to char *.

	* fix-header.c (cpp_print_containing_files): Mark parameter
 	`pfile' with ATTRIBUTE_UNUSED.
	(cpp_fatal): Likewise.

	* flow.c (find_basic_blocks_1): Cast the first argument of bzero
	to char *.

	* genattrtab.c (make_length_attrs): Change the type of variable
	`i' from int to size_t.
	(zero_fn): Mark parameter `exp' with ATTRIBUTE_UNUSED.
	(one_fn): Likewise.

	* genextract.c (main): When generating insn-extract.c, mark
	variable `junk' with ATTRIBUTE_UNUSED.

	* gengenrtl.c (gencode): When generating genrtl.c, cast the first
	argument of bzero to char*.

	* integrate.c: Include toplev.h.

	* libgcc2.c: Wrap `struct exception_table' and
	`find_exception_handler' in macro DWARF2_UNWIND_INFO.

	* objc/Make-lang.in (objc-act.o): Depend on toplev.h.

	* objc/objc-act.c: Include toplev.h.
	(lang_print_xnode): Mark parameters `file', `node' and `indent'
	with ATTRIBUTE_UNUSED.
	(finish_protocol): Likewise for parameter `protocol'.

	* output.h (declare_weak): Add prototype.
	(decode_reg_name): Don't wrap with TREE_CODE macro.
	(assemble_alias): Add prototype.

	* regclass.c: Include output.h.

	* reload.h (reloads_conflict): Add prototype.

	* rtl.h (print_rtl_single, mark_elimiation, reg_class_subset_p,
	output_func_start_profiler): Add prototypes.

	* rtlanal.c (reg_set_p_1): Mark parameters `x' and `pat' with
 	ATTRIBUTE_UNUSED.

	* scan-decls.c: Include scan.h.

	* scan.h (recognized_function, recognized_extern): Add prototypes.

	* stmt.c: Include output.h.

	* toplev.c (error_for_asm, warning_for_asm): Remove prototypes.
	(output_lang_identify): Hide prototype and definition.
	(float_signal): Mark parameter `signo' with ATTRIBUTE_UNUSED.
	(pipe_closed): Likewise.

	* toplev.h (count_error, strip_off_ending, error_for_asm,
 	warning_for_asm): Add prototypes.

Wed May 13 12:54:19 1998  Michael Meissner  <meissner@cygnus.com>

	* toplev.c (rest_of_compilation): "Charge" final for any time
	doing various cleanup operations after finishing compilation
	of a function.

	* flow.c (dump_flow_info): Also print number of sets and
	whether or not the pseudo is a user variable.

	* flow.c (reg_n_max): New global variable.
	* regclass.c (allocate_reg_info): Keep reg_n_max up to date.
	Delete regno_max variable.
	* regs.h (REG_N_CHECK): Define.
	(REG_N_REFS, REG_N_SETS, REG_N_DEATHS): Use REG_N_CHECK.
	(REG_N_CHANGES_SIZE, REG_N_CALLS_CROSSED, REG_LIVE_LENGTH): Likewise.
	(REGNO_FIRST_UID, REGNO_LAST_UID, REGNO_LAST_NOTE_UID): Likewise.

Wed May 13 12:54:19 1998  Martin von Loewis <martin@mira.isdn.cs.tu-berlin.de>

	* acconfig.h (ENABLE_CHECKING): Undefine.
	* configure.in (--enable-checking): New option.

Wed May 13 08:52:08 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload1.c (merge_assigned_reloads):  Can merge
	RELOAD_FOR_INPUT_ADDRESS and RELOAD_FOR_OTHER_ADDRESS even
	if RELOAD_FOR_INPUT with the same reload_reg_rtx is present.

Tue May 12 20:05:57 1998  Jim Wilson  <wilson@cygnus.com>

	* collect2.c (main): Ignore do_collecting when COLLECT_EXPORT_LIST.

Wed May 13 03:23:45 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload1.c (gen_reload): Create REG_EQUIV notes.

Tue May 12 22:21:07 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload1.c (reload): Fix check for USEs to use code of pattern.
	(choose_reload_regs): Remove dead variable use_insn.

Tue May 12 14:04:49 1998  Jeffrey A Law  (law@cygnus.com)

	* pa.h (DBX_CONTIN_LENGTH): Reduce to 3000 bytes.

Tue May 12 15:16:02 1998  Michael Meissner  <meissner@cygnus.com>

	* haifa-sched.c (HAIFA_INLINE): Define to be __inline unless
	already defined.
	(find_insn_{,mem_}list): Use HAIFA_INLINE, not __inline.
	(insn_{unit,issue_delay}): Ditto.
	(blockage_range): Ditto.
	(actual_hazard{,_this_instance}): Ditto.
	(schedule_unit): Ditto.
	(potential_hazard): Ditto.
	(insn_cost): Ditto.
	(swap_sort): Ditto.
	(queue_insn): Ditto.
	(birthing_insn_p): Ditto.
	(adjust_priority): Ditto.
	(get_block_head_tail): Ditto.
	(init_rgn_data_dependences): Ditto.

Tue May 12 10:27:54 1998  Klaus Kaempf  <kkaempf@progis.de>

	* alpha/vms.h (COMMON_ASM_OP, ASM_OUTPUT_ALIGNED_COMMON): Define.

Tue May 12 11:44:14 1998  Gavin Koch  <gavin@cygnus.com>

	* config/mips/mips.h (ASM_OUTPUT_ALIGN): Remove trailing semi-colon.

Tue May 12 11:38:31 1998  Gavin Koch  <gavin@cygnus.com>

	* config/mips/mips.md (dslot): Move after definition of "cpu"
	attribute.  Handle r3900 case.

Tue May 12 10:21:36 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* system.h: Define the STRINGIFY macro here.
	* protoize.c: Not here.
	* gengenrtl.c (DEF_RTL_EXPR): Use the STRINGIFY macro.

Tue May 12 00:47:33 1998  John Wehle  (john@feith.com)

	* varasm.c (assemble_variable): Compute the alignment of the data
	earlier so that both initialized and uninitialized variables are
	effected by DATA_ALIGNMENT.
	* tm.texi (DATA_ALIGNMENT): Updated appropriately.

Mon May 11 19:57:58 1998  Jeffrey A Law  (law@cygnus.com)

	* mips.c: Prototype static functions.

Mon May 11 17:43:03 1998  Jim Wilson  <wilson@cygnus.com>

	* regmove.c (fixup_match_2, find_matches, regmove_profitable):
	Add explanatory comments.

	* sparc.h (SPARC_INCOMING_INT_ARG_FIRST): Support TARGET_FLAT.

Mon May 11 17:24:27 1998  Richard Henderson  <rth@cygnus.com>

	* sparc.md (ffsdi2): Disable.  Simplify the expression as well.

Mon May 11 13:30:44 1998  Jim Wilson  <wilson@cygnus.com>

	* varasm.c (make_decl_rtl): Disable April 1 change.

Mon May 11 09:14:41 1998  Richard Henderson  <rth@cygnus.com>

	* configure.in (alpha-*-linux-gnu): Undo lossage from gcc2 merge.

Mon May 11 08:24:18 1998  Richard Henderson <rth@cygnus.com>

	* alpha.h (PRINT_OPERAND_PUNCT_VALID_P): Add '`'.
	* alpha.c (print_operand): Handle it.
	* alpha.md (fix_truncdfsi2, fix_truncsfsi2): New patterns and
	related define_splits.  Also add peepholes for SImode reload
	plus sign_extend lossage.

Mon May 11 09:33:10 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

        * genattr.c: Include stdarg.h/varargs.h.  Change function
	`fatal' to use variable arguments instead of faking it with
	integer parameters.  Provide a prototype which also
        checks the format specifiers using ATTRIBUTE_PRINTF_1.

        * genattrtab.c: Likewise.
        * gencodes.c: Likewise.
        * genconfig.c: Likewise.
        * genemit.c: Likewise.
        * genextract.c: Likewise.
        * genflags.c: Likewise.
        * genopinit.c: Likewise.
        * genpeep.c: Likewise.
        * genrecog.c: Likewise.
        * genoutput.c: Likewise.  Similarly for function `error'.

Sun May 10 02:27:03 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* acconfig.h (HAVE_VOLATILE): Insert stub for autoconf.
	* alocal.m4 (GCC_C_VOLATILE): New autoconf test.
	* configure.in: Use GCC_C_VOLATILE.
	* system.h (volatile): Define as empty if no volatile support is
	available.

Sun May 10 01:21:43 1998  Jeffrey A Law  (law@cygnus.com)

	* genemit.c (output_add_clobbers): Removed unused variable 'i' from
	generated fucntion.

Sat May  9 02:02:15 1998  Richard Henderson  <rth@cygnus.com>

	* loop.c (get_condition): Don't combine when either compare is MODE_CC.
	* alpha.c (alpha_emit_conditional_branch): New function.  Taken from
	the body of beq; additionally set the mode of the branch to CCmode for
	FP compares and not fast_math.
	(alpha_emit_conditional_move): Always use a compare insn for FP
	when not fast_math, as well as setting CCmode on the cmov.
	* alpha.md (beq, bne, blt, et al): Call alpha_emit_conditional_branch.

	* machmode.h (COMPLEX_MODE_P): New macro.

Sat May  9 01:53:23 1998  Richard Henderson  <rth@cygnus.com>

	* haifa-sched.c (print_exp): Fix typo.

Fri May 8 21:48:50 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Fri May  8 18:23:08 1998  Michael Meissner  <meissner@cygnus.com>

	* final.c (final_scan_insn): Call fatal_insn instead of abort if
	we could not split an insn when required to.

	* m32r.md ({add,sub}di3): Add define_splits and appropriate low
	level insns.
	(peepholes): Disable peepholes that call dead_or_set_p.
	(movsi): Rewrite to handle addresses better after last change.
	Add define_split to split load of addresses in large/medium modes.
	(prologue): Call m32r_expand_prologue.
	(movsi_{push,pop}): Generators for push/pop.
	(movsi): Support PRE_{INC,DEC}, POST_INC.
	(mov{di,df}): Rewrite.  Always split the insns.
	(movsf): Add define_split to get register load in correct mode.
	(cmp_ne_small_const_insn): Use 'N' instead of 'S' constraint.
	(attributes): Rewrite attributes so that type indicates both the
	type and the length of the insn directly.
	(all insns): Change to use new type attributes.
	(debug): New attribute to convey whether -mdebug was used.
	(opt_space): New attribute to convey whether -Os was used.
	(function units): Loads are 3 cycles, not 2.  Better classify all
	insns into short/long.
	(load/store/extend insns): Add separate case for load/store
	indirect operations without an offset.
	(divsi3): Division is a long operation, not short.

	* m32r.h (LEGITIMATE_LO_SUM_ADDRESS_P): Do not allow LO_SUM for
	modes > 1 word.
	(GO_IF_MODE_DEPENDENT_ADDRESS): LO_SUM is now mode dependent.
	(CONST_OK_FOR_LETTER_P): Make 'N' handle reverse 8 bit compares.
	(EXTRA_CONSTRAINT): Remove 'S' special support.  Add 'U' for
	operands with PRE_{INC,DEC}, POST_INC.
	(FUNCTION_PROFILER): Call abort instead of doing nothing.
	(GO_IF_LEGITIMATE_ADDRESS): Allow PRE_{INC,DEC}, POST_INC of
	SImode variables.
	(gen_split_move_double): Declare.
	(EXTRA_CONSTRAINT): Add 'T' for memory reference with no offset.

	* m32r.c (gen_split_move_double): Fix typo.  Also, don't call
	emit_move_insn, build up SET's directly.
	(toplevel): Include system.h, not stdio.h.
	(move_double_src_operand): Allow any DF or DI mode constant.
	(gen_split_move_double): Split moves of DI or DF values into the
	appropriate moves, loads, or stores.  Don't handle use of auto
	inc/dec if using dead index.  Do handle overlapping moves, etc.
	(m32r_frame_info): Remove prologue_size field.
	(m32r_compute_frame_size): Don't calculate prologue size.
	(m32r_output_function_prologue): Change to pretty much a NOP.
	(m32r_expand_prologue): Expand prologue as a series of INSNs.
	(m32r_print_operand): Add support for PRE_{INC,DEC}, POST_INC.
	(m32r_print_operand_address): Ditto.

Fri May  8 14:13:21 1998  H.J. Lu  (hjl@gnu.org)

	* reload1.c (emit_reload_insns): When performing expensive
	optimizations, do not output the last reload insn if OLD is
	not the dest of NSN and is in the src and is clobbered by INSN.

Fri May  8 09:47:29 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (genrtl.o): Depend on system.h.
	* gengenrtl.c (gencode): When creating genrtl.c, have it
	include system.h.

Fri May  8 10:57:33 1998  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* config/m68k/t-linux: Remove extra stuff already included in
	config/t-linux.

Fri May  8 09:53:24  Paul Eggert  <eggert@twinsun.com>

	* fixinc.wrap: Renamed from fixinc.math.  Put wrapper around
	curses.h if it contains `typedef char bool;', as suggested by
	Manfred Hollstein <manfred@s-direktnet.de>.

	* configure.in: Rename fixinc.math to fixinc.wrap.

Thu May  7 19:26:34 1998  Jim Wilson  <wilson@cygnus.com>

	* gcc.c (read_specs): Handle missing blank line at end of specs file.

	* i386.md (movsicc, movhicc, movsicc_1, movhicc_1, movsfcc_1,
	movdfcc_1): Disable.

Thu May  7 15:39:14 1998  Jim Wilson  <wilson@cygnus.com>

	* configure.in (enable_threads): Rename to enable_threads_flag before
	main loop.  Set enable_threads to enable_threads_flag inside main
	loop.

Thu May  7 17:38:03 1998  Michael Meissner  <meissner@cygnus.com>

	* r6000/eabi.asm (__eabi): Restore LR in case __eabi is called
	multiple times.

Thu May  7 14:26:05 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* aclocal.m4 (GCC_FUNC_VFPRINTF_DOPRNT): New macro.

	* configure.in: Add a call to GCC_FUNC_VFPRINTF_DOPRNT.
	(AC_CHECK_HEADERS): Remove unused check for varargs.h,sys/varargs.h.
	(AC_CHECK_FUNCS): Remove unused check for vprintf.

	* Makefile.in: Add support for linking in vfprintf.c and doprint.c.
	(cccp.o): Depend on gansidecl.h.
	(cexp.o): Likewise.

	* cccp.c: Convert from using PRINTF_ALIST/PRINTF_DCL to VPROTO as
 	per the rest of gcc source.
  	* cexp.y: Likewise.  Include gansidecl.h and remove all code made
 	redundant.

	* cccp.c: Remove checks for HAVE_VPRINTF and the associated code
	used when vfprintf is missing.
	* cexp.y: Likewise.
	* gcc.c: Likewise.
	* genattrtab.c: Likewise.
	* mips-tfile.c: Likewise.
	* toplev.c: Likewise.

	* vfprintf.c: New file.
	* doprint.c: New file.

Thu May  7 10:18:41 1998  Jeffrey A Law  (law@cygnus.com)

	* config/linux.h (ASM_COMMENT_START): Remove from here,
	* config/linux-aout.h (ASM_COMMENT_START): and here,
	* config/i386/linux.h (ASM_COMMENT_START): to here,
	* config/i386/linux-aout.h (ASM_COMMENT_START): and here.
	* config/i386/linux-oldld.h (ASM_COMMENT_START): Define
	here as '#' too.

Thu May  7 10:55:59 1998  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* config/m68k/m68k.md (adddi3, subdi3): Properly negate the DImode
	constant.

Wed May  6 22:32:37 CDT 1998 Robert Lipe  <robertl@dgii.com>

	* Makefile.in (dwarfout.o) Add toplev.h dependency.
	* dwarfout.c, i386.c: Include toplev.h
	* toplev.h: (pfatal_with_name) Add prototype.

Wed May  6 19:02:29 1998  Jason Merrill  <jason@yorick.cygnus.com>

	* Makefile.in: Fix .SUFFIXES.

Wed May  6 19:31:32 1998  Alan Modra <alan@spri.levels.unisa.edu.au>

	* config/linux.h (ASM_COMMENT_START): Define as "#".
	* config/linux-aout.h (ASM_COMMENT_START): Likewise.

Wed May  6 15:51:39 1998  Jim Wilson  <wilson@cygnus.com>

	* objc/Make-lang.h (objc-parse.o): Add toplev.h dependency.
	* objc/objc-parse.y, objc/objc-parse.c: Regenerate.

	* toplev.c: Include toplev.h.
	* Makefile.in (c-common.o, c-convert.o, c-decl.o, c-iterate.o,
	c-lex.o, c-parse.o, c-pragma.o, c-typeck.o, calls.o, convert.o,
	dwarf2out.o, except.o, expr.o, final.o, fold-const.o, function.o,
	hash.o, profile.o, real.o, reg-stack.o, regclass.o, reload.o,
	reload1.o, stmt.o, stor-layout.o, tlink.o, tree.o, varasm.o): Add
	toplev.h dependency.

	* mips/mips.c (save_restore_insns): Change FRAME_POINTER_REGNUM to
	HARD_FRAME_POINTER_REGNUM.

	* expr.c (target_temp_slot_level): Delete duplicate definition.

Wed May  6 16:46:01 1998  Jeffrey A Law  (law@cygnus.com)

	* stmt.c (mark_seen_cases): Make it have external linkage again.
	* expr.h (mark_seen_cases): Add declaration, but only when tree.h
	has been included.

	* haifa-sched.c (print_value, case SUBREG): Fix typo.

	* i386.c (output_387_binary_op): Add some braces to avoid warnings.
	* i386.h (REG_CLASS_CONTENTS): Similarly.

	* toplev.c (-fsched-max): Delete flag.
	(-fsched-interblock-max-blocks,-fsched-interblock-max-insns): Likewise.
	* haifa-sched.c: Remove -fsched-max-N, -fsched-interblock-max-blocks-N
	and -fsched-interblock-max-insns-N support.  Remove INTERBLOCK_DEBUG
	conditionals.

	* haifa-sched.c (find_rgns): Correctly handle reducible loops with
	inner loops which are not reducible.

	* loop.c (regs_match_p): Fix typo in prototype.

	* regmove.c (try_auto_increment): Wrap declaration inside an
	#ifdef AUTO_INC_DEC.

Wed May  6 17:07:47 1998  Michael Meissner  <meissner@cygnus.com>

	* final.c (output_operand_lossage): Call fatal with the operand
	lossage message instead of calling abort.

Wed May  6 15:37:27 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* c-common.c: Convert to using ctype macros defined in system.h.
	* c-lex.c: Likewise.
	* cccp.c: Likewise.
	* collect2.c: Likewise.
	* rs6000.c: Likewise.
	* cpplib.c: Likewise.
	* fix-header.c: Likewise.
	* gcc.c: Likewise.
	* gen-protos.c: Likewise.
	* pexecute.c: Likewise.
	* protoize.c: Likewise.
	* rtl.c: Likewise.
	* scan.c: Likewise.
	* stmt.c: Likewise.
	* tlink.c: Likewise.
	* toplev.c: Likewise.

Wed May  6 14:44:14 1998  Gavin Koch  <gavin@cygnus.com>

	* config/mips/r3900.h (SUBTARGET_ASM_DEBUGGING_SPEC) :
	Replace -gdwarf-2 with -g0.

Wed May  6 11:43:18 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (mips-tfile.o, mips-tdump.o): Depend on system.h.
	* mips-tdump.c: Include system.h, remove redundant headers.
	* mips-tfile.c: Likewise.  Also, convert all ctype function calls
	to calls of the macro versions defined in system.h.

	* objc/Make-lang.in (objc-act.o): Depend on system.h.
	* objc/objc-act.c: Include system.h, remove redundant headers.

Wed May  6 11:21:06 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* configure.in (AC_CHECK_FUNCS): Add isascii.
	(GCC_NEED_DECLARATIONS): Add atof.

	* system.h: Provide prototypes for abort, atof, atol and sbrk here.
	* rtl.c, rtl.h, toplev.c, tree.h: Not here.

Wed May  6 10:52:49 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* system.h: Wrap time.h and sys/file.h in autoconf checks.
	Provide default definitions for O_RDONLY and O_WRONLY here.

	* cccp.c, cpplib.c, fix-header.c, gcc.c, protoize.c: Not here.

1998-05-06 Mark Mitchell  <mmitchell@usa.net>

	* tree.h (IS_EXPR_CODE_CLASS): Remove bogus '3'.

Wed May  6 06:35:38 1998  Robert Lipe  <robertl@dgii.com>

	* toplev.h: New file.   Protypes for functions in toplev.c.
	* tree.h, rtl.h: Deleted protos for functions in toplev.c.
	* c-common.c, c-convert.c, c-decl.c, c-iterate.c, c-lex.c,
	c-parse.in, c-parse.y, c-pragma.c, c-typeck.c, calls.c,
	convert.c, dwarf2out.c, except.c, expr.c, final.c, fold-const.c,
	function.c, hash.c, profile.c, real.c, reg-stack.c, regclass.c,
	reload.c, reload1.c, stmt.c, stor-layout.c, tlink.c, tree.c,
	varasm.c: include it.

Wed May  6 01:09:01 1998  Jeffrey A Law  (law@cygnus.com)
			  Jim Wilson (wilson@cygnus.com)

	* haifa-sched.c (find_rgns): In no_loops case, fix test for leaf
	blocks.  Check for 1 successor which is the EXIT_BLOCK.

	* haifa-sched.c (find_rgns): Detect unreachable blocks, including
	unreachable loops with more than one block.

Wed May  6 08:22:24 1998  Manfred Hollstein  <manfred@s-direktnet.de>

	* fix-header.c (write_rbrac): Add "abort" to functions which need to
	be protected.

Wed May  6 00:09:36 1998  Jeffrey A Law  (law@cygnus.com)

	* Check in merge from gcc2.  See ChangeLog.12 for details.

Tue May  5 14:33:49 1998  Jim Wilson  <wilson@cygnus.com>

	* c-common.c (scan_char_table): Separate 's' and 'c'.  'c' does not
	accept 'a' flag.  'S' does accept 'a' flag.
	(check_format_info): When pedantic, warn for m/C/S/a/A formats,
	and `a' flag.

	* elf64.h (MULTILIB_DEFAULTS): Move definition after mips.h include.

Tue May  5 10:50:39 1998  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* config/m68k/m68k.h: Declare functions from m68k.c used in
	macros and machine description.
	(ASM_OUTPUT_LONG_DOUBLE): Always use `l' flag in print format for
	long values.
	(ASM_OUTPUT_FLOAT): Likewise.
	(ASM_OUTPUT_FLOAT_OPERAND): Likewise.

Tue May  5 01:28:12 1998  Jason Merrill  <jason@yorick.cygnus.com>

	* tree.def: Add NAMESPACE_DECL.
	* dwarfout.c (type_ok_for_scope): Ignore NAMESPACE_DECLs for now.
	* dwarf2out.c (push_decl_scope): Likewise.
	(scope_die_for): Likewise.
	* tree.c (decl_function_context): Use TREE_CODE_CLASS to determine
	how to get next context level.

Tue May  5 01:43:16 1998  Jim Wilson  <wilson@cygnus.com>

	* i386.c (output_fix_trunc): Add code to emulate non-popping DImode
	case.

Tue May  5 01:15:06 1998  Jeffrey A Law  (law@cygnus.com)

	* h8300.h (ADDITIONAL_REGISTER_NAMES): Add "er" registers.

	* reorg.c (fill_slots_from_thread): Update REG_DEAD/REG_UNUSED notes
	for any insns skipped at the start of a block because they were
	redundant.

Mon May  4 20:23:51 1998  Jim Wilson  <wilson@cygnus.com>

	* alpha.h (DBX_CONTIN_LENGTH): Decrease to 3000.

1998-05-04  Ulrich Drepper  <drepper@cygnus.com>

	* c-common.c (format_char_info): Add new field hhlen.
	(print_char_table, scan_char_table, time_char_table): Initialize
	hhlen field appropriately.
	(char_format_info): Recognize hh modifier and lookup correct char
	table entry.

Mon May  4 19:15:29 1998  Jim Wilson  <wilson@cygnus.com>

	* expr.c (expand_expr, case INDIRECT_REF): Don't optimize string
	reference if this is a store.

Mon May  4 17:25:17 1998  Richard Henderson  <rth@cygnus.com>

	* sparc.c (output_move_quad): Fix typo in mov_by_64 argument.

Sun May  3 23:57:25 1998  Robert Lipe   <robertl@dgii.com>

	Make UnixWare 7 bootstrap support work with final shipping product.
	* configure.in: (i[34567]86-*-sysv5): append, not overwrite, xm_file.
	Pick up xm-siglist and xm-alloca.
	(xm_defines): Add USG so dbxout will build.
	* configure: Regenerate.

Sun May  3 13:51:34 PDT 1998  Richard Henderson  <rth@cygnus.com>

	Support for official Sparc V9 ABI:
	* sparc.c (sparc_override_options): Force stack bias off for !arch64.
	Care for flag_pcc_struct_return default.
	(output_move_quad): Rewrite to move by halves on v9 and in the
	proper direction.
	(move_quad_direction): New function.
	(output_fp_move_quad): Use it to determine the direction of copy.
	(function_arg_slotno): Return -1 for FP reg overflow as well.
	(function_arg_record_value*): New functions.
	(function_arg): Use them.  Streamline unprototyped parameter passing.
	(function_arg_pass_by_reference): Pass TCmode by reference.
	(function_value): New function.
	* sparc.h (PTRDIFF_TYPE, SIZE_TYPE): For -pedantic's sake, don't use
	long long in 64-bit mode.
	(RETURN_IN_MEMORY): v9 returns structs < 32-bytes in regs.
	(DEFAULT_PCC_STRUCT_RETURN): Make the default detectable.
	(BASE_RETURN_VALUE_REG): Consider complex float types for arch64.
	(BASE_OUTGOING_VALUE_REG, BASE_PASSING_ARG_REG): Likewise.
	(BASE_INCOMING_ARG_REG): Likewise.
	(FUNCTION_VALUE): Call function_value.
	(FUNCTION_OUTGOING_VALUE, LIBCALL_VALUE): Likewise.
	* sparc.md (movdi_sp32_v9): Disable for arch64.
	(movsf, movdf, movtf): Sort all ulternatives using fp regs first.
	(call_value_address_sp64): Remove register class constraints.
	(call_value_symbolic_sp64): Likewise.
	(nonlocal_goto): Pass label reg directly to goto_handlers.  Constrain
	v9 case to 32-bit constants.
	(goto_handler_and_restore_v9): Provide a version for arch64.
	* sparc/linux64.h (SIZE_TYPE, PTRDIFF_TYPE): Remove private definition.
	* sparc/sp64-aout.h (TARGET_DEFAULT): Turn on stack bias.
	(CPP_PREDEFINES): New.
	* sparc/sp64-elf.h: Likewise.
	(PREFERRED_DEBUGGING_TYPE): Dwarf2.
	(ASM_OUTPUT_DWARF2_ADDR_CONST): New.
	* sparc/sysv4.h (SIZE_TYPE, PTRDIFF_TYPE): Undo svr4.h's changes.

Sat May 2 17:47:17 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Sat May  2 01:37:29 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* reload.c (find_reloads): Emit USEs to mark where a pseudo
	is reloaded with the MEM of its stack slot.
	* reload1.c (cannot_omit_stores): Delete.
	(reload): Don't initialize it.
	Don't apply avoid_return_reg logic to USEs.
	When done, remove USEs that have a REG_EQUAL note on them.
	(emit_reload_insns): Handle case where we have inherited a MEM.
	(choose_reload_regs): Likewise.
	(delete_output_reload): Don't use cannot_omit_stores.

Thu Apr 30 18:59:03 1998  Jim Wilson  <wilson@cygnus.com>

	* Makefile.in (cpp.info, gcc.info): Put -o option before input file.

Thu Apr 30 16:57:34 1998  Michael Meissner  <meissner@cygnus.com>

	* haifa-sched.c (print_{exp,value}): Various changes to make the
	debug output easier to read.  Also, use only one buffer, and make
	sure the buffer we are passed in doesn't overflow.
	(safe_concat): Concatenate to a buffer without overflow.

Thu Apr 30 16:57:34 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* haifa-sched.c (alloc_{INSN,EXPR}_LIST): Make static to agree
	with the prototype.

Wed Apr 29 21:45:16 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sched.c (new_insn_dead_notes): Check if the register was
	used in the original instruction.
	* haifa-sched.c (new_insn_dead_notes): Likewise.

Wed Apr 29 13:46:03 1998  Jim Wilson  <wilson@cygnus.com>

	* dwarf2out.c (scope_die_for): If could not find proper scope,
	check for and handle tagged type with incorrect TYPE_CONTEXT.

Wed Apr 29 15:34:40 1998  John Carr  <jfc@mit.edu>

	* calls.c (expand_call): Fix recognition of C++ operator new.

	* alias.c (mode_alias_check): Disable type based alias detection.

Wed Apr 29 15:06:42 1998  Gavin Koch  <gavin@cygnus.com>

	* config/mips/elf.h (ASM_OUTPUT_DEF,ASM_WEAKEN_LABEL,
	ASM_OUTPUT_WEAK_ALIAS): Define.
	* config/mips/elf64.h: Same.
	* config/mips/r3900.h (ASM_OUTPUT_DEF,SUPPORTS_WEAK,
	ASM_WEAKEN_LABEL): Removed.

Wed Apr 29 10:53:29 1998  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* calls.c (expand_call): Bump the length limit on the specially
	recognized function names to 17.

Tue Apr 28 17:53:33 1998  Jim Wilson  <wilson@cygnus.com>

	* ginclude/stddef.h: Add check for _MACHINE_ANSI_H_ for BSD/OS
	when undefining macros at the end.

	* expr.c (expand_builtin, case BUILT_IN_MEMSET): Break if either
	val or len has TREE_SIDE_EFFECTS set.

	* sparc.md (mulsidi3): Call const v8plus and v8plus routines.
	(mulsidi3_v8plus, const_mulsidi3_v8plus): Delete asterisk from name.
	(smuldi3_highpart): Call const v8plus routine.
	(smulsi3_highpart_v8plus): Renamed from smulsidi3_highpart_v8plus.
	(const_smulsi3_highpart_v8plus): New pattern.
	(smulsi3_highpart_sp32): Renamed from smulsidi3_highpart_sp32.
	(umulsidi3): Call const v8plus routine.
	(umulsi3_highpart): Handle const before v8plus.  Call const v8plus
	routine.
	(umulsi3_highpart_v8plus): Renamed from umulsidi3_highpart_v8plus.
	(umulsi3_highpart_sp32): Renamed from umulsidi3_highpart_sp32.

Tue Apr 28 08:55:26 1998  Michael Meissner  <meissner@cygnus.com>

	* m32r.c (*_oper{and|ator}): Change enum arguments and return
	values to int, so they can be prototyped even in files that don't
	include rtl.h.
	({small,large}_insn_p): Ditto.
	(m32r_select_cc_mode): Ditto.
	(gen_compare): Ditto.
	(function_arg_partial_nregs): Ditto.
	(m32r_setup_incoming_varargs): Ditto.
	(init_reg_tables): Add prototype.
	(m32r_frame_info): Add prolog_size field.
	(m32r_compute_frame_size): Calculate the size of the prologue.
	(m32r_first_insn_address): Return prologue size.
	(m32r_output_function_prologue): Calculate frame size before
	printing out information.  Print out the prologue size.

	* m32r.h: Prototype all functions in m32r.c.
	(FIRST_INSN_ADDRESS): Declare, returning prologue size.

	* m32r.md (bcc functions): Cast enum's to int.

	* m32r.c (conditional_move_operand): Silence a debug message.
	({small,long}_insn): New predicates.

	* m32r.h (TARGET_M32R): New macro.
	(PREDICATE_CODES): Rearrange somewhat, add small_insn/long_insn.
	(HAIFA_P): Define as 1/0 depending on whether the Haifa scheduler
	was selected.
	(ISSUE_RATE): Define as 2.

	* m32r.md (insn_size): New attribute.
	({,rev_}branch_insn): Add .s qualifier to branches believed to be
	short.
	(m32r): New attribute.

	* configure.in (enable_haifa): Switch m32r to Haifa by default.
	* configure: Regenerate.

	(Changes from Nick Clifton <nickc@cygnus.com>)
	* m32r.h (EXTRA_CONSTRAINT): Implement 'S' constraint to perfoirm
	the equivalent of a negated 'I' constraint.
	(PRESERVE_DEATH_INFO_REGNO_P): Define in order to allow peephole
	optimisation to work.

	* m32r.md (cmp_ne_small_const_insn): Use 'S' constriant rather
	than 'I' since the value is negated.
	(peephole): Add peephole optimisation to cope with optimization of
	divide and subtracts of the same operands.

	* m32r.c zero_and_one, emit_cond_move): Add support for MVFC.
	* m32r.h: Ditto.
	* m32r.md: Ditto.

	* m32r.h (PREDICATE_CODES): Add declaration of machine specific
	predicates.

Tue Apr 28 07:25:53 1998  Manfred Hollstein  <manfred@s-direktnet.de>

	* Makefile.in (libgcc2.ready): Revert last patch (Apr 24).

Mon Apr 27 18:39:47 1998  Nick Clifton  <nickc@cygnus.com>

	* config/arm/thumb.h (GO_IF_LEGITIMATE_ADDRESS): Check against
	frame_pointer_rtx not FRAME_POINTER_REGNUM.

Mon Apr 27 18:36:28 1998  Jim Wilson  <wilson@cygnus.com>

	* reg-stack.c: Revert last patch (Apr 20).
	(convert_regs): Set insn to PREV_INSN (next) after do while loop.

	* m68k/lb1sf68.asm (Laddsf$3): Fix typos in mcf5200 exg code.

	* loop.c (check_dbra_loop): New locals jump, first_compare, and
	compare_and_branch.  Call get_condition to set first_compare.
	Set compare_and_branch to number of compare/branch instructions.
	Replace PREV_INSN (PREV_INSN (loop_end)) with first_compare.
	Replace '2' with compare_and_branch.

Mon Apr 27 15:53:30 EDT 1998 Andrew MacLeod <amacleod@cygnus.com>

	* cplus-dem.c (demangle_qualified): Replace missing else.

Mon Apr 27 20:22:08 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sh.c (gen_ashift_hi): Don't make SUBREG of a SUBREG.

Mon Apr 27 18:23:51 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

        * sh.c (sh_expand_prologue, sh_expand_epilogue):
        If TARGET_DOUBLE_ALIGN, preserve 64 bit stack alignment.
        * sh.h (STACK_BOUNDARY): Likewise.

Mon Apr 27 17:22:48 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sh.h (LEGITIMIZE_RELOAD_ADDRESS): Define.

Mon Apr 27 08:55:23 1998  Michael Meissner  <meissner@cygnus.com>

	* system.h (abort): If abort is not defined, and neither is
	USE_SYSTEM_ABORT, redefine abort to call fprintf and exit,
	reporting the line and filename of the error.

	* .gdbinit: Add breakpoints on exit and fancy_abort.

	* final.c (split_double): Avoid a compiler warning if
	BITS_PER_WORD is less than or equal to HOST_BIT_PER_WIDE_INT.

	* rtl.h (JUMP_{CROSS_JUMP,NOOP_MOVES,AFTER_REGSCAN}):  New macros
	for calling jump_optimize.

	* toplev.c (rest_of_compilation): Call jump_optimize using JUMP_*
	macros, rather than 0/1's.

Sun Apr 26 23:19:10 1998  Richard Henderson  <rth@cygnus.com>

	* alpha.h (CONST_COSTS): Zero is always free.
	(RTX_COSTS): Add EV6 costs.  Abort if alpha_cpu is unknown.

Sun Apr 26 15:38:50 1998  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* cplus-dem.c (gnu_special): Fix off-by-one bug when checking the
	length in the name of a virtual table.

Sun Apr 26 01:21:06 1998  Richard Henderson  <rth@cygnus.com>

	* alpha.c (print_operand): Don't add 'v' suffix for ALPHA_FPTM_N.

Sat Apr 25 22:11:38 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Sat Apr 25 17:17:15 1998  Jeffrey A Law  (law@cygnus.com)

	* fold-const.c (fold_convert): Fix typo.

Sat Apr 25 17:55:54 1998  John Carr  <jfc@mit.edu>

	* alias.c (alias_invariant): New variable.
	(record_base_value): New argument INVARIANT.
	(memrefs_conflict_p): If a register has an entry in the alias_invariant
	array, try substituting that value for the register.

	* rtl.h: Declare record_base_value.

	* loop.c, unroll.c: Update callers of record_base_value.

	* alias.c (find_base_value, find_base_term): SIGN_EXTEND and
	ZERO_EXTEND do not affect base values.

Fri Apr 24 15:57:02 1998  Jeffrey A Law  (law@cygnus.com)

	* dbxout.c (dbxout_type): Fix typo.
	(dbxout_range_type): Another HOST_WIDE_INT_PRINT_DEC fix.

	* configure.in: Use CC_FOR_BUILD, not BUILD_CC.

Fri Apr 24 16:11:47 1998  John Carr  <jfc@mit.edu>

	* expr.c (expand_builtin, case MEMSET): Set MEM_IN_STRUCT_P
	if the argument is the address of a structure or array.

	* configure.in: Enable Haifa scheduler by default for SPARC.

Fri Apr 24 20:55:47 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* cse.c (cse_set_around_loop): Don't do optimization when
	new pseudos are created.

Fri Apr 24 11:00:18 1998  Jeffrey A Law  (law@cygnus.com)

	* dbxout.c (dbxout_type_fields): Use HOST_WIDE_INT_PRINT_DEC
	appropriately.
	(dbxout_type_method_1, dbxout_type): Likewise.
	(print_int_cst_octal, print_octal, dbxout_symbol): Likewise.
	(dbxout_type): Fix check for when to print a type range in
	octal vs decimal.

Fri Apr 24 16:45:03 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* (gen_shl_and, in case 1): Fix comparison with mask.

Fri Apr 24 06:46:40 1998  Nick Clifton  <nickc@cygnus.com>

	* config/arm/thumb.h (GO_IF_LEGITIMATE_ADDRESS): Disallow frame
	pointer as second register in REG+REG pair.

Fri Apr 24 09:22:23 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* c-common.c (check_format_info): Don't check for the 'x' format
	character twice, instead check for 'x' and 'X'

Fri Apr 24 08:02:30 1998  Manfred Hollstein  <manfred@s-direktnet.de>

	* Makefile.in (libgcc2.ready): Add explicit dependancy from
	$(STMP_FIXPROTO) to ensure all necessary include files have
	been created and to guarantee proper parallel builds.

Fri Apr 24 04:42:35 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sh.c (sh_expand_prologue, in !SH3E code): Don't push an extra
	register for stdarg functions.
	* sh.h (current_function_varargs): Declare.
	(FUNCTION_ARG): Ignore NAMED for stdarg functions.

1998-04-23  Jim Wilson  <wilson@cygnus.com>

	* frame.c, libgcc2.c (stdlib.h, unistd.h): Don't include when
	inhibit_libc is defined.

	* c-aux-info.c (gen_type): Use DECL_NAME only for TYPE_DECL.

Thu Apr 23 19:09:33 1998  Jim Wilson  <wilson@cygnus.com>

	* profile.c (tablejump_entry_p): New function.
	(branch_prob): Add code to recognize MIPS tablejump entry branch.
	Use tablejump_entry_p in MIPS and HPPA tablejump checking code.

Thu Apr 23 15:01:13 1998  Nick Clifton  <nickc@cygnus.com>

	* config/arm/arm.c (find_barrier): Return as soon as a barrier is
	found, rather than at end of the loop, after the insn has been
	changed.

Thu Apr 23 20:21:06 1997  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sh.c (gen_ashift_hi): Implement right shifts via gen_ashift.
	* sh.md (ashrhi3_k, lshrhi3_k, lshrhi3_m, lshrhi3, lshrhi3+1): Delete.

Wed Apr 22 17:07:35 1998  Michael Meissner  <meissner@cygnus.com>

	* loop.c (note_addr_stored): Correct function to take 2 arguments,
	instead of 1.

	* rtl.def (MATCH_INSN2): Add new matching pattern.
	* genrecog.c (add_to_sequence): Support MATCH_INSN2.

Wed Apr 22 15:52:22 1998  John Carr  <jfc@mit.edu>

	* emit-rtl.c (gen_highpart): The high part of a CONST_INT is not zero
	if HOST_BITS_PER_WIDE_INT is larger than BITS_PER_WORD.

	* final.c (split_double): Sign extend both halves of a split CONST_INT.

Wed Apr 22 10:42:45 1998  Jeffrey A Law  (law@cygnus.com)

	* mips.c (compute_frame_size): Change only argument to a HOST_WIDE_INT.

Wed Apr 22 10:53:49 EDT 1998 Andrew MacLeod  <amacleod@cygnus.com>

	* cplus-dem.c (struct work stuff): Add field for B and K mangle codes.
	(cplus_demangle_opname): Call mop_up_squangle.
	(cplus_demangle): Initialize squangle info, then call
	internal_cplus_demangle. (Most code moved there as well)
	(internal_cplus_demangle): New function, performs most of what use
	to be done in cplus_demangle, but is only called with this file.
	(squangle_mop_up): New function to clean up B and K code data.
	(mop_up): set pointers to NULL after freeing.
	(demangle_signature, demangle_template, demangle_class): Add
	switch elements to handle K and B codes.
	(demangle_prefix, gnu_special, demangle_qualified): Add
	code to handle K and B codes.
	(do_type, demangle_fund_type): Handle B and K codes.
	(remember_Ktype): New function to store K info.
	(register_Btype, remember_Btype): New functions for B codes.
	(forget_B_and_K_types): New function to destroy B and K info.

1998-04-21  Jim Wilson  <wilson@cygnus.com>

	* stmt.c (check_seenlabel): When search for line number note for
	warning, handle case where there is no such note.

Tue Apr 21 20:48:37 1998  John Carr  <jfc@mit.edu>

	* genemit.c (gen_exp): Allow machine description to set mode of
	MATCH_OP_DUP.

Tue Apr 21 16:36:01 1998  John Carr  <jfc@mit.edu>

	* alias.c (mode_alias_check): New function.
	(true_dependence, anti_dependence, output_dependence): Call
	mode_alias_check.

Tue Apr 21 12:05:32 1998  Jeffrey A Law  (law@cygnus.com)

	* mips.h (STACK_BOUNDARY): Allow specific targets to override.
	(MIPS_STACK_ALIGN): Similarly.

	* c-common.c (type_for_mode): Handle TI types.
	* c-decl.c (intTI_type_node, unsigned_int_TI_type_node): Define.
	(init_decl_processing): Handle TI types.
	* c-tree.h (intTI_type_node, unsigned_int_TI_type_node): Declare.

	* mips.c (block_move_loop): Test Pmode == DImode instead of
	TARGET_MIPS64.
	(expand_block_move, save_restore_insns): Likewise.
	(function_prologue, mips_expand_prologue): Likewise.
	(mips_expand_epilogue): Likewise.
	* mips.h (POINTER_SIZE): Allow specific targets to override.
	(Pmode): Allow specific targets to override.
	(FUNCTION_PROFILER): Test Pmode == DImode instead of TARGET_MIPS64
	(POINTER_BOUNDARY, FUNCTION_MODE): Likewise.
	(TRAMPOLINE_TEMPLATE, TRAMPOLINE_SIZE): Likewise.
	(TRAMPOLINE_ALIGNMENT, INITIALIZE_TRAMPOLINE): Likewise.
	(CASE_VECTOR_MODE, ASM_OUTPUT_ADDR_VEC_ELT): Likewise.
	(ASM_OUTPUT_ADDR_DIFF_ELT, SIZE_TYPE, PTRDIFF_TYPE): Likewise.
	* mips.md (indirect, tablejump & casesi support): Test for
	Pmode == DImode instead of TARGET_MIPS64.
	(call patterns): Likewise.

Tue Apr 21 09:43:55 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* objc/sendmsg.c: Define gen_rtx_MEM() to 1, as is already done
	for gen_rtx(MEM, ...).

Tue Apr 21 02:15:36 1998  Richard Henderson  <rth@cygnus.com>

	* sparc.h (MACHINE_STATE_SAVE, MACHINE_STATE_RESTORE): Rewrite
	to not be so gross, and to properly function with PIC.

Mon Apr 20 20:44:25 1998  Jim Wilson  <wilson@cygnus.com>

	* frame.c (heapsort): Rename to frame_heapsort.

	* gcc.c (do_spec_1, case '['): Move flag out of loop and initialize it.

Mon Apr 20 12:43:09 1998  Doug Evans  <devans@canuck.cygnus.com>

	* flow.c (sbitmap_vector_alloc): Ensure sbitmaps properly aligned.

Mon Apr 20 15:04:14 1998  John Wehle  (john@feith.com)

	* i386.md (movsf_push, movdf_push, movxf_push): Allow memory
	operands during and after reload.

Mon Apr 20 22:37:50 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* final.c (shorten_branches, init_insn_lengths): Move code
	to free label_align, uid_shuid, insn_lengths, insn_addresses
	and uid_align from the former function into the latter one;
	Add code to clear these variables.
	* sh.h (label_align): Remove declaration.

Mon Apr 20 14:48:29 1998  Michael Meissner  <meissner@cygnus.com>

	* gcc.c (lang_specific_driver): Declare prototype properly so
	fatal can be passed to it without error.

	* configure.in (AC_CHECK_FUNCS): Check for strchr and strrchr.
	* configure: Regenerate.
	* config.in: Add #undef's for strchr and strrchr.

	* protoize.c (toplevel): If we have rindex, but not strrchr, map
	rindex to strrchr.
	(file_could_be_converted): Use strrchr, not rindex since rindex is
	not defined on Linux systems when _POSIX_SOURCE is defined.
	(file_normally_convertible): Ditto.
	(process_aux_info_file): Ditto.
	(main): Ditto.

	* rs6000.md (mov{sf,df} define_splits): When splitting a move of
	a constant to an integer register, don't split the insns that do
	the simple AND and OR operations, rather just split each word, and
	let the normal movsi define split handle it further.

Mon Apr 20 18:19:40 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sh.c (find_barrier): Fix bug in ADDR_DIFF_VEC handling.
	(split_branches): Call init_insn_lengths.

Mon Apr 20 07:37:49 1998  Michael Meissner  <meissner@cygnus.com>

	* i386.c: Include expr.h to get the change_address prototype
	declared.

Mon Apr 20 01:00:05 1998  H.J. Lu  (hjl@gnu.org)

	* reg-stack.c (subst_asm_stack_regs): Change to return the last
	new insn generated by this function.
	(subst_stack_regs): Likewise.
	(convert_regs): Record the last newly generated insn and use
	it for change_stack () instead of INSN.

Sun Apr 19 15:41:24 1998  Manfred Hollstein  <manfred@s-direktnet.de>

	* fix-header.c (enum special_file): Undefine enumerators if they
	are already defined by include files.
	* fixproto (rel_source_file in unistd.h stdlib.h): Prefix file protection
	macro with '__' to not pollute user namespace.

Sun Apr 19 02:42:06 1998  Richard Henderson  <rth@cygnus.com>

	* haifa-sched.c (queue_to_ready): Fix typo in prototype.

Sat Apr 18 23:52:35 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Sat Apr 18 18:30:22 1998  Jim Wilson  <wilson@cygnus.com>

	* i386.md (fix_truncsfdi2+[123]): Add + to operand 1 constraints.

	* i386.h (CPP_CPU_DEFAULT): Renamed to CPP_CPU_DEFAULT_SPEC.
	Add missing -Dpentium* options.
	(CPP_CPU_SPEC): Delete redundant definition.  Include cpp_cpu_default
	instead of CPP_CPU_DEFAULT.
	(EXTRA_SPECS): Add entry for cpp_cpu_default.

Sat Apr 18 19:06:59 1998  David Edelsohn  <edelsohn@mhpcc.edu>

	* rs6000.md (floatsidf2_loadaddr): rs6000_fpmem_offset will be
	negative in a stackless frame.
	* rs6000.c (rs6000_stack_info): Don't include fixed-size link area
	in stackless frame size.  Support 64-bit stackless frame size.
	Combine fpmem offset calculations and don't add total_size to
	offset if not pushing a stack frame.

Sat Apr 18 15:41:16 1998  Jim Wilson  <wilson@cygnus.com>

	* regmove.c (fixup_match_1): In three places, in flag_exceptions
	check, change p to q.

Sat Apr 18 15:30:49 1998  Jim Wilson  <wilson@cygnus.com>

	* gcc.c (lang_specific_driver): Add new parm type to prototype.
	(added_libraries): New file scope static variable.
	(process_command): Initialize added_libraries.  Pass it to
	lang_specific_driver.
	(main): Use added_libraries in check for no input files.

Sat Apr 18 01:23:11 1998  John Carr  <jfc@mit.edu>

	* sparc.c, sparc.h, sparc.md, sol2.h: Many changes related to V9
	code generation.  Use 64 bit instructions in 32 bit mode when
	possible.  Use V9 return instruction.  UltraSPARC optimizations.

        * sparc.h: Change gen_rtx (CODE to gen_rtx_CODE (.

Fri Apr 17 22:38:17 1998  Jeffrey A Law  (law@cygnus.com)

	* global.c (global_alloc): Don't pass HARD_CONST (0) to find_reg,
	just pass zero.  That will work regardless of the size of HARD_REG_SET.

	* libgcc2.c (__floatdisf): Fix a couple typos.

Fri Apr 17 17:28:26 1998  Jim Wilson  <wilson@cygnus.com>

	* Makefile.in (mostlyclean): Delete *.mach and *.bp files.

Fri Apr 17 16:35:35 1998  Greg McGary  <gkm@gnu.org>

	* emit-rtl.c (gen_highpart): initialize `word' properly for pseudo.

Fri Apr 17 14:30:37 1998  John Carr <jfc@mit.edu>

	* emit-rtl.c (operand_subword_force): If a register can not be
	accessed by words, copy it to a pseudo register.

Fri Apr 17 14:30:37 1998  Jim Wilson  <wilson@cygnus.com>

	* rs6000/vxppc.h (CPP_SPEC): Add support for mrelocatable*.

Fri Apr 17 17:01:25 1998  Michael Meissner  <meissner@cygnus.com>

	* tree.h (mark_seen_cases): Delete declaration.

Fri Apr 17 13:32:20 1998  Jeffrey A Law  (law@cygnus.com)

	* stmt.c (mark_seen_cases): Make static and add prototype.

Fri Apr 17 11:21:43 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

        * frame.c: Include stdlib.h and unistd.h to possibly get various
        function prototypes.  The fixproto script guarantees these header
        files exist on the target system.
        * libgcc2.c: Likewise.

        * gthr-single.h (__gthread_mutex_lock, __gthread_mutex_trylock,
        __gthread_mutex_unlock): Add __attribute__ ((__unused__)) to the
        function parameters.
        * libgcc2.c (__udiv_w_sdiv): Likewise.

Thu Apr 16 22:41:02 1998  Jeffrey A Law  (law@cygnus.com)

	* varasm.c (asm_output_bss): Add prototype.
	(asm_output_aligned_bss): Likewise.

	* unroll.c (verify_addresses): Add prototype.

	* toplev.c: Add many prototypes.  Too many to mention here.

	* stmt.c (check_seenlabel): Add prototype.

	* rtlanal.c (reg_set_p_1): Add prototype.
	(reg_set_last_1): Likewise.

	* reorg.c (find_dead_or_set_registers): Add prototype.

	* regmove (try_auto_increment): Add prototype.

	* reg-stack.c (pop_stack): Add prototype.

	* recog.c (validate_replace_rtx_1): Add prototype.
	(find_cosntant_term_loc): Likewise.

	* loop.c (regs_patch_p): Add prototype.
	(add_label_notes, count_nonfixed_reads): Likewise.
	(find_single_use_in_loop): Likewise.
	(express_from): Surround prototype with #ifdef.
	(giv_sort): Similarly.

	* jump.c (mark_modified_reg): Add prototype.

	* haifa-sched.c (is_prisky): Add prototype.
	(queue_to_ready): Likewise.

	* genextract.c (gen_insn): Add prototype.

	* genemit.c (max_operand_1): Add prototype.
	(max_operand_vec, print_code, gen_exp, gen_insn): Likewise.
	(gen_expand, gen_explit, output_add_clobbers): Likewise.
	(output_init_mov_optab): Likewise.

	* genattrtab.c (attr_hash_add_rtx): Add prototype.
	(attr_hash_add_string, write_length_unit_log): Likewise.

	* genattr.c (init_range): Add prototype.

	* combine.c (sets_function_arg_p): Add prototype.

	* expr.c (store_constructor_field): Add prototype.
	(get_memory_usage_from_modifier): Likewise

	* expmed.c (synth_mult): Add prototype.
	(choose_multiplier, invert_mod2n): Likewise.

	* except.c (push_eh_entry): Add prototype.
	(pop_eh_entry, enqueue_eh_entry, dequeu_eh_entry): Likewise.
	(call_get_eh_context, start_dynamic_cleanup): Likewise.
	(start_dynamic_handler, can_throw): Likewise.
	(output_exception_table_entry, scan_region): Likewise.
	(eh_regs, set_insn_eh_region): Likewise.

	* dwarfout.c (decl_class_context): Add prototype.
	(output_inheritance_die, type_ok_for_scope): Likewise.

	* c-lex.c (skip_white_space_on_line): Add prototype.

	* alias.c (record_set): Add prototype.
	(find_base_term, base_alias_check): Likewise.

	* function.c (assign_outer_stack_local): Make static and add prototype.

	* haifa-sched.c (build_control_flow): Accept raw data as inputs
	instead of computing it locally.  Callers changed.
	(find_rgns): Several new arguments.  Callers changed.
	Generally clean up and comment better.  Use dominators to
	identify reducible loops.  Convert some flag arrays to bitmaps.
	Convert most of the code to work on pred/succ lists instead of
	an edge table.  Add comments for future improvements.
	(schedule_insns): Allocate temporary tables for flow data, call
	routines to compute flow data and pass it along to children as
	arguments.
	(debug_control_flow): Delete.  Use dump_bb_data instead.

	* basic-block.h (compute_dominators): Declare.

	* flow.c (dump_sbitmap, dump_sbitmap_vector): New debugging
	functions.
	* basic-block.h: Declare them.

Thu Apr 16 13:45:51 1998  Jim Wilson  <wilson@cygnus.com>

	* reg-stack.c (constrain_asm_operands): Set n_alternatives to zero if
	no operands.

Wed Apr 15 11:33:09 1998  Alexandre Petit-Bianco  <apbianco@sendai.cygnus.com>

        * tree.c (build_expr_wfl): Use NULL_TREE if the file name is NULL.
        Propagate TREE_SIDE_EFFECTS and TREE_TYPE iff the encapsulated
        node is non NULL. Cache last file name and file name identifier node.

1998-04-15  Mark Mitchell  <mmitchell@usa.net>

	* c-common.c (declare_hidden_char_array): Use TYPE_DOMAIN to get
	the length of an array, not TREE_TYPE.

Wed Apr 15 15:31:34 1998  Jeffrey A Law  (law@cygnus.com)

	* flow.c (sbitmap_union_of_successors):  New function.
	* basic-block.h (sbitmap_union_of_successors): Declare it.

Wed Apr 15 12:38:03 1998  Jim Wilson  <wilson@cygnus.com>

	* configure.in (gnu_ld): Rename to gnu_ld_flag before main loop.
	Set gnu_ld to gnu_ld_flag inside main loop.
	(gas): Likewise.

Wed Apr 15 14:50:05 1998  Dave Brolley  <brolley@cygnus.com>

	* toplev.c (compile_file): Call init_parse using new interface.
	(init_lex): Remove declaration.

	* c-lex.c (init_parse): Now returns char* containing filename.

Wed Apr 15 12:37:10 1998  Jeffrey A Law  (law@cygnus.com)

	* pa.h (LEGITIMIZE_RELOAD_ADDRESS): Do nothing if not optimizing.

Wed Apr 15 12:10:18 1998  Michael Meissner  <meissner@cygnus.com>

	* Makefile.in (gen{config,flags,codes,emit}): Link in host print-rtl.o.
	(gen{extract,peep,opinit,output}): Ditto.

	* gen{attr,codes,config,emit,output}.c (insn_attr_name): Provide a
	global definition so print-rtl.o can be linked in.
	* gen{peep,recog}.c (insn_attr_name): Ditto.

Tue Apr 14 07:30:57 1998  K. Richard Pixley  <rich@kyoto.noir.com>

	* fixincludes: discard empty C++ comments, as found in sys/time.h
	on hpux-11.0.

Wed Apr 15 10:47:21 1998  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* config/m68k/m68k.md (adddi3, subdi3): Optimize for constant
	operand.

Wed Apr 15 01:21:21 1998  Jeffrey A Law  (law@cygnus.com)

	* emit-rtl.c (operand_subword): Rework slightly to avoid
	bogus warning from previous change.

Tue Apr 14 23:39:13 1998  Richard Henderson  <rth@cygnus.com>

	* alpha.md: Revert Oct 27 change, as it is superceeded by Kenner's
	Nov 8 find_replacement change.  Move decls of get_unaligned_address
	* alpha.h: ... here.

Tue Apr 14 22:00:39 1998  John Carr <jfc@mit.edu>

	* function.c (assign_parms): Initialize unsignedp before passing
	its pointer to promote_mode.

	* genattrtab.c (check_attr_test): Handle MATCH_INSN like MATCH_OPERAND.
	(write_test_expr): Allow MATCH_INSN.

Tue Apr 14 21:57:57 1998  Paul Eggert <eggert@twinsun.com>

	* install.texi: Update section on warnings that can be safely ignored.

Tue Apr 14 14:55:16 1998  Jim Wilson  <wilson@cygnus.com>

	* mips.md (reload_outdi): Change the scratch mode from DImode to
	TImode.  New variable scratch, used instead of operand[2] in template.
	Add code for MIPS16 HILO_REGNUM case where output reg is not M16_REG_P.

Tue Apr 14 16:19:03 1998  Michael Meissner  <meissner@cygnus.com>

	* expr.c (MOVE_RATIO): Set to 3 if optimizing for space.

Tue Apr 14 11:31:28 1998  Krister Walfridsson <cato@df.lth.se>

	* i386/bsd386.h (ASM_OUTPUT_ALIGN): Redefine.

Tue Apr 14 09:02:32 1998  Jeffrey A Law  (law@cygnus.com)

	* svr4.h (ASM_DECLARE_OBJECT_NAME): Use HOST_WIDE_INT_PRINT_DEC.
	(ASM_FINISH_DECLARE_OBJECT): Likewise.

	* Idea and part of the patch from HJ.
        * Makefile.in: auto-host.h renamed from auto-config.h.  All references
        changed.
        (distclean): Remove auto-build.h too.
        * configure.in: Rename host autoconf generated file to auto-host.h.
        If host != build, then run autoconf to generate auto-build.h for
        the build machine and include it in build_xm_files.
        Check for wait.h and sys/wait.h.

	* combine.c (simplify_rtx, case TRUNCATE): Respect value of
	TRULY_NOOP_TRUNCATION.

Mon Apr 13 11:31:49 1998  Jason Merrill  <jason@yorick.cygnus.com>

	* tree.h (BINFO_OFFSET_ZEROP): Use integer_zerop.

Sun Apr 12 20:55:32 1998  Catherine Moore <clm@cygnus.com>

	* invoke.texi (ld options)  Include memset requirements
	for options -nodstdlib and -nodefaultlibs.

1998-04-12  Paul Eggert  <eggert@twinsun.com>

	This change is from an idea suggested by Arthur David Olson.

	* c-common.c (decl_attributes, record_function_format,
	check_format_info, init_function_format_info):
	Add support for strftime format checking.
	(enum format_type): New type.
	(record_function_format): Now static, and takes value of type
	enum format_type instead of int.
	(time_char_table): New constant.
	(struct function_format_info): format_type member renamed from is_scan.
	(check_format_info): Use `warning' rather than sprintf followed by
	`warning', to avoid mishandling `%' in warnings.
	Change `pedwarn' to `warning', since these warnings do not necessarily
	mean the program does not conform to the C Standard, as the code
	need not be executed.

	* c-tree.h (record_function_format): Remove decl; no longer extern.

	* extend.texi: Add documentation for strftime format checking.

Sun Apr 12 20:23:03 1998  Jeffrey A Law  (law@cygnus.com)

	* mips/ecoffl.h: Do not include mips.h.
	* mips/elf.h: Likewise.

	* configure.in (mips-*-ecoff): Do not mention mips/mips.h in tm_files.
	* mips/ecoff.h: Include "mips/mips.h".

Sat Apr 11 22:42:54 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Sat Apr 11 01:24:28 1998  Jeffrey A Law  (law@cygnus.com)

	* cse.c (count_reg_usage): Correctly handle REG_NONNEG notes.
	(delete_trivially_dead_insns): Renamed from delete_dead_from_cse.
	* toplev.c (rest_of_compilation): Call delete_trivially_dead_insns		instead of delete_dead_from_cse.  Also call delete_trivially_dead_insns
	between loop optimization passes.
	* rtl.h: Updated appropriately.

Fri Apr 10 22:28:32 1998  Jeffrey A Law  (law@cygnus.com)

	Reinstall this patch from Jason.
	* function.c (push_function_context_to): Don't call init_emit.

Fri Apr 10 13:40:20 1998  Nick Clifton  <nickc@cygnus.com>

	* rtl.c (read_skip_spaces): Prevent infinite loops upon
	encountering unterminated comments.

Fri Apr 10 10:43:41 1998  Jeffrey A Law  (law@cygnus.com)

	* emit-rtl.c (operand_subword): Properly handle CONST_INTs for
	64x32 cross builds.

	* configure.in: Handle --with-fast-fixincludes.
	(fixincludes): If --with-fast-fixincludes, then use a different
	fixincludes program by default.
	* Makefile.in (fixinc.sh): New rule.

Fri Apr 10 00:36:31 1998  H.J. Lu  (hjl@gnu.org)

	* i386.md (movqi+1): Handle invalid QI register.
	(movsf_push-1): Likewise.

Thu Apr  9 16:53:59 1998  Nick Clifton  <nickc@cygnus.com>

	* config/m32r/m32r.c: call_address_operand(): Only accept symbolic
	addresses.
	symbolic_memort_operand(), call32_operand(), int8_operand(),
	int16_operand(), uint24_operand(), reg_or_int8_operand(): Removed.
	Not used.
	uint16_operand(): Made static.

Thu Apr  9 01:43:04 1998  Jeffrey A Law  (law@cygnus.com)

	* calls.c (expand_call): Fix typo.

Thu Apr  9 00:18:44 1998  Dave Brolley  (brolley@cygnus.com)

	* c-lex.c (finput): New global.
	(init_parse): Always included.  Handle !USE_CPPLIB using
	code originally in compile_file.
	(finish_parse): Update for CPPLIB.
	* toplev.c (init_parse, finish_parse): Declare.
	(finput): Delete variable.  Now in front-ends.
	(compile_file): Remove code which is now handled by init_parse
	which is unconditionally called.  Similarly for finish_parse.

Wed Apr  8 23:13:50 1998  Gavin Koch  <gavin@cygnus.com>

	* config/mips/r3900.h (ASM_OUTPUT_DEF,SUPPORTS_WEAK,
	ASM_WEAKEN_LABEL): Add.

Wed Apr  8 18:21:30 1998  Richard Henderson  <rth@cygnus.com>

	* alpha/crtbegin.asm, alpha/crtend.asm, alpha/t-crtb: New files.
	* configure.in (alpha-*-linux*): Use them.

Fri Apr  3 17:02:13 1998  Alexandre Petit-Bianco  <apbianco@cygnus.com>

 	* tree.def (EXPR_WITH_FILE_LOCATION): New tree node definition.
 	* tree.h (EXPR_WFL_{NODE,FILENAME,FILENAME_NODE,LINENO,
 	COLNO,LINECOL,SET_LINECOL,EMIT_LINE_NOTE}): New macros.
 	(build_expr_wfl): New prototype declaration.
 	* tree.c (build_expr_wfl): New function, to build
  	EXPR_WITH_FILE_LOCATION nodes.
 	(copy_node): Don't zero TREE_CHAIN if copying a
  	EXPR_WITH_FILE_LOCATION node.
 	* print-tree.c (print_node): Handle EXPR_WITH_FILE_LOCATION.
 	* expr.c (expand_expr): Handle EXPR_WITH_FILE_LOCATION.

Wed Apr  8 12:51:19 1998  Jeffrey A Law  (law@cygnus.com)

	* configure.in (v850): Use t-v850.
	(ix86-wrs-vxworks): Recognize 786 just like other x86 configurations.

	* protoize.c (creat, read, write): Do not declare.

	* jump.c (mark_jump_label): Record REG_LABEL notes for insns which
	refer to the CODE_LABEL before a dispatch table.

	* invoke.texi: Add ARC options.

	* gcc.c (proces_command): Improve error message for -o with
	either -c or -S.

	* i386/x-cygwin32 (CLIB): Link in advapi32.

	* alpha.h (ASM_IDENTIFY_GCC): Define to nothing.
	(ASM_IDENTIFY_LANGUAGE): Likewise.

	* i386.md (movqi recognizer): Don't perfom byte increment into
	a NON_QI_REG_P.

	* configure.in (x86-dg-dgux): Run fixinc.dgux.

	* i370.h: Fix typo in GEN_INT changes.

	* bitmap.c (bitmap_element_allocate): Use "void" for arglist instead
	of an empty arglist in prototype.

	* Makefile.in: Remove bytecode crud that crept back in after the
	gcc2 merge.

1998-04-08  Brendan Kehoe  <brendan@cygnus.com>

	* c-lex.h (is_class_name): Fix arg type to be tree, not void.
	(make_pointer_declarator, reinit_parse_for_function): Fix typo.

Wed Apr  8 06:16:45 1998  Richard Earnshaw (rearnsha@arm.com)

	* arm.h (LEGITIMIZE_RELOAD_ADDRESS): Define.

Wed Apr  8 00:44:18 1998  Bernd Schmidt (crux@pool.informatik.rwth-aachen.de>

	* c-lex.c (is_class_name): Delete declaration.
	(whitespace_cr): Make static and add prototype.
	* c-lex.h (make_pointer_declarator, reinit_parse_for_function,
	yylex, get_directive_line): Turn declarations into prototypes.
	(position_after_whitespace, check_newline, yyerror,, is_class_name,
	forget_protocol_qualifiers, remember_protocol_qualifiers): Add
	prototypes.
	* genattr.c (extend_range, write_upcase, gen_attr, write_units): Add
	prototypes.
	* gencodes.c (gen_insn): Add prototype.
	* genconfig.c (walk_insn, gen_insn, gen_expand, gen_split,
	gen_peephole): Add prototypes.
	* genflags.c (num_operands, gen_proto, gen_nonproto, gen_insn): Add
	prototypes.
	* gengenrtl.c (type_from_format, accessor_from_format, special_rtx,
	special_format, find_formats, gendecl, genmacro, gendef, genlegend,
	genheader, gencode): Add prototypes.
	* genopinit.c (gen_insn): Add prototype.
	* genoutput.c (output_prologue, output_epilogue, scan_operands,
	process_template, validate_insn_alternatives, gen_insn, gen_peephole,
	gen_expand, gen_split, n_occurrences): Add prototypes.
	* genpeep.c (gen_peephole): Add prototype.
	* loop.c (find_and_verify_loops, mark_loop_jump, prescan_loop,
	reg_in_basic_block_p, consec_sets_invariant_p, libcall_other_reg,
	labels_in_range_p, count_loop_regs_set, note_addr_stored,
	loop_reg_used_before_p, scan_loop, replace_call_address,
	skip_consec_insns, libcall_benefit, ignore_some_movables,
	force_movables, combine_movables, rtx_equal_for_loop_p, move_movables,
	strength_reduce, valid_initial_value_p, find_mem_givs, record_biv,
	check_final_value, record_giv, update_giv_derive, basic_induction_var,
	simplify_giv_expr, general_induction_var, consec_sets_giv,
	check_dbra_loop, express_from, combine_givs_p, combine_givs,
	product_cheap_p, maybe_eliminate_biv, maybe_eliminate_biv_1,
	last_use_this_basic_block, record_initial, update_reg_last_use,
	iteration_info, analyze_loop_iterations, insert_bct,
	instrument_loop_bct, indirect_jump_in_function_p): Turn declarations
	into prototypes.

Tue Apr  7 21:48:52 1998  Jeffrey A Law  (law@cygnus.com)

	* pa.h (LEGITIMIZE_RELOAD_ADDRESS): Define.

1998-04-07  Ken Raeburn  <raeburn@cygnus.com>

	* config/mips/mips.c (siginfo): Deleted.
	(override_options): Don't install SIGINFO signal handler.

Tue Apr  7 11:58:04 1998  Jim Wilson  <wilson@cygnus.com>

	* loop.c (check_dbra_loop): When normalize comparison_val, add check
	to verify it is non-negative.

Tue Apr  7 02:01:47 1998  Richard Henderson  <rth@cygnus.com>

	* alpha.c (alpha_expand_block_move): Correctly collect block offsets.
	(alpha_expand_block_clear): Likewise.

Mon Apr  6 23:36:01 1998  Richard Henderson  <rth@cygnus.com>

	* tree.h (sizetype_tab): Fix previous change for K&R.

Mon Apr 6 22:23:29 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Mon Apr  6 23:16:10 1998  Richard Earnshaw (rearnsha@arm.com)

	* configure.in (sparc-*-solaris2*): Add xm-siglist.h to xm_file.
	Add USG and POSIX to xm_defines.

Mon Apr  6 21:49:57 1998  Bob Manson  <manson@charmed.cygnus.com>

	* gcc.c: Add linker spec.
	(link_command_spec): Use %(linker) instead of ld.
	(main): If collect2 is requested as the linker, see if it exists;
 	if not, use ld instead.

	* Makefile.in (USE_COLLECT2): It's named collect2 now, not ld.
	(ld:) Deleted.
	(install-collect2): Install as collect2, not ld.

	* configure.in(will_use_collect2): It's named collect2 now.

	* collect2: Remove checks to see if we were invoked recursively.
	(collect_execute): Use _spawnvp under cygwin32.

Mon Apr  6 17:23:41 1998  Jim Wilson  <wilson@cygnus.com>

	* haifa-sched.c (build_control_flow): Set unreachable for block whose
	only predecessor is itself.

Mon Apr  6 16:08:04 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

        * c-parse.in: Include system.h, and remove stuff now made redundant.
        * cccp.c: Likewise.
        * cexp.y: Likewise.
        * protoize.c: Likewise.  Properly check for cpp stringification.

        * Makefile.in (c-parse.o, cccp.o, cexp.o, protoize.o, unprotoize.o):
	Depend on system.h.

	* objc/Make-lang.in (objc-parse.o): Likewise.

Mon Apr  6 14:59:58 1998  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

        * gansidecl.h: Check if compiler supports __attribute__.  Provide
        definitions for ATTRIBUTE_UNUSED and ATTRIBUTE_PRINTF using
        __attribute__ when its available.  Also provide definitions for
        ATTRIBUTE_PRINTF_1, ATTRIBUTE_PRINTF_2 and ATTRIBUTE_PRINTF_3 in
        terms of ATTRIBUTE_PRINTF.

        * genoutput.c (process_template): Use ATTRIBUTE_UNUSED in place
	of __attribute__.

Mon Apr  6 07:17:52 1998  Catherine Moore  <clm@cygnus.com>

        * combine.c (can_combine_p):  Include successor in volatile test.

Mon Apr  6 14:16:33 1998  J"orn Rennecke <amylaar@cygnus.co.uk>

	* sh.h (CASE_VECTOR_SHORTEN_MODE): Fix logic when to set
	offset_unsigned.

Mon Apr  6 02:03:29 1998  Jeffrey A Law  (law@cygnus.com)

	* objc/objc-act.c (encode_aggregate_within): Avoid GNU extensions
	in prototype and definition.

Mon Apr 6 00:48:56 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Mon Apr  6 00:08:50 1998  Richard Henderson  <rth@cygnus.com>

	* alpha.c (alpha_expand_block_clear): Add missing offset arg to
	alpha_expand_unaligned_store_words.

Sun Apr  5 21:31:24 1998  John Wehle  (john@feith.com)

	* i386.md (movsf_push, movsf_mem): Remove.
	(movsf_push): Rename from movsf_push_nomove and move in front of
	movsf.  Use nonmemory_operand predicate and don't bother checking
	TARGET_MOVE.
	(movsf_push_memory): New pattern.
	(movsf): Don't bother checking for push_operand.  If TARGET_MOVE and
	both operands refer to memory then force operand[1] into a register.
	(movsf_normal): Change to unnamed pattern.
	Likewise for movdf, movxf, and friends.

Sun Apr 5 18:45:51 PDT 1998 Jeff Law  (law@cygnus.com)

	* version.c: Bump for snapshot.

Sun Apr  5 16:31:10 1998  Richard Henderson  <rth@cygnus.com>

